package fantastikk;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.Serializable;
import java.util.HashSet;
import java.util.Set;

import java.beans.XMLDecoder;
import java.beans.XMLEncoder;

import fantastikk.properties.JXPropertyDepository;


/**
 * AvP[V̐ݒێ邽߂̃NXłB
 * @author Takashi Nishikawa
 */
public class JXConfiguration implements Serializable {
	/** ftHgEVAEo[W ID */
	private static final long serialVersionUID = 1L;

	/** ϊ PDF t@CJǂ */
	private boolean openPdfFile;

	/** ϊ EPUB t@CJǂ */
	private boolean openEpubFile;

	/** kŎgpGR[fBO (EPUB Ŏgp) */
	private String encoding4epub;

	/** XSLT vZbT̎ */
	private String xSLTProcessor;

	/** XSL-FO vZbT̎ */
	private int formattingObjectsProcessorType;

	/** AH Formatter CXg[fBNg */
	private String xslFormatterDirectory;

	/** XML ւ̕ϊɎgp XSLT X^CV[g̃fBNg */
	private String styleSheetDirectory4xml;

	/** XSL-FO ւ̕ϊɎgp XSLT X^CV[g̃fBNg */
	private String styleSheetDirectory4xslFo;

	/** EPUB ւ̕ϊɎgp XSLT X^CV[g̃fBNg */
	private String styleSheetDirectory4epub;

	/** XML ւ̕ϊɎgp XSLT X^CV[g (xslFormatterDirectory4xml ̔zɂƂz) */
	private String styleSheetFile4xml;

	/** XSL-FO ւ̕ϊɎgp XSLT X^CV[g (xslFormatterDirectory4xslFo ̔zɂƂz) */
	private String styleSheetFile4xslFo;

	/** EPUB ւ̕ϊɎgp XSLT X^CV[g (xslFormatterDirectory4epub ̔zɂƂz) */
	private String styleSheetFile4epub;

	/** Velocity ev[g̃fBNg */
	private String velocityTemplateDirectory;

	/** vZbgt@C̃fBNg */
	private String presetDirectory;

	/**  */
	private String language;

	/** t@Cۑ (t@C`[UŎgp) */
	private String fileChooserSaveDirectory;

	/** t@Cǂݍݐ (t@C`[UŎgp) */
	private String fileChooserLoadDirectory;

	/** uXML ϊvj[LƂ邩 */
	private boolean xml2xmlAvairable;

	/** DTD t@C̃pX */
	private String dtdFilePath = "";
	
	/** DTD t@C̃pXLɂ邩 */
	private boolean dtdFilePathEnable;

	/** Xalan */
	public static final String XALAN = "org.apache.xalan.processor.TransformerFactoryImpl";

	/** Saxon 9.x */
	public static final String SAXON = "net.sf.saxon.TransformerFactoryImpl";

	/** Apache FOP */
	public static final int APACHE_FOP = 0;

	/** Antenna House AH Formatter */
	public static final int ANTENNA_HOUSE_XSL_FORMATTER = 1;

	/** Antenna House AH Formatter (java interface) */
	public static final int ANTENNA_HOUSE_XSL_FORMATTER_JAVA = 2;

	/** XML ւ̕ϊɎgp XSLT X^CV[g̃fBNg̏l */
	public static final String STYLESHEET_DIRECTORY_XML = "stylesheet" + File.separator + "xml";

	/** XSL-FO ւ̕ϊɎgp XSLT X^CV[g̃fBNg̏l */
	public static final String STYLESHEET_DIRECTORY_XSL_FO = "stylesheet" + File.separator + "fo";

	/** EPUB ւ̕ϊɎgp XSLT X^CV[g̃fBNg̏l */
	public static final String STYLESHEET_DIRECTORY_EPUB = "stylesheet" + File.separator + "epub";

	/** XML ւ̕ϊɎgp XSLT X^CV[g̃t@C̏l */
	public static final String STYLESHEET_FILE_XML = "jepax.xsl";

	/** XSL-FO ւ̕ϊɎgp XSLT X^CV[g̃t@C̏l */
	public static final String STYLESHEET_FILE_XSL_FO = "jepax.xsl";

	/** EPUB ւ̕ϊɎgp XSLT X^CV[g̃t@C̏l */
	public static final String STYLESHEET_FILE_EPUB = "jepax.xsl";

	/** Velocity ev[g̃fBNg̏l */
	public static final String DIRECTORY_VELOCITY_TEMPLATE = "template" + File.separator + "epub";

	/** vZbgt@C̃fBNg̏l */
	public static final String DIRECTORY_PRESET_FILES = "preset";

	/** ݒt@C (FOP, AvP[V) ̃fBNg̖O */
	public static final String DIRECTORY_CONF_FILES = "conf";

	/** ݒt@C (AvP[V) ̃t@C̖O */
	public static final String CONFIGURATION_FILE = "configuration.xml";

	/** ݒt@C (AvP[V) ̃pX */
	public static final String CONFIGURATION_FILE_PATH;

	/** ݒt@C (FOP) ̃t@C̖O */
	public static final String FOP_XCONF_FILE = "fop.xconf";

	/** ݒt@C (FOP) ̃pX */
	public static final String FOP_XCONF_PATH;

	/** ꎞt@CpfBNg̃pX */
	public static final String TMP_PATH;

	/** ꎞt@CpfBNg̃pX (XSLTX^CV[g) */
	public static final String TMP_XSLT_STYLESHEET_PATH;

	/** ꎞt@CpfBNg̃pX (o͌) */
	public static final String TMP_OUTPUT_PATH;

	/** o͂̎ނ\萔 (vZbgt@C output vf format Ŏgpl) */
	public static final String OUTPUT_FORMAT_XML = "xml";
	public static final String OUTPUT_FORMAT_XSL_FO = "xsl-fo";
	public static final String OUTPUT_FORMAT_EPUB = "epub";

	/**  (gp\Ȃ) */
	public static final String LANGUAGE_EN = "en";
	public static final String LANGUAGE_JA = "ja";

	/**
	 * static q
	 */
	static {
		CONFIGURATION_FILE_PATH = System.getProperty("user.dir") + File.separator
								+ DIRECTORY_CONF_FILES + File.separator
								+ CONFIGURATION_FILE;

		FOP_XCONF_PATH = System.getProperty("user.dir") + File.separator
								+ DIRECTORY_CONF_FILES + File.separator
								+ FOP_XCONF_FILE;

		TMP_PATH = System.getProperty("user.dir") + File.separator + "tmp";
		TMP_XSLT_STYLESHEET_PATH = TMP_PATH + File.separator + "stylesheet";
		TMP_OUTPUT_PATH = TMP_PATH + File.separator + "output";
	}

	/**
	 * RXgN^ (public łȂ XMLEncoder#writeObject() s)
	 */
	public JXConfiguration() {
		super();
		resetConfiguration();
	}

	/**
	 * ݒmF܂B
	 * @return ݒ̃`FbNŖ肪Ɣ肵ڂ̖O
	 */
	public Set check() {
		JXPropertyDepository propertyDepository = JXPropertyDepository.getInstance();
		HashSet result = new HashSet();

		if (formattingObjectsProcessorType != APACHE_FOP && !(new File(xslFormatterDirectory).exists())) {
			result.add(propertyDepository.getString(JXPropertyDepository.PROPERTIES_LABEL, "ah_formatter_dir"));
		}

		if (!(new File(styleSheetDirectory4xslFo).exists())) {
			result.add(propertyDepository.getString(JXPropertyDepository.PROPERTIES_LABEL, "fo_stylesheet_dir"));
		}

		if (!(new File(styleSheetFile4xslFo).exists())) {
			result.add(propertyDepository.getString(JXPropertyDepository.PROPERTIES_LABEL, "fo_stylesheet_file"));
		}

		if (!(new File(styleSheetDirectory4epub).exists())) {
			result.add(propertyDepository.getString(JXPropertyDepository.PROPERTIES_LABEL, "epub_stylesheet_dir"));
		}

		if (!(new File(styleSheetFile4epub).exists())) {
			result.add(propertyDepository.getString(JXPropertyDepository.PROPERTIES_LABEL, "epub_stylesheet_file"));
		}

		if (!(new File(velocityTemplateDirectory).exists())) {
			result.add(propertyDepository.getString(JXPropertyDepository.PROPERTIES_LABEL, "velocity_template_dir"));
		}

		if (xml2xmlAvairable && !(new File(styleSheetDirectory4xml).exists())) {
			result.add(propertyDepository.getString(JXPropertyDepository.PROPERTIES_LABEL, "xml_stylesheet_dir"));
		}

		if (xml2xmlAvairable && !(new File(styleSheetFile4xml).exists())) {
			result.add(propertyDepository.getString(JXPropertyDepository.PROPERTIES_LABEL, "xm_stylesheet_file"));
		}

		if (dtdFilePathEnable && !(new File(dtdFilePath).exists())) {
			result.add(propertyDepository.getString(JXPropertyDepository.PROPERTIES_LABEL, "dtd_file"));
		}

		if (!(new File(presetDirectory).exists())) {
			result.add(propertyDepository.getString(JXPropertyDepository.PROPERTIES_LABEL, "preset_dir"));
		}

		return result;
	}

	/**
	 * JXEConfiguration IuWFNgԂ܂B
	 * @return JXEConfiguration IuWFNg (s null ̉\)
	 */
	public static JXConfiguration getInstance() {
		JXConfiguration configuration = null;
		XMLDecoder decoder = null;

		/* ݒt@C擾 */
		try {
			decoder = new XMLDecoder(new BufferedInputStream(
					new FileInputStream(CONFIGURATION_FILE_PATH)));
			configuration = (JXConfiguration) decoder.readObject();
		} catch (Exception e) {
		} finally {
			if (configuration == null) {
				configuration = new JXConfiguration();
				configuration.saveConfiguration();

//				/* N (ݒt@C) ɐݒEBhEJ */
//				JXConfigurationFrame.getInstance().setVisible(true);
			}

			if (decoder != null) {
				decoder.close();
			}
		}

		return configuration;
	}

	/**
	 * ݒZbg܂B
	 */
	public void resetConfiguration() {
		xSLTProcessor = SAXON;

		String osName = System.getProperty("os.name");

		if (osName.indexOf("Windows") >= 0 || osName.indexOf("Mac") >= 0) {
			openPdfFile = true;
			encoding4epub = "MS932";
		} else {
			openPdfFile = false;
			String encoding = System.getProperty("file.encoding");
			if ("Shift-JIS".equals(encoding) || "Shift_JIS".equals(encoding) ||"SJIS".equals(encoding) || "ISO-2022-JP".equals(encoding)) {
				encoding4epub = "MS932";
			} else {
				encoding4epub = encoding;
			}
		}

		openEpubFile = false;
		styleSheetDirectory4xml = System.getProperty("user.dir") + File.separator + STYLESHEET_DIRECTORY_XML;
		styleSheetDirectory4xslFo = System.getProperty("user.dir") + File.separator + STYLESHEET_DIRECTORY_XSL_FO;
		styleSheetDirectory4epub = System.getProperty("user.dir") + File.separator + STYLESHEET_DIRECTORY_EPUB;
		velocityTemplateDirectory = System.getProperty("user.dir") + File.separator + DIRECTORY_VELOCITY_TEMPLATE;
		presetDirectory = System.getProperty("user.dir") + File.separator + DIRECTORY_PRESET_FILES;
		styleSheetFile4xml = System.getProperty("user.dir") + File.separator + STYLESHEET_DIRECTORY_XML + File.separator + STYLESHEET_FILE_XML;
		styleSheetFile4xslFo = System.getProperty("user.dir") + File.separator + STYLESHEET_DIRECTORY_XSL_FO + File.separator + STYLESHEET_FILE_XSL_FO;
		styleSheetFile4epub = System.getProperty("user.dir") + File.separator + STYLESHEET_DIRECTORY_EPUB + File.separator + STYLESHEET_FILE_EPUB;
		dtdFilePath = System.getProperty("user.dir") + File.separator + "schema" + File.separator + "dtd" + File.separator + "jepax09.dtd";
		dtdFilePathEnable = true;

		fileChooserSaveDirectory = System.getProperty("user.dir");
		fileChooserLoadDirectory = System.getProperty("user.dir");

		formattingObjectsProcessorType = APACHE_FOP;
		xslFormatterDirectory = System.getProperty("user.dir");
		xml2xmlAvairable = false;

		// TO DO ۉΉɏC鎖
		// Locale locale = Locale.getDefault(); // ftHgP[̎擾
		language = LANGUAGE_JA;
	}

	/**
	 * ݒo܂B
	 */
	public void saveConfiguration() {
		/*  conf fBNgƕۑłȂ̂ŁA쐻 */
		File destination = new File(System.getProperty("user.dir") + File.separator + DIRECTORY_CONF_FILES);

		if (!destination.exists()) {
			destination.mkdir();
		}

		/* ݒt@C擾 */
		XMLEncoder encoder = null;

		try {
			encoder = new XMLEncoder(new BufferedOutputStream(new FileOutputStream(CONFIGURATION_FILE_PATH)));
			encoder.writeObject(this);
		} catch (Exception e) {
		} finally {
			if (encoder != null) {
				encoder.close();
			}
		}
	}

	/**
	 * ϊ PDF t@CJۂԂ܂B
	 * @return ϊ PDF t@CJۂ
	 */
	public boolean isOpenPdfFile() {
		return openPdfFile;
	}

	/**
	 * ϊ PDF t@CJۂݒ肵܂B
	 * @param openPdfFile ϊ PDF t@CJۂ
	 */
	public void setOpenPdfFile(boolean openPdfFile) {
		this.openPdfFile = openPdfFile;
	}

	/**
	 * ϊ EPUB t@CJۂԂ܂B
	 * @return ϊ EPUB t@CJۂ
	 */
	public boolean isOpenEpubFile() {
		return openEpubFile;
	}

	/**
	 * ϊ EPUB t@CJۂݒ肵܂B
	 * @param openEpubFile ϊ EPUB t@CJۂ
	 */
	public void setOpenEpubFile(boolean openEpubFile) {
		this.openEpubFile = openEpubFile;
	}

	/**
	 * kŎgpGR[fBO (EPUB Ŏgp) Ԃ܂B
	 * @return kŎgpGR[fBO (EPUB Ŏgp) 
	 */
	public String getEncoding4epub() {
		return encoding4epub;
	}

	/**
	 * kŎgpGR[fBO (EPUB Ŏgp) ݒ肵܂B
	 * @param encoding4epub kŎgpGR[fBO (EPUB Ŏgp) 
	 */
	public void setEncoding4epub(String encoding4epub) {
		this.encoding4epub = encoding4epub;
	}

	/**
	 * XSLT vZbT̎ނԂ܂B
	 * @return XSLT vZbT̎
	 */
	public String getXSLTProcessor() {
		return xSLTProcessor;
	}

	/**
	 * XSLT vZbT̎ނݒ肵܂B
	 * @param xSLTProcessor XSLT vZbT̎
	 */
	public void setXSLTProcessor(String xSLTProcessor) {
		this.xSLTProcessor = xSLTProcessor;
	}

	/**
	 * XSL-FO vZbT̎ނݒ肵܂B
	 * @param processorType XSL-FO vZbT̎
	 */
	public void setFormattingObjectsProcessorType(int processorType) {
		this.formattingObjectsProcessorType = processorType;
	}

	/**
	 * XSL-FO vZbT̎ނԂ܂B
	 * @return XSL-FO vZbT̎
	 */
	public int getFormattingObjectsProcessorType() {
		return this.formattingObjectsProcessorType;
	}

	/**
	 * AH Formatter CXg[fBNgԂ܂B
	 * @return AH Formatter CXg[fBNg
	 */
	public String getXslFormatterDirectory() {
		return xslFormatterDirectory;
	}

	/**
	 * AH Formatter CXg[fBNgݒ肵܂B
	 * @param presetDirectory AH Formatter CXg[fBNg
	 */
	public void setXslFormatterDirectory(String xslFormatterDirectory) {
		this.xslFormatterDirectory = xslFormatterDirectory;
	}

	/**
	 * XML ւ̕ϊɎgp XSLT X^CV[g̃fBNgԂ܂B
	 * @return XML ւ̕ϊɎgp XSLT X^CV[g̃fBNg
	 */
	public String getStyleSheetDirectory4xml() {
		return styleSheetDirectory4xml;
	}

	/**
	 * XML ւ̕ϊɎgp XSLT X^CV[g̃fBNgݒ肵܂B
	 * @param styleSheetDirectory4xml XML ւ̕ϊɎgp XSLT X^CV[g̃fBNg
	 */
	public void setStyleSheetDirectory4xml(String styleSheetDirectory4xml) {
		this.styleSheetDirectory4xml = styleSheetDirectory4xml;
	}

	/**
	 * XSL-FO ւ̕ϊɎgp XSLT X^CV[g̃fBNgԂ܂B
	 * @return XSL-FO ւ̕ϊɎgp XSLT X^CV[g̃fBNg
	 */
	public String getStyleSheetDirectory4xslFo() {
		return styleSheetDirectory4xslFo;
	}

	/**
	 * XSL-FO ւ̕ϊɎgp XSLT X^CV[g̃fBNgݒ肵܂B
	 * @param styleSheetDirectory4xslFo XSL-FO ւ̕ϊɎgp XSLT X^CV[g̃fBNg
	 */
	public void setStyleSheetDirectory4xslFo(String styleSheetDirectory4xslFo) {
		this.styleSheetDirectory4xslFo = styleSheetDirectory4xslFo;
	}

	/**
	 * EPUB ւ̕ϊɎgp XSLT X^CV[g̃fBNgԂ܂B
	 * @return EPUB ւ̕ϊɎgp XSLT X^CV[g̃fBNg
	 */
	public String getStyleSheetDirectory4epub() {
		return styleSheetDirectory4epub;
	}

	/**
	 * EPUB ւ̕ϊɎgp XSLT X^CV[g̃fBNgݒ肵܂B
	 * @param EPUB ւ̕ϊɎgp styleSheetDirectory4epub XSLT X^CV[g̃fBNg
	 */
	public void setStyleSheetDirectory4epub(String styleSheetDirectory4epub) {
		this.styleSheetDirectory4epub = styleSheetDirectory4epub;
	}

	/**
	 * XML ւ̕ϊɎgp XSLT X^CV[g Ԃ܂B
	 * @return XML ւ̕ϊɎgp XSLT X^CV[g
	 */
	public String getStyleSheetFile4xml() {
		return styleSheetFile4xml;
	}

	/**
	 * XML ւ̕ϊɎgp XSLT X^CV[g ݒ肵܂B
	 * @param styleSheetFile4xml XML ւ̕ϊɎgp XSLT X^CV[g
	 */
	public void setStyleSheetFile4xml(String styleSheetFile4xml) {
		this.styleSheetFile4xml = styleSheetFile4xml;
	}

	/**
	 * XSL-FO ւ̕ϊɎgp XSLT X^CV[g Ԃ܂B
	 * @return XSL-FO ւ̕ϊɎgp XSLT X^CV[g
	 */
	public String getStyleSheetFile4xslFo() {
		return styleSheetFile4xslFo;
	}

	/**
	 * XSL-FO ւ̕ϊɎgp XSLT X^CV[g ݒ肵܂B
	 * @param styleSheetFile4xslFo XSL-FO ւ̕ϊɎgp XSLT X^CV[g
	 */
	public void setStyleSheetFile4xslFo(String styleSheetFile4xslFo) {
		this.styleSheetFile4xslFo = styleSheetFile4xslFo;
	}

	/**
	 * EPUB ւ̕ϊɎgp XSLT X^CV[g Ԃ܂B
	 * @return EPUB ւ̕ϊɎgp XSLT X^CV[g
	 */
	public String getStyleSheetFile4epub() {
		return styleSheetFile4epub;
	}

	/**
	 * EPUB ւ̕ϊɎgp XSLT X^CV[g ݒ肵܂B
	 * @param styleSheetFile4epub EPUB ւ̕ϊɎgp XSLT X^CV[g
	 */
	public void setStyleSheetFile4epub(String styleSheetFile4epub) {
		this.styleSheetFile4epub = styleSheetFile4epub;
	}

	/**
	 * Velocity ev[g̃fBNgԂ܂B
	 * @return Velocity ev[g̃fBNg
	 */
	public String getVelocityTemplateDirectory() {
		return velocityTemplateDirectory;
	}

	/**
	 * Velocity ev[g̃fBNgݒ肵܂B
	 * @param velocityTemplateDirectory Velocity ev[g̃fBNg
	 */
	public void setVelocityTemplateDirectory(String velocityTemplateDirectory) {
		this.velocityTemplateDirectory = velocityTemplateDirectory;
	}

	/**
	 * vZbgt@C̃fBNgԂ܂B
	 * @return vZbgt@C̃fBNg
	 */
	public String getPresetDirectory() {
		return presetDirectory;
	}

	/**
	 * vZbgt@C̃fBNgݒ肵܂B
	 * @param presetDirectory vZbgt@C̃fBNg
	 */
	public void setPresetDirectory(String presetDirectory) {
		this.presetDirectory = presetDirectory;
	}

	/**
	 * Ԃ܂B
	 * @return 
	 */
	public String getLanguage() {
		return language;
	}

	/**
	 * ݒ肵܂B
	 * @param locale 
	 */
	public void setLanguage(String language) {
		this.language = language;
	}

	/**
	 * ۑfBNgԂ܂B
	 * @return ۑfBNg
	 */
	public String getFileChooserSaveDirectory() {
		return fileChooserSaveDirectory == null ? System.getProperty("user.dir") : fileChooserSaveDirectory;
	}

	/**
	 * ۑfBNgݒ肵܂B
	 * @param fileChooserSaveDirectory ۑfBNg
	 */
	public void setFileChooserSaveDirectory(String fileChooserSaveDirectory) {
		this.fileChooserSaveDirectory = fileChooserSaveDirectory;
	}

	/**
	 * ǂݍݐfBNgԂ܂B
	 * @return ǂݍݐfBNg
	 */
	public String getFileChooserLoadDirectory() {
		return fileChooserLoadDirectory == null ? System.getProperty("user.dir") : fileChooserLoadDirectory;
	}

	/**
	 * ǂݍݐfBNgݒ肵܂B
	 * @param fileChooserLoadDirectory ǂݍݐfBNg
	 */
	public void setFileChooserLoadDirectory(String fileChooserLoadDirectory) {
		this.fileChooserLoadDirectory = fileChooserLoadDirectory;
	}

	/**
	 * o̓tH[}bg̎ʂɈꎞt@CpfBNg̃X^CV[g Ԃ܂B
	 * @param outputFormat o̓tH[}bg̎ (OUTPUT_FORMAT_XML  OUTPUT_FORMAT_XSL_FO  OUTPUT_FORMAT_EPUB)
	 * @return ꎞt@CpfBNg̃X^CV[g
	 */
	public String getTemporaryStyleSheetFile(String outputFormat) {
		String styleSheetFile = null;
		String styleSheetDirectory = null;

		if (OUTPUT_FORMAT_XML.equals(outputFormat)) {
			styleSheetDirectory = this.styleSheetDirectory4xml;
			styleSheetFile = this.styleSheetFile4xml;
		} else if (OUTPUT_FORMAT_XSL_FO.equals(outputFormat)) {
			styleSheetDirectory = this.styleSheetDirectory4xslFo;
			styleSheetFile = this.styleSheetFile4xslFo;
		} else if (OUTPUT_FORMAT_EPUB.equals(outputFormat)) {
			styleSheetDirectory = this.styleSheetDirectory4epub;
			styleSheetFile = this.styleSheetFile4epub;
		}

		if (styleSheetFile != null && !styleSheetDirectory.equals(styleSheetFile) && styleSheetFile.startsWith(styleSheetDirectory)) {
			return TMP_XSLT_STYLESHEET_PATH + styleSheetFile.substring(styleSheetDirectory.length());
		} else {
			return null;
		}
	}

	/**
	 * uXML ϊvj[LƂ邩Ԃ܂B
	 * @return uXML ϊvj[LƂ邩 (trueFL)
	 */
	public boolean isXml2xmlAvairable() {
		return xml2xmlAvairable;
	}

	/**
	 * uXML ϊvj[LƂ邩ݒ肵܂B
	 * @param xml2xmlAvairable uXML ϊvj[LƂ邩 (trueFL)
	 */
	public void setXml2xmlAvairable(boolean xml2xmlAvairable) {
		this.xml2xmlAvairable = xml2xmlAvairable;
	}

	/**
	 * DTD t@C̃pXԂ܂B
	 * @return DTD t@C̃pX
	 */
	public String getDtdFilePath() {
		return dtdFilePath;
	}

	/**
	 * DTD t@C̃pXݒ肵܂B
	 * @param dtdFilePath DTD t@C̃pX
	 */
	public void setDtdFilePath(String dtdFilePath) {
		this.dtdFilePath = dtdFilePath;
	}

	/**
	 * DTD t@C̃pXLƂ邩ǂԂ܂B
	 * @return DTD t@C̃pXLƂ邩ǂ
	 */
	public boolean isDtdFilePathEnable() {
		return dtdFilePathEnable;
	}

	/**
	 * DTD t@C̃pXLƂ邩ǂݒ肵܂B
	 * @param dtdFilePathEnable DTD t@C̃pXLƂ邩ǂ
	 */
	public void setDtdFilePathEnable(boolean dtdFilePathEnable) {
		this.dtdFilePathEnable = dtdFilePathEnable;
	}
}
