package fantastikk;

import javax.xml.transform.ErrorListener;
import javax.xml.transform.TransformerException;

import fantastikk.properties.JXPropertyDepository;

/**
 * G[Xi (XSLT)
 * @author Takashi Nishikawa
 */
public class JXErrorListener implements ErrorListener {
	/** JXController IuWFNg */
	private JXController controller;

	/** Oo͂邩ǂ */
	private boolean verbose;

	/** ÕvtBbNX */
	private String errorLinePrefix;
	private String fatalErrorLinePrefix;
	private String warningLinePrefix;

	/**
	 * RXgN^
	 */
	public JXErrorListener() {
		verbose = true;
		JXPropertyDepository propertyDepository = JXPropertyDepository.getInstance();
		errorLinePrefix = propertyDepository.getString(JXPropertyDepository.PROPERTIES_LINE, "xlst_error_line_prefix");
		fatalErrorLinePrefix = propertyDepository.getString(JXPropertyDepository.PROPERTIES_LINE, "xlst_fatal_error_line_prefix");
		warningLinePrefix = propertyDepository.getString(JXPropertyDepository.PROPERTIES_LINE, "xlst_warning_line_prefix");
	}

	/**
	 * JXController IuWFNgZbg܂B
	 * @param controller JXController IuWFNg
	 */
	public void setController(JXController controller) {
		this.controller = controller;
	}

	/**
	 * 񕜉\ȃG[̒ʒm󂯎܂B
	 * @throws TransformerException
	 */
	public void error(TransformerException tfe) throws TransformerException {
		if (verbose) {
			controller.printMessage(errorLinePrefix + tfe.getMessageAndLocation(), false);
		}
	}

	/**
	 * 񕜂łȂG[̒ʒm󂯎܂B
	 * @throws TransformerException
	 */
	public void fatalError(TransformerException tfe) throws TransformerException {
		if (verbose) {
			controller.printMessage(fatalErrorLinePrefix + tfe.getMessageAndLocation(), false);
		}
	}

	/**
	 * x̒ʒm󂯎܂B
	 * @throws TransformerException
	 */
	public void warning(TransformerException tfe) throws TransformerException {
		if (verbose) {
			controller.printMessage(warningLinePrefix + tfe.getMessageAndLocation(), false);
		}
	}

	/**
	 * Oo͂邩ǂԂ܂B
	 * @return Oo͂邩ǂ
	 */
	public boolean isVerbose() {
		return verbose;
	}

	/**
	 * Oo͂邩ǂݒ肵܂B
	 * @param verbose Oo͂邩ǂ
	 */
	public void setVerbose(boolean verbose) {
		this.verbose = verbose;
	}
}

