package fantastikk;

import java.awt.Color;
import java.awt.Font;
import java.io.File;
import java.lang.reflect.Method;
import java.util.Iterator;

import javax.swing.JOptionPane;
import javax.swing.SwingUtilities;
import javax.swing.UIDefaults;
import javax.swing.UIManager;
import javax.swing.plaf.FontUIResource;

import fantastikk.gui.icon.JXIconDepository;
import fantastikk.proc.fo.fop.JXFOPLogger;
import fantastikk.properties.JXPropertyDepository;
import fantastikk.util.ClassPathUtility;
import fantastikk.util.FontUtility;


/**
 * Np̃NXłB
 * @author Takashi Nishikawa
 */
public class Main {
	/** JAR t@Ci[fBNg̖O */
	public static final String DIRECTORY_LIB = "lib";
	
	/** tHgTCY */
	public static final int DEFAULT_FONT_SIZE = 12;

	/**
	 * RXgN^
	 */
	private Main() {
	}

	/**
	 * C\bh
	 * @param args (gp܂)
	 */
	public static void main(String[] args) {
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				/* AvP[V̋N */
				start();
			}
		});
	}

	/**
	 * AvP[V̋N
	 */
	private static void start() {
		/* GUI ̌ڂ̐ݒ */
		try {
			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
		} catch (Exception e) {
		}

		String osName = System.getProperty("os.name");

		if (osName.indexOf("Mac") >= 0) {		// MacOS ̏ꍇ
			/* j[o[̈ʒu̐ݒ */
			System.setProperty("apple.laf.useScreenMenuBar", "true");

			/* ^u̐F () */
			UIManager.put( "TabbedPane.selected", new Color(255, 255, 255, 100));
		}

		/* tHgw (IPA UI SVbNCI΂g) */
		Font font = new Font("SansSerif", Font.PLAIN, DEFAULT_FONT_SIZE);
		
		if (osName.indexOf("Mac") < 0) {
			if (osName.indexOf("Windows") >= 0 && FontUtility.MEIRYO_AVAILABLE) {
				font = new Font(FontUtility.MEIRYO_FONT_NAME, Font.PLAIN, DEFAULT_FONT_SIZE);
			} else if (FontUtility.IPA_UI_GOTHIC_AVAILABLE) {
				font = new Font(FontUtility.IPA_UI_GOTHIC_FONT_NAME, Font.PLAIN, DEFAULT_FONT_SIZE);
			}
		}

		FontUIResource fontUIResource = new FontUIResource(font);
		UIDefaults defaultTable = UIManager.getLookAndFeelDefaults();

		for (Iterator iterator = defaultTable.keySet().iterator(); iterator.hasNext(); ) {
			Object obj = iterator.next();
			
			if (obj.toString().toLowerCase().endsWith("font")) {
				UIManager.put(obj, fontUIResource);
			}
		}

		/* NXpX̐ݒ */
		File libDirectory = new File(System.getProperty("user.dir") + File.separator + DIRECTORY_LIB);
		
		if (!libDirectory.exists() || !libDirectory.isDirectory()) {
			JOptionPane.showMessageDialog(null, JXPropertyDepository.getInstance().getString(JXPropertyDepository.PROPERTIES_LABEL, "lib_directory_not_found"),
				"", JOptionPane.WARNING_MESSAGE, JXIconDepository.getInstance().getIcon(JXIconDepository.FANTASTIKK_48PX, JXIconDepository.STATE_NONE));
			System.exit(1);
		} else {
			try {
				ClassPathUtility.addClassPath(libDirectory.listFiles());
			} catch (Exception e) {
				JOptionPane.showMessageDialog(
					null, JXPropertyDepository.getInstance().getString(JXPropertyDepository.PROPERTIES_LABEL, "startup_failed") + " " + e.toString(),
					"", JOptionPane.WARNING_MESSAGE, JXIconDepository.getInstance().getIcon(JXIconDepository.FANTASTIKK_48PX, JXIconDepository.STATE_NONE));
				e.printStackTrace();
				System.exit(1);
			}
		}

		/* O̐ݒ */
		System.setProperty("org.apache.commons.logging.Log", JXFOPLogger.class.getName());
		
		/* JAXP ֘A̐ݒ */
//		System.setProperty("javax.xml.parsers.DocumentBuilderFactory", "org.apache.crimson.jaxp.DocumentBuilderFactoryImpl");
		System.setProperty("javax.xml.parsers.DocumentBuilderFactory", "org.apache.xerces.jaxp.DocumentBuilderFactoryImpl");
//		System.setProperty("javax.xml.parsers.SAXParserFactory", "org.apache.crimson.jaxp.SAXParserFactoryImpl");
		System.setProperty("javax.xml.parsers.SAXParserFactory", "org.apache.xerces.jaxp.SAXParserFactoryImpl");
		System.setProperty("javax.xml.transform.TransformerFactory", "org.apache.xalan.processor.TransformerFactoryImpl");

		/* Jn */
		JXController controller = JXController.getInstance();

		if (osName.indexOf("Mac") >= 0) {		// MacOS ̏ꍇ
			/* Mac OS X ̏ꍇ̃j[̓C */
			try {
				Class clazz = Class.forName("fantastikk.JXMenuModifierForMacOSX");
				Method method = clazz.getMethod("setupMenu", new Class[] {});
				method.invoke(null, new Object[] {});
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

		/* EBhE쐻 */
		controller.createFrame();
		
		controller.showStatus();
		controller.checkConfiguration();
	}
}

