package fantastikk.gui;

import java.awt.Container;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Toolkit;
import java.io.IOException;
import java.net.URL;

import javax.swing.JEditorPane;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JScrollPane;

import fantastikk.gui.icon.JXIconDepository;
import fantastikk.util.FileUtility;


/**
 * \邽߂̃NXłB
 */
public class JXDescriptionFrame {
	/** GUI i */
	private Container container;
	private JFrame frame;
	private JEditorPane editorPane;
	private JScrollPane scrollPane;

	/**
	 * RXgN^
	 */
	public JXDescriptionFrame() {
		super();
	}

	/**
	 * GUI 쐬ĕ\܂B
	 * @param title ^Cg
	 * @param descriptionFileURL t@C (HTML)  URL
	 */
	public void createAndShowGUI(String title, URL descriptionFileURL) {
		JXIconDepository iconDepository = JXIconDepository.getInstance();

		/* `FbN */
		if (title == null || descriptionFileURL == null) {
			return;
		}

		frame = new JFrame(title);
		frame.setIconImage(iconDepository.getIcon(JXIconDepository.FANTASTIKK_16PX, JXIconDepository.STATE_NONE).getImage());

		/* RecyC̎擾 */
		container = frame.getContentPane();

		/* R|[lg̍쐻 */
		editorPane = new JEditorPane();
		editorPane.setContentType("text/html");
		editorPane.setEditable(false);

		scrollPane = new JScrollPane(editorPane, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		scrollPane.getVerticalScrollBar().setUnitIncrement(100);		// XN[x

		/* GridBagLayout ŕizu */
		GridBagLayout gb = new GridBagLayout();
		GridBagConstraints c = new GridBagConstraints();
		container.setLayout(gb);

		c.gridx = 0;
		c.gridy = 0;
		c.gridwidth  = 1;
		c.gridheight = 1;
		c.fill = GridBagConstraints.BOTH; 	// R|[lg\̈̍őTCYɂ
		c.weightx = 100.0;
		c.weighty = 100.0;
		c.anchor = GridBagConstraints.WEST;		// 
		gb.setConstraints(scrollPane, c);
		container.add(scrollPane);

		/* t@C̓e\ */
		try {
			editorPane.setPage(descriptionFileURL);
		} catch (IOException ioe) {
			JOptionPane.showMessageDialog(null, FileUtility.getName(descriptionFileURL.getPath()) + " ̕\s܂B",
					"", JOptionPane.WARNING_MESSAGE, JXIconDepository.getInstance().getIcon(JXIconDepository.FANTASTIKK_48PX, JXIconDepository.STATE_NONE));
			return;
		}

		/* eLXg}Lbg̈ʒuݒ (̂Ƃ擪ɃXN[) */
		editorPane.setCaretPosition(0);

		/* 1 sڂ\悤ɃXN[ (textArea#setCaretPosition(0) Ő擪ɃXN[ȂƂ邽) */
		scrollPane.getVerticalScrollBar().setValue(scrollPane.getVerticalScrollBar().getMinimum());

		/* ʒuݒ */
		Dimension dim = Toolkit.getDefaultToolkit().getScreenSize();
		frame.setLocation(dim.width / 2 - 300 , dim.height / 2 - 300);

		/* t[̐ݒ */
		frame.setSize(600, 600);
//		frame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);		// Ȃ悤ɂ
		frame.setVisible(true);
	}
}
