package fantastikk.gui;

import java.awt.BorderLayout;
import java.awt.CardLayout;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.Point;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.TreeMap;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTabbedPane;
import javax.swing.JTextArea;
import javax.swing.JToolBar;
import javax.swing.ListSelectionModel;
import javax.swing.WindowConstants;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.plaf.basic.BasicButtonUI;
import javax.swing.plaf.basic.BasicTabbedPaneUI;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import fantastikk.JXConfiguration;
import fantastikk.JXController;
import fantastikk.gui.icon.JXIconDepository;
import fantastikk.gui.panel.JXAbstractValuePanel;
import fantastikk.gui.panel.JXAppendableListValuePanel;
import fantastikk.gui.panel.JXBorderValuePanel;
import fantastikk.gui.panel.JXColorValuePanel;
import fantastikk.gui.panel.JXComplexValuePanel;
import fantastikk.gui.panel.JXDocumentCategoryPanel;
import fantastikk.gui.panel.JXFilePathValuePanel;
import fantastikk.gui.panel.JXListValuePanel;
import fantastikk.gui.panel.JXNumberValuePanel;
import fantastikk.gui.panel.JXPasswordValuePanel;
import fantastikk.gui.panel.JXSeparatorPanel;
import fantastikk.gui.panel.JXStringValuePanel;
import fantastikk.properties.JXPropertyDepository;
import fantastikk.util.PatternUtility;


/**
 * ʂ\܂B
 * @author Takashi Nishikawa
 */
public class JXFrame {
	/** JXFrame IuWFNg */
	private static JXFrame thisFrame;

	/** VKEBhËʒu (x) */
	public static int xPosition = 0;

	/** VKEBhËʒu (y) */
	public static int yPosition = 0;

	/** GUI i */
	private CardLayout cardLayout;
	private JList presetNameList;
	private JFrame frame;
	private JLabel presetListLabel;
	private JPanel presetPanel;
	private JToolBar toolBar;
	private JPanel presetContentPanel;
	private JPanel bottomPanel;
	private JScrollPane scrollPane_log;
	private JSplitPane splitPane_top;
	private JSplitPane splitPane;
	private JTextArea textArea_log;

	/** j[ڂێ */
	private Map menuItems;

	/** c[o[ڂێ */
	private Map toolBarItems;

	/** j[ڂ̎wɎgp镶 (萔) */
	public static final String CREATE_FRAME;
	public static final String LOAD_PRESET;
	public static final String SAVE_PRESET;
	public static final String SAVE_AS_PRESET;
	public static final String EXIT;
	public static final String SET_PARAM;
	public static final String XML2XML;
	public static final String XML2FO;
	public static final String XML2PDF;
	public static final String FO2PDF;
	public static final String FO2RTF;
	public static final String FO2AWT;
	public static final String XML2EPUB;
	public static final String CONFIG;
	public static final String CLEAR_LOG;
	public static final String VERSION;

	/** ݑIĂvZbgێ */
	private String currentPresetName;

	/** ݑIĂvZbg̃plێ */
	private JXDocumentCategoryPanel currentDocumentPanel;

	/** vZbg̃pl̐؂ւ邩ǂ */
	private boolean allowPresetChange = true;

	/** vZbgێ (key: vZbg̖O, value: t@C̃pX) */
	private Map presetNames;

	/** Xi */
	private ActionListener actionListener;
	private ListSelectionListener listSelectionListener;
	private JXFrameWindowAdapter windowAdapter;

	/**
	 * static q
	 */
	static {
		JXPropertyDepository propertyDepository = JXPropertyDepository.getInstance();
		CREATE_FRAME = propertyDepository.getString(JXPropertyDepository.PROPERTIES_MENU, "create_frame");
		LOAD_PRESET = propertyDepository.getString(JXPropertyDepository.PROPERTIES_MENU, "load_preset");
		SAVE_PRESET = propertyDepository.getString(JXPropertyDepository.PROPERTIES_MENU, "save_preset");
		SAVE_AS_PRESET = propertyDepository.getString(JXPropertyDepository.PROPERTIES_MENU, "save_as_preset");
		EXIT = propertyDepository.getString(JXPropertyDepository.PROPERTIES_MENU, "exit");
		SET_PARAM = propertyDepository.getString(JXPropertyDepository.PROPERTIES_MENU, "set_param");
		XML2XML = propertyDepository.getString(JXPropertyDepository.PROPERTIES_MENU, "xml2xml");
		XML2FO = propertyDepository.getString(JXPropertyDepository.PROPERTIES_MENU, "xml2fo");
		XML2PDF = propertyDepository.getString(JXPropertyDepository.PROPERTIES_MENU, "xml2pdf");
		FO2PDF = propertyDepository.getString(JXPropertyDepository.PROPERTIES_MENU, "fo2pdf");
		FO2RTF = propertyDepository.getString(JXPropertyDepository.PROPERTIES_MENU, "fo2rtf");
		FO2AWT = propertyDepository.getString(JXPropertyDepository.PROPERTIES_MENU, "fo2awt");
		XML2EPUB = propertyDepository.getString(JXPropertyDepository.PROPERTIES_MENU, "xml2epub");
		CONFIG = propertyDepository.getString(JXPropertyDepository.PROPERTIES_MENU, "config");
		CLEAR_LOG = propertyDepository.getString(JXPropertyDepository.PROPERTIES_MENU, "clear_log");
		VERSION = propertyDepository.getString(JXPropertyDepository.PROPERTIES_MENU, "version");
	}

	/**
	 * RXgN^
	 */
	public JXFrame() {
		thisFrame = this;
		menuItems = new HashMap();
		toolBarItems = new HashMap();
		actionListener = new JXFrameActionListener();
		listSelectionListener = new JXListSelectionListener();
		windowAdapter = new JXFrameWindowAdapter();
		presetNames = new HashMap();
		allowPresetChange = true;
	}

	/**
	 * GUI 쐬A\
	 */
	public void createAndShowGUI() {
		String osName = System.getProperty("os.name");
		JXPropertyDepository propertyDepository = JXPropertyDepository.getInstance();
		JXIconDepository iconDepository = JXIconDepository.getInstance();

		frame = new JFrame();
		frame.setIconImage(iconDepository.getIcon(JXIconDepository.FANTASTIKK_16PX, JXIconDepository.STATE_NONE).getImage());
		frame.setTitle(propertyDepository.getString(JXPropertyDepository.PROPERTIES_LABEL, "main_title"));
		Container container = frame.getContentPane();

		/* vZbgXg\ */
		presetListLabel = new JLabel(propertyDepository.getString(JXPropertyDepository.PROPERTIES_LABEL, "preset"));

		TreeMap presets = JXController.getInstance().getPresets();
		DefaultListModel model = new DefaultListModel();
		String selectedValue = null;	// NɑIĂԂƂvZbg

		if (presets != null && !presets.isEmpty()) {
			for (Iterator iterator = presets.keySet().iterator(); iterator.hasNext(); ) {
				String path = (String)iterator.next();
				Document document = (Document)presets.get(path);
				String presetName = document.getDocumentElement().getAttribute("name");
				int num = 1;

				/* vZbgdĂꍇɂ͐ */
				while (model.contains(presetName)) {
					presetName = document.getDocumentElement().getAttribute("name") + " " + (++num);
				}

				if (PatternUtility.PATTERN_YES_OR_TRUE.matcher(document.getDocumentElement().getAttribute("selected")).matches()) {
					selectedValue = presetName;
				}

				model.addElement(presetName);

				/* vZbgƂēo^Ă */
				presetNames.put(presetName, path);
			}
		}

		presetNameList = new JList(model);
		presetNameList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		presetNameList.setSelectedIndex(0);		// ŏ̍ () I
		JScrollPane scrollPane_preset = new JScrollPane(presetNameList, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		scrollPane_preset.getVerticalScrollBar().setUnitIncrement(25);		// XN[x
		scrollPane_preset.setPreferredSize(new Dimension(200, 400));

		presetPanel = new JPanel();

		GridBagLayout gb_preset = new GridBagLayout();
		presetPanel.setLayout(gb_preset);
		GridBagConstraints c_preset = new GridBagConstraints();
		c_preset.insets = new Insets(2, 5, 2, 5);	// R|[lgԂ̌

		c_preset.gridx = 0;
		c_preset.gridy = 0;
		c_preset.gridwidth = 1;
		c_preset.gridheight = 1;
		c_preset.fill = GridBagConstraints.HORIZONTAL;
		c_preset.anchor = GridBagConstraints.NORTH;
		c_preset.weightx = 100.0;
		c_preset.weighty = 0.0;
		gb_preset.setConstraints(presetListLabel, c_preset);
		presetPanel.add(presetListLabel);

		c_preset.gridx = 0;
		c_preset.gridy = 1;
		c_preset.gridwidth = 1;
		c_preset.gridheight = 1;
		c_preset.fill = GridBagConstraints.BOTH;
		c_preset.anchor = GridBagConstraints.NORTH;
		c_preset.weightx = 100.0;
		c_preset.weighty = 100.0;
		gb_preset.setConstraints(scrollPane_preset, c_preset);
		presetPanel.add(scrollPane_preset);

		/* vZbge\̐ */
		createPresetContentPanel();

		/* 㕔̃XvbgyC */
		splitPane_top = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT);
		splitPane_top.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
		splitPane_top.setLeftComponent(presetPanel);			// ̃R|[lg
		splitPane_top.setRightComponent(presetContentPanel);		// ẼR|[lg

		/* pl */
		bottomPanel = new JPanel();

		textArea_log = new JTextArea();			// JTextArea IuWFNg (O\)
		textArea_log.setEditable(false);
		textArea_log.setTabSize(4);
		scrollPane_log = new JScrollPane(textArea_log, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		scrollPane_log.getVerticalScrollBar().setUnitIncrement(25);		// XN[x
		scrollPane_log.getHorizontalScrollBar().setUnitIncrement(25);		// XN[x
		JLabel label_log = new JLabel(propertyDepository.getString(JXPropertyDepository.PROPERTIES_LABEL, "log"));

		GridBagLayout gb_log = new GridBagLayout();
		bottomPanel.setLayout(gb_log);
		GridBagConstraints c_log = new GridBagConstraints();
		c_log.insets = new Insets(0, 0, 0, 0);	// R|[lgԂ̌

		c_log.gridx = 0;
		c_log.gridy = 0;
		c_log.fill = GridBagConstraints.NONE;
		c_log.anchor = GridBagConstraints.WEST;
		c_log.weightx = 0.0;
		c_log.weighty = 0.0;
		gb_log.setConstraints(label_log, c_log);
		bottomPanel.add(label_log);

//		c_log.gridx = 0;
		c_log.gridy = 1;
		c_log.fill = GridBagConstraints.BOTH;
//		c_log.anchor = gridBagConstraints.WEST;
		c_log.weightx = 100.0;
		c_log.weighty = 100.0;
		gb_log.setConstraints(scrollPane_log, c_log);
		bottomPanel.add(scrollPane_log);

		splitPane = new JSplitPane(JSplitPane.VERTICAL_SPLIT, true, splitPane_top, bottomPanel);
		splitPane.setBorder(BorderFactory.createEmptyBorder(0, 0, 1, 0));

		/* c[o[̍쐬 */
		toolBar = new JToolBar();
		createToolBarItem(JXIconDepository.TOOL_BAR_CREATE_FRAME_IMAGE, CREATE_FRAME);
		toolBar.addSeparator();
		createToolBarItem(JXIconDepository.TOOL_BAR_LOAD_PRESET_IMAGE, LOAD_PRESET);
		createToolBarItem(JXIconDepository.TOOL_BAR_SAVE_PRESET_IMAGE, SAVE_PRESET);
		createToolBarItem(JXIconDepository.TOOL_BAR_SAVE_AS_PRESET_IMAGE, SAVE_AS_PRESET);
		toolBar.addSeparator();
		createToolBarItem(JXIconDepository.TOOL_BAR_XML2FO_IMAGE, XML2FO);
		createToolBarItem(JXIconDepository.TOOL_BAR_XML2PDF_IMAGE, XML2PDF);
		createToolBarItem(JXIconDepository.TOOL_BAR_FO2PDF_IMAGE, FO2PDF);
		createToolBarItem(JXIconDepository.TOOL_BAR_FO2RTF_IMAGE, FO2RTF);
		createToolBarItem(JXIconDepository.TOOL_BAR_FO2AWT_IMAGE, FO2AWT);
		createToolBarItem(JXIconDepository.TOOL_BAR_XML2EPUB_IMAGE, XML2EPUB);
		toolBar.addSeparator();
		createToolBarItem(JXIconDepository.TOOL_BAR_CONFIG_IMAGE, CONFIG);
		createToolBarItem(JXIconDepository.TOOL_BAR_CLEAR_LOG_IMAGE, CLEAR_LOG);

		JPanel toolBarPanel = new JPanel(new BorderLayout());
		toolBarPanel.add(toolBar);

		/* plzu */
		GridBagLayout gb = new GridBagLayout();
		container.setLayout(gb);
		GridBagConstraints c = new GridBagConstraints();
		c.insets = new Insets(2, 5, 2, 5);	// R|[lgԂ̌

		c.gridx = 0;
		c.gridy = 0;
		c.gridwidth = 1;
		c.gridheight = 1;
		c.fill = GridBagConstraints.HORIZONTAL;
		c.anchor = GridBagConstraints.NORTH;
		c.weightx = 100.0;
		c.weighty = 0.0;
		gb.setConstraints(toolBarPanel, c);
		container.add(toolBarPanel);

		c.gridx = 0;
		c.gridy = 1;
		c.gridwidth = 1;
		c.gridheight = 1;
		c.fill = GridBagConstraints.BOTH;
		c.anchor = GridBagConstraints.NORTH;
		c.weightx = 100.0;
		c.weighty = 100.0;
		gb.setConstraints(splitPane, c);
		container.add(splitPane);

		/* j[̍쐬 */
		JMenu menu_file = new JMenu(propertyDepository.getString(JXPropertyDepository.PROPERTIES_MENU, "file"));
		createMenuItem(menu_file, CREATE_FRAME);
		menu_file.addSeparator();
		createMenuItem(menu_file, LOAD_PRESET);
		createMenuItem(menu_file, SAVE_PRESET);
		createMenuItem(menu_file, SAVE_AS_PRESET);
		
		if (osName.indexOf("Mac") == -1) {		// MacOS ȊȌꍇ
			menu_file.addSeparator();
			createMenuItem(menu_file, EXIT);
		}

		JMenu menu_edit = new JMenu(propertyDepository.getString(JXPropertyDepository.PROPERTIES_MENU, "edit"));
		if (JXConfiguration.getInstance().isXml2xmlAvairable()) {
			createMenuItem(menu_edit, XML2XML);
			menu_edit.addSeparator();
		}
		createMenuItem(menu_edit, XML2FO);
		createMenuItem(menu_edit, XML2PDF);
		createMenuItem(menu_edit, FO2PDF);
		createMenuItem(menu_edit, FO2RTF);
		createMenuItem(menu_edit, FO2AWT);
		menu_edit.addSeparator();
		createMenuItem(menu_edit, XML2EPUB);

		JMenu menu_misc = new JMenu(propertyDepository.getString(JXPropertyDepository.PROPERTIES_MENU, "misc"));

		if (osName.indexOf("Mac") == -1) {		// MacOS ȊȌꍇ
			createMenuItem(menu_misc, CONFIG);
			menu_misc.addSeparator();
		}

		createMenuItem(menu_misc, CLEAR_LOG);

		if (osName.indexOf("Mac") == -1) {		// MacOS ȊȌꍇ
			createMenuItem(menu_misc, VERSION);
		}

		JMenuBar menuBar = new JMenuBar();
		menuBar.add(menu_file);
		menuBar.add(menu_edit);
		menuBar.add(menu_misc);
		frame.setJMenuBar(menuBar);

		/* Xi̓o^ */
		presetNameList.addListSelectionListener(listSelectionListener);
		frame.addWindowListener(windowAdapter);

		if (!model.isEmpty()) {
			if (selectedValue != null) {
				presetNameList.setSelectedValue(selectedValue, true);
			} else {
				/* ߂̃vZbgIԂŕ\肩 */
				presetNameList.setSelectedIndex(0);
			}

			showPresetGUI((String)(presetNameList.getSelectedValue()));
		}

		frame.setSize(1010, 720);
		frame.setLocation(xPosition, yPosition);
		xPosition += 25;
		yPosition += 25;
		frame.setVisible(true);
		splitPane_top.setDividerLocation(0.23);
		splitPane.setDividerLocation(0.77);
	}

	/**
	 * j[ڂ쐻܂B
	 * @param menu j[
	 * @param label j[ڂ̃x (ds)
	 */
	private void createMenuItem(JMenu menu, String label) {
		JMenuItem menuItem = new JMenuItem(label);
		menuItems.put(label ,menuItem);
		menu.add(menuItem);
		menuItem.addActionListener(actionListener);
	}

	/**
	 * c[o[ڂ쐻܂B
	 * @param iconName ACR̖O (ds)
	 * @param tooltip c[o[ڂ̃c[`bvŎgp镶 (null̏ꍇ̓c[`bvȂ)
	 */
	private void createToolBarItem(String iconName, String tooltip) {
		JXIconDepository depository = JXIconDepository.getInstance();
		
		JButton button = new JButton();
		button.setUI(new BasicButtonUI());
		button.setBorder(BorderFactory.createEmptyBorder(0, 1, 0, 0));
//		button.setBackground(Color.WHITE);
		button.setIcon(depository.getIcon(iconName, JXIconDepository.STATE_NONE));
		button.setDisabledIcon(depository.getIcon(iconName, JXIconDepository.STATE_DISABLED));
		button.setPressedIcon(depository.getIcon(iconName, JXIconDepository.STATE_PRESSED));
		button.setRolloverIcon(depository.getIcon(iconName, JXIconDepository.STATE_ROLLOVER));
//		button.setFocusable(false);
		button.setToolTipText(tooltip);
		button.setOpaque(false);

		toolBarItems.put(iconName ,button);
		toolBar.add(button);
		button.addActionListener(actionListener);
	}

	/**
	 * j[ڂ̏ԂύX܂B
	 * @param menuItemLabel j[ڂ̖O
	 * @param enable j[ڂLǂ
	 */
	public void setMenuItemEnabled(String menuItemLabel, boolean enable) {
		if (menuItems.containsKey(menuItemLabel)) {
			((JMenuItem)menuItems.get(menuItemLabel)).setEnabled(enable);
		}
	}

	/**
	 * c[o[ڂ̏ԂύX܂B
	 * @param menuItemLabel c[o[ڂ̃ACR̖O
	 * @param enable c[o[ڂLǂ
	 */
	public void setToolBarItemEnabled(String toolBarItemIconName, boolean enable) {
		if (toolBarItems.containsKey(toolBarItemIconName)) {
			((JButton)toolBarItems.get(toolBarItemIconName)).setEnabled(enable);
		}
	}

	/**
	 * EBhËʒuԂ܂B
	 * @return EBhËʒu
	 */
	public Point getLocation() {
		return frame == null ? new Point() : frame.getLocation();
	}

	/**
	 * c[LbgԂ܂B
	 * @return c[Lbg
	 */
	public Toolkit getToolkit() {
		return frame == null ? Toolkit.getDefaultToolkit() : frame.getToolkit();
	}

	/**
	 * vZbge\pl쐻܂B
	 */
	private void createPresetContentPanel() {
		presetContentPanel = new JPanel();
		cardLayout = new CardLayout();
		presetContentPanel.setLayout(cardLayout);

		if (presetNames == null || presetNames.isEmpty()) {
			presetContentPanel.add(new JLabel(JXPropertyDepository.getInstance().getString(JXPropertyDepository.PROPERTIES_LABEL, "preset_not_found")), "");
		}
	}

	/**
	 * vZbge\쐻܂B
	 * @param presetName vZbg̖O
	 */
	private void updatePresetPanel(String presetName) {
		/* GUI ̃vZbgŖꍇ͏Ȃ */
		if (presetName == null || !presetNames.containsKey(presetName)) {
			return;
		}

		System.gc();

		String path = (String)presetNames.get(presetName);

		/* Document IuWFNg擾 */
		TreeMap presets = JXController.getInstance().getPresets();
		Document document = (Document)presets.get(path);
		Element root = document.getDocumentElement();

		JXDocumentCategoryPanel documentPanel = new JXDocumentCategoryPanel();
		documentPanel.setInformation((String)presetNames.get(presetName));

		JTabbedPane tabbedPane = new JTabbedPane(JTabbedPane.TOP);		// ^üʒu͏[
		tabbedPane.setUI(new BasicTabbedPaneUI());

		GridBagLayout gb_document = new GridBagLayout();
		documentPanel.setLayout(gb_document);
		GridBagConstraints c_document = new GridBagConstraints();
		c_document.insets = new Insets(0, 0, 0, 0);	// R|[lgԂ̌

		c_document.gridx = 0;
		c_document.gridy = 0;
		c_document.fill = GridBagConstraints.BOTH;
		c_document.anchor = GridBagConstraints.EAST;
		c_document.weightx = 100.0;
		c_document.weighty = 100.0;
		gb_document.setConstraints(tabbedPane, c_document);
		documentPanel.add(tabbedPane);

		List categoryPanelList = documentPanel.getChildPanelList();

		/* vZbg category vf̃Xg擾 (VtH[}bgł body vf̉ category vf) */
		NodeList categoryNodeList = null;
		NodeList nodeList = root.getChildNodes();

		for (int i = 0; i < nodeList.getLength(); i++) {
			Node node = nodeList.item(i);
			if (node.getNodeType() == Node.ELEMENT_NODE && node.getNodeName().equals("body")) {
				categoryNodeList = node.getChildNodes();
				break;
			}
		}

		if (categoryNodeList == null) {
			categoryNodeList = nodeList;
		}

		/* category ̊Kw̏ */
		for (int i = 0; i < categoryNodeList.getLength(); i++) {
			Node categoryNode = categoryNodeList.item(i);
			if (categoryNode.getNodeType() == Node.ELEMENT_NODE && categoryNode.getNodeName().equals("category")) {
				boolean categoryVisible = PatternUtility.PATTERN_NO_OR_FALSE.matcher(((Element)categoryNode).getAttribute("visible")).matches() ? false : true;

				if (!categoryVisible) {
					/* visible s̏ꍇ͏XLbv */
					continue;
				}

				String categoryName = ((Element)categoryNode).getAttribute("name");
				JXDocumentCategoryPanel categoryPanel = new JXDocumentCategoryPanel();
				categoryPanel.setInformation("");

				GridBagLayout gb_category = new GridBagLayout();
				categoryPanel.setLayout(gb_category);
				GridBagConstraints c_category = new GridBagConstraints();
				c_category.insets = new Insets(0, 0, 0, 0);	// R|[lgԂ̌
				int y_category = 0;
				List subCategoryPanelList = categoryPanel.getChildPanelList();

				/* sub-category ̊Kw̏ */
				NodeList subCategoryNodeList = categoryNode.getChildNodes();

				for (int j = 0; j < subCategoryNodeList.getLength(); j++) {
					Node subCategoryNode = subCategoryNodeList.item(j);

					if (subCategoryNode.getNodeType() == Node.ELEMENT_NODE && subCategoryNode.getNodeName().equals("sub-category")) {
						String subCategoryName = ((Element)subCategoryNode).getAttribute("name");
						String separatorColorStr = ((Element)subCategoryNode).getAttribute("separator-color");
						String separatorVisibleStr = ((Element)subCategoryNode).getAttribute("separator-visible");
						String toolTipTextStrStr = ((Element)subCategoryNode).getAttribute("tooltip-text");
						String descriptionStr = ((Element)subCategoryNode).getAttribute("description");

						JXDocumentCategoryPanel subCategoryPanel = new JXDocumentCategoryPanel();
						subCategoryPanel.setInformation("");
//						subCategoryPanel.setBorder(BorderFactory.createTitledBorder(new SoftBevelBorder(SoftBevelBorder.LOWERED), sunCategoryName));

						GridBagLayout gb_subCategory = new GridBagLayout();
						subCategoryPanel.setLayout(gb_subCategory);
						GridBagConstraints c_subCategory = new GridBagConstraints();
						c_subCategory.insets = new Insets(2, 0, 0, 0);	// R|[lgԂ̌
						int y_subCategory = 0;
						List valuePanelList = subCategoryPanel.getChildPanelList();

						/* TuJeSԂ̋؂̕\ */
						JXSeparatorPanel separatorPanel = new JXSeparatorPanel(subCategoryName, separatorColorStr, separatorVisibleStr, toolTipTextStrStr, descriptionStr);

						c_subCategory.gridx = 0;
						c_subCategory.gridy = y_subCategory++;
						c_subCategory.fill = GridBagConstraints.HORIZONTAL;
						c_subCategory.anchor = GridBagConstraints.NORTH;
						c_subCategory.weightx = 100.0;
						c_subCategory.weighty = 0.0;
						gb_subCategory.setConstraints(separatorPanel, c_subCategory);
						subCategoryPanel.add(separatorPanel);

						/* ݒl\𐶐 */
						NodeList valueNodeList = subCategoryNode.getChildNodes();

						for (int k = 0; k < valueNodeList.getLength(); k++) {
							Node valueNode = valueNodeList.item(k);

							if (valueNode.getNodeType() == Node.ELEMENT_NODE) {
								JXAbstractValuePanel valuePanel = null;
								String valueNodeName = valueNode.getNodeName();

								if (valueNodeName.equals("number")) {
									valuePanel = new JXNumberValuePanel((Element)valueNode);
								} else if (valueNodeName.equals("string")) {
									valuePanel = new JXStringValuePanel((Element)valueNode);
								} else if (valueNodeName.equals("password")) {
									valuePanel = new JXPasswordValuePanel((Element)valueNode);
								} else if (valueNodeName.equals("file-path")) {
									valuePanel = new JXFilePathValuePanel((Element)valueNode);
								} else if (valueNodeName.equals("color")) {
									valuePanel = new JXColorValuePanel((Element)valueNode);
								} else if (valueNodeName.equals("list")) {
									valuePanel = new JXListValuePanel((Element)valueNode);
								} else if (valueNodeName.equals("border")) {
									valuePanel = new JXBorderValuePanel((Element)valueNode);
								} else if (valueNodeName.equals("appendable-list")) {
									valuePanel = new JXAppendableListValuePanel((Element)valueNode);
								} else if (valueNodeName.equals("complex")) {
									valuePanel = new JXComplexValuePanel((Element)valueNode);
								}

								if (valuePanel != null) {
									c_subCategory.gridx = 0;
									c_subCategory.gridy = y_subCategory++;
									c_subCategory.fill = GridBagConstraints.HORIZONTAL;
									c_subCategory.anchor = GridBagConstraints.NORTH;
									c_subCategory.weightx = 100.0;
									c_subCategory.weighty = 0.0;
									gb_subCategory.setConstraints(valuePanel, c_subCategory);
									subCategoryPanel.add(valuePanel);

									valuePanelList.add(valuePanel);
								}
							}
						}

						c_category.gridx = 0;
						c_category.gridy = y_category++;
						c_category.fill = GridBagConstraints.HORIZONTAL;
						c_category.anchor = GridBagConstraints.NORTH;
						c_category.weightx = 100.0;
						c_category.weighty = 0.0;
						gb_category.setConstraints(subCategoryPanel, c_category);
						categoryPanel.add(subCategoryPanel);

						subCategoryPanelList.add(subCategoryPanel);
					}
				}

				Component spacer = Box.createVerticalStrut(20);

				c_category.gridx = 0;
				c_category.gridy = y_category++;
				c_category.fill = GridBagConstraints.BOTH;
				c_category.anchor = GridBagConstraints.SOUTH;
				c_category.weightx = 100.0;
				c_category.weighty = 100.0;
				gb_category.setConstraints(spacer, c_category);
				categoryPanel.add(spacer);

				JScrollPane scrollPane = new JScrollPane(categoryPanel, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
				scrollPane.getVerticalScrollBar().setUnitIncrement(100);		// XN[x

				/* ^uɒǉ */
				tabbedPane.addTab(categoryName, scrollPane);

				/* c[`bvݒ */
				String tabToolTipTextStr = ((Element)categoryNode).getAttribute("tooltip-text");

				if (tabToolTipTextStr == null || tabToolTipTextStr.equals("")) {
					tabbedPane.setToolTipTextAt(tabbedPane.getTabCount() - 1, categoryName);
				} else {
					tabbedPane.setToolTipTextAt(tabbedPane.getTabCount() - 1, tabToolTipTextStr);
				}

				categoryPanelList.add(categoryPanel);
			}
		}

		if (tabbedPane.getTabCount() > 0) {
			tabbedPane.setSelectedIndex(0);		// ŏɒǉI
		}

		presetContentPanel.removeAll();
		presetContentPanel.add(documentPanel, presetName);
		presetContentPanel.validate();
		currentDocumentPanel = documentPanel;
		currentPresetName = presetName;
	}

	/**
	 * OȂǂ̃bZ[Wo͂܂B
	 * @param content o͓e
	 */
	public void printMessage(String content) {
		textArea_log.append("\n");
		textArea_log.append(content);
		textArea_log.setCaretPosition(textArea_log.getText().length());
		scrollPane_log.getHorizontalScrollBar().setValue(scrollPane_log.getHorizontalScrollBar().getMinimum());
		scrollPane_log.getVerticalScrollBar().setValue(scrollPane_log.getVerticalScrollBar().getMaximum());
	}

	/**
	 * OȂǂ̃bZ[Wo͂܂B
	 * @param e G[^O
	 */
	public void printMessage(Throwable e) {
		textArea_log.append("\n");

		StringWriter sw = new StringWriter();
		PrintWriter pw = new PrintWriter(sw);
		e.printStackTrace(pw);
		pw.flush();

		textArea_log.append(sw.getBuffer().toString());

		pw.close();

		textArea_log.setCaretPosition(textArea_log.getText().length());
		scrollPane_log.getHorizontalScrollBar().setValue(scrollPane_log.getHorizontalScrollBar().getMinimum());
	}

	/**
	 * vZbgēǂݍ
	 */
	public void reloadPresets() {
		/* vZbg؂ւȂ悤ɂ */
		allowPresetChange = false;

		TreeMap presets = JXController.getInstance().getPresets();
		DefaultListModel model = (DefaultListModel)presetNameList.getModel();
		model.removeAllElements();

		/* vZbg */
		presetNames.clear();
		currentPresetName = null;

		if (presets != null && !presets.isEmpty()) {
			for (Iterator iterator = presets.keySet().iterator(); iterator.hasNext(); ) {
				String path = (String)iterator.next();
				Document document = (Document)presets.get(path);
				String presetName = document.getDocumentElement().getAttribute("name");
				int num = 1;

				/* vZbg̖OdĂꍇɂ͐ */
				while (model.contains(presetName)) {
					presetName = document.getDocumentElement().getAttribute("name") + " " + (++num);
				}

				model.addElement(presetName);

				/* vZbgƂēo^Ă */
				presetNames.put(presetName, path);
			}
		}

		allowPresetChange = true;

		/* ߂̃vZbgIԂŕ\肩 */
		if(!model.isEmpty()) {
			presetNameList.setSelectedIndex(0);
			showPresetGUI((String)(presetNameList.getSelectedValue()));
		}
	}

	/**
	 * vZbg\肩
	 * @param presetName vZbg
	 */
	public void showPresetGUI(String presetName) {
		if (presetName == null || !presetNames.containsKey(presetName)) {
			printMessage(JXPropertyDepository.getInstance().getString(JXPropertyDepository.PROPERTIES_LINE, "preset_not_found"));
			return;
		}

		if (this.currentPresetName == null || !presetName.equals(this.currentPresetName)) {
			/*  ɕ\EBhE */
			JXAbstractWaitingFrame waitingFrame;

			JXController controller = JXController.getInstance();
			if (controller.isInit()) {
				waitingFrame = JXSplashScreenFrame.getInstance();
				((JXSplashScreenFrame) waitingFrame).setOnClickClose(false);
			} else {
				waitingFrame = JXWaitingFrame.getInstance();
			}

			/* ԎZopϐ */
			long start = 0;
			
			if (controller.isInit()) {
				start = System.currentTimeMillis();
			}

			/*  ɕ\EBhE\ */
			waitingFrame.setVisible(this, true);

			updateDocumentStatus();

			/* vZbg\XV */
			updatePresetPanel(presetName);

			if (controller.isInit()) {
				/* ԎZo */
				long end = System.currentTimeMillis();
				long execTime = (start < end) ? (end - start) : 0;

				/* Ԃ2bȉ̏ꍇ̓XvbVXN[\Ԃ̂΂߃X[v */
				if (execTime < 2000) {
					try {
						Thread.sleep(2000 - execTime);
					} catch (InterruptedException e) {
						e.printStackTrace();
					}	
				}
			}

			waitingFrame.setVisible(this, false);
			controller.setInit(false);
			this.refresh();		// \΍
		}
	}

	/**
	 * vZbg㏑ۑ
	 */
	private void savePresetFile() {
		JXController.getInstance().savePresetFile(this);
	}

	/**
	 * vZbgʖۑ
	 */
	private void saveAsPresetFile() {
		JXController.getInstance().saveAsPresetFile(this);
	}

	/**
	 * XML ϊ
	 */
	private void xml2xml() {
		/* XML ϊ */
		JXController.getInstance().xml2xml(this);
	}

	/**
	 * XML  FO 𐶐
	 * @param frame ˗̃EBhE
	 */
	private void xml2fo() {
		/* XML  FO 𐶐 */
		JXController.getInstance().xml2fo(this);
	}

	/**
	 * XML  PDF 𐶐
	 */
	private void xml2pdf() {
		/* XML  PDF 𐶐 */
		JXController.getInstance().xml2pdf(this);
	}

	/**
	 * FO  PDF 𐶐
	 */
	private void fo2pdf() {
		/* FO  PDF 𐶐 */
		JXController.getInstance().fo2pdf(this);
	}

	/**
	 * FO  RTF 𐶐
	 */
	private void fo2rtf() {
		/* FO RTF 𐶐 */
		JXController.getInstance().fo2rtf(this);
	}

	/**
	 * FO ̓e\
	 */
	private void fo2awt() {
		/* FO ̓e\ */
		JXController.getInstance().fo2awt(this);
	}

	/**
	 * XML  EPUB 𐶐
	 */
	private void xml2epub() {
		/* XML  EPUB 𐶐 */
		JXController.getInstance().xml2epub(this);
	}

	/**
	 * ݂̃vZbg̃pXԂ܂B(ꍇ "")
	 * @return ݂̃vZbg̃pX
	 */
	public String getCurrentPresetPath() {
		if (currentDocumentPanel != null) {
			return currentDocumentPanel.getInformation();
		} else {
			return "";
		}
	}

	/**
	 * vZbg Document  GUI őIꂽl𔽉f܂B
	 */
	public void updateDocumentStatus() {
		if (currentDocumentPanel != null) {
			this.currentDocumentPanel.updateNodeStatus();
		}
	}

	/**
	 * vZbg Document ̏Ԃɖ߂܂B
	 */
	public void setBackDocumentStatus() {
		if (currentDocumentPanel != null) {
			this.currentDocumentPanel.setBackNodeStatus();
		}
	}

	/**
	 * \XV܂B(\΍)
	 */
	public void refresh() {
		splitPane.paintImmediately(splitPane.getBounds());
	}

	/**
	 * ANVCxg󂯎܂B
	 * @author Takashi Nishikawa
	 */
	class JXFrameActionListener implements ActionListener {
		/**
		 * ANVƌĂяo܂B
		 * @param ae ANVCxg
		 */
		public void actionPerformed(ActionEvent ae) {
			Object source = ae.getSource();

			if (source == menuItems.get(CREATE_FRAME)	// j[Ft@C - VKEBhE
					|| source == toolBarItems.get(JXIconDepository.TOOL_BAR_CREATE_FRAME_IMAGE)) {	// c[o[FVKEBhE
				JXController.getInstance().createFrame();
			} else if (source == menuItems.get(LOAD_PRESET)	// j[Ft@C - vZbgēǂݍ
					|| source == toolBarItems.get(JXIconDepository.TOOL_BAR_LOAD_PRESET_IMAGE)) {	// c[o[FvZbgēǂݍ
				JXController.getInstance().reloadPresets();
			} else if (source == menuItems.get(SAVE_PRESET)	// j[Ft@C - vZbg㏑ۑ
					|| source == toolBarItems.get(JXIconDepository.TOOL_BAR_SAVE_PRESET_IMAGE)) {	// c[o[FvZbg㏑ۑ
				savePresetFile();
			} else if (source == menuItems.get(SAVE_AS_PRESET)	// j[Ft@C - vZbgʖŕۑ
					|| source == toolBarItems.get(JXIconDepository.TOOL_BAR_SAVE_AS_PRESET_IMAGE)) {	// c[o[FvZbgʖŕۑ
				saveAsPresetFile();
			} else if (source == menuItems.get(EXIT)) {	// j[Ft@C - I
				JXController.getInstance().exit(false);
			} else if (source == menuItems.get(XML2XML)) {	// j[FҏW - XML ϊ
				xml2xml();
			} else if (source == menuItems.get(XML2FO)	// j[FҏW - XML  FO 𐶐
					|| source == toolBarItems.get(JXIconDepository.TOOL_BAR_XML2FO_IMAGE)) {	// c[o[FXML  FO 𐶐
				xml2fo();
			} else if (source == menuItems.get(XML2PDF)	// j[FҏW - XML  PDF 𐶐
					|| source == toolBarItems.get(JXIconDepository.TOOL_BAR_XML2PDF_IMAGE)) {	// c[o[FXML  PDF 𐶐
				xml2pdf();
			} else if (source == menuItems.get(FO2PDF)	// j[FҏW - FO  PDF 𐶐
					|| source == toolBarItems.get(JXIconDepository.TOOL_BAR_FO2PDF_IMAGE)) {	// c[o[FFO  PDF 𐶐
				fo2pdf();
			} else if (source == menuItems.get(FO2RTF)	// j[FҏW - FO  RTF 𐶐
					|| source == toolBarItems.get(JXIconDepository.TOOL_BAR_FO2RTF_IMAGE)) {	// c[o[FFO  RTF 𐶐
				fo2rtf();
			} else if (source == menuItems.get(FO2AWT)	// j[FҏW - FO ̓e\
					|| source == toolBarItems.get(JXIconDepository.TOOL_BAR_FO2AWT_IMAGE)) {	// c[o[FFO ̓e\
				fo2awt();
			} else if (source == menuItems.get(XML2EPUB)	// j[FҏW - XML  EPUB 𐶐
					|| source == toolBarItems.get(JXIconDepository.TOOL_BAR_XML2EPUB_IMAGE)) {	// c[o[FXML  EPUB 𐶐
				xml2epub();
			} else if (source == menuItems.get(CONFIG)		// j[F̑ - ݒEBhEJ
					|| source == toolBarItems.get(JXIconDepository.TOOL_BAR_CONFIG_IMAGE)) {	// c[o[FݒEBhEJ
				JXController.getInstance().showCongigurationFrame();
			} else if (source == menuItems.get(CLEAR_LOG)	// j[F̑ - ONA
					|| source == toolBarItems.get(JXIconDepository.TOOL_BAR_CLEAR_LOG_IMAGE)) {	// c[o[FONA
				textArea_log.setText("");
			} else if (source == menuItems.get(VERSION)) {	// ̑ - o[W\
				JXController.getInstance().showSplashScreenFrame();
			}
		}
	}

	/**
	 * Xg̑I͈͂̒lύXꂽƂɒʒm郊Xi[łB
	 * @author Takashi Nishikawa
	 */
	class JXListSelectionListener implements ListSelectionListener {
		/**
		 * I͈͓̒lύXꂽƂɌĂяo܂B
		 * @param lse Cxg
		 */
		public void valueChanged(ListSelectionEvent lse) {
			if (allowPresetChange) {
				String presetName = (String)presetNameList.getSelectedValue();

				/* vZbg\肩 */
				showPresetGUI(presetName);
				
				/* j[̏ԂXV */
				JXController.getInstance().updateMenuAndToolBarState();
			}
		}
	}

	/**
	 * WindowEvent 󂯎邽߂̃NXłB
	 * @author Takashi Nishikawa
	 */
	class JXFrameWindowAdapter extends WindowAdapter {
		/**
		 * EBhEN[Ył鎞ɌĂяo܂B
		 * @param we EBhȄԂςƂCxg
		 */
		public void windowClosing(WindowEvent we) {
			frame.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);

			JXController controller = JXController.getInstance();
			Set frames = controller.getFrames();

			/* \ĂEBhE@1  (ȉ) ̏ꍇAvP[VI */
			if (frames.size() <= 1) {
				JXPropertyDepository propertyDepository = JXPropertyDepository.getInstance();
				if (JOptionPane.showConfirmDialog(
						null,
						propertyDepository.getString(JXPropertyDepository.PROPERTIES_LABEL, "window_close_exit_confirm"),
						propertyDepository.getString(JXPropertyDepository.PROPERTIES_LABEL, "window_close_exit_title"),
						JOptionPane.YES_NO_OPTION,
						JOptionPane.PLAIN_MESSAGE,
						JXIconDepository.getInstance().getIcon(JXIconDepository.FANTASTIKK_48PX, JXIconDepository.STATE_NONE)
					) == JOptionPane.OK_OPTION) {
					/* AvP[V̏I */
					JXController.getInstance().exit(true);
				} else {
					frame.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
				}

			} else {
				frames.remove(thisFrame);
			}

			/* j[̏ԂXV */
			controller.updateMenuAndToolBarState();
		}
	}
}
