package fantastikk.gui;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.SwingConstants;
import javax.swing.WindowConstants;

import fantastikk.gui.icon.JXIconDepository;
import fantastikk.properties.JXPropertyDepository;

/** 
 * XvbVXN[\EBhẼNXłB
 * @author Takashi Nishikawa
 */
public class JXSplashScreenFrame extends JXAbstractWaitingFrame {
	/** JXSplashScreenFrame IuWFNg */
	private static JXSplashScreenFrame splashScreenFrame;

	/** NbNƂɕ邩ǂ */
	private boolean onClickClose;

	/** GUI i */
	private JFrame frame;
	private JLabel label;

	/**
	 * RXgN^
	 */
	private JXSplashScreenFrame() {
		super();
		onClickClose = false;
	}

	/**
	 * JXAbstractWaitingFrame IuWFNgԂ܂B
	 * @return JXAbstractWaitingFrame IuWFNg
	 */
	public static JXAbstractWaitingFrame getInstance() {
		if (splashScreenFrame == null) {
			splashScreenFrame = new JXSplashScreenFrame();
		}

		return splashScreenFrame;
	}

	/**
	 * GUI 쐬܂B
	 */
	protected void createGUI() {
		JXPropertyDepository propertyDepository = JXPropertyDepository.getInstance();
		JXIconDepository iconDepository = JXIconDepository.getInstance();

		/* XvbVXN[ */
		frame = new JFrame();

		/* t[̐ݒ */
		frame.setSize(new Dimension(375, 250));
		frame.setResizable(false);		// TCYύXs
		frame.setLocation(30, 30);
		frame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);		// Ȃ悤ɂ
		frame.setUndecorated(true);		// t[̗̑LƖ؂ւ
		frame.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);	 // Ȃ
		frame.setVisible(false);

		String name = propertyDepository.getString(JXPropertyDepository.PROPERTIES_LABEL, "name");
		String version = propertyDepository.getString(JXPropertyDepository.PROPERTIES_LABEL, "version");
		String copyright = propertyDepository.getString(JXPropertyDepository.PROPERTIES_LABEL, "copyright");

		String content = "<html><body><font size=\"+5\">"
					+ name
					+ "</font><br><br><font>version "
					+ version
					+ "</font><br><br><font>"
					+ copyright
					+ "</font></body></html>";

		label = new JLabel(content, iconDepository.getIcon(JXIconDepository.FANTASTIKK_128PX, JXIconDepository.STATE_NONE), SwingConstants.CENTER);
		label.setVerticalAlignment(SwingConstants.CENTER);
		label.setIconTextGap(8);
		label.setOpaque(true);
		frame.getContentPane().add(label);
		frame.addMouseListener(new JXSplashScreenMouseListener());

		/* F̐ݒ */
		if (System.getProperty("os.name").indexOf("Mac") < 0) {
			label.setBackground(new Color(225, 255, 225));
		} else {
			frame.setBackground(new Color(225, 255, 225, 100));
		}
	}

	/**
	 * EBhẺEsݒ肵܂B
	 * @clientFrame ˗̃EBhE
	 * @param visible EBhẺEs
	 */
	public void setVisible(JXFrame clientFrame, boolean visible) {
		/* ʒuݒ */
		Dimension dim = clientFrame.getToolkit().getScreenSize();
		frame.setLocation((dim.width - frame.getBounds().width)/ 2 , (dim.height - frame.getBounds().height) / 2);

		/* EBhE\ */
		frame.setVisible(visible);
		
		if (visible) {
			frame.toFront();
			frame.repaint(10);
			label.paintImmediately(label.getBounds());		// \΍
		}
	}

	/**
	 * NbNƂɕ邩ǂw肵܂B
	 * @param onClickClose NbNƂɕ邩ǂ
	 */
	public void setOnClickClose(boolean onClickClose) {
		this.onClickClose = onClickClose;
	}

	/**
	 * }EXCxg󂯎NXłB
	 * @author Takashi Nishikawa
	 */
	class JXSplashScreenMouseListener extends MouseAdapter {
		/**
		 * R|[lgŃ}EXNbNƌĂяo܂B
		 * @param me }EXCxg
		 */
		public void mouseClicked(MouseEvent me) {
			if (onClickClose) {
				frame.setVisible(false);
			}
		}

		/**
		 * R|[lgŃ}EX{^ƌĂяo܂B
		 * @param me }EXCxg
		 */
		public void	mousePressed(MouseEvent me) {
			if (onClickClose) {
				frame.setVisible(false);
			}
		}
		/**
		 * R|[lgŃ}EX{^ƌĂяo܂B
		 * @param me }EXCxg
		 */
		public void	mouseReleased(MouseEvent me) {
			if (onClickClose) {
				frame.setVisible(false);
			}
		}
	}
}
