package fantastikk.gui;

import java.awt.Dimension;

import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.SwingConstants;
import javax.swing.WindowConstants;

import fantastikk.gui.icon.JXIconDepository;
import fantastikk.properties.JXPropertyDepository;

/** 
 * ɕ\EBhẼNXłB
 * @author Takashi Nishikawa
 */
public class JXWaitingFrame extends JXAbstractWaitingFrame {
	/** JXWaitingFrame IuWFNg */
	private static JXWaitingFrame waitingFrame;

	/** GUI i */
	private JFrame frame;
	private JLabel label;

	/**
	 * RXgN^
	 */
	private JXWaitingFrame() {
		super();
	}

	/**
	 * JXAbstractWaitingFrame IuWFNgԂ܂B
	 * @return JXAbstractWaitingFrame IuWFNg
	 */
	public static JXAbstractWaitingFrame getInstance() {
		if (waitingFrame == null) {
			waitingFrame = new JXWaitingFrame();
		}

		return waitingFrame;
	}

	/**
	 * GUI 쐬܂B
	 */
	protected void createGUI() {
		JXPropertyDepository propertyDepository = JXPropertyDepository.getInstance();
		JXIconDepository iconDepository = JXIconDepository.getInstance();

		frame = new JFrame();
		frame.setIconImage(iconDepository.getIcon(JXIconDepository.FANTASTIKK_16PX, JXIconDepository.STATE_NONE).getImage());
		frame.setTitle(propertyDepository.getString(JXPropertyDepository.PROPERTIES_LABEL, "wait_title"));

		label = new JLabel(propertyDepository.getString(JXPropertyDepository.PROPERTIES_LABEL, "please_wait"), SwingConstants.CENTER);
		frame.getContentPane().add(label);

		/* t[̐ݒ */
		frame.setSize(new Dimension(260, 60));
		frame.setResizable(false);		// TCYύXs
		frame.setLocation(30, 30);
		frame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);		// Ȃ悤ɂ
//		frame.setUndecorated(true);		// t[̗̑LƖ؂ւ
		frame.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);	 // Ȃ
		frame.setVisible(false);
	}

	/**
	 * EBhẺEsݒ肵܂B
	 * @clientFrame ˗̃EBhE
	 * @param visible EBhẺEs
	 */
	public void setVisible(JXFrame clientFrame, boolean visible) {
		/* ʒuݒ */
		Dimension dim = clientFrame.getToolkit().getScreenSize();
		frame.setLocation((dim.width - frame.getBounds().width)/ 2 , (dim.height - frame.getBounds().height) / 2);

		/* EBhE\ */
		frame.setVisible(visible);
		
		if (visible) {
			frame.toFront();
			frame.repaint(10);
			label.paintImmediately(label.getBounds());		// \΍
		}
	}
}
