package fantastikk.gui.icon;

import java.util.HashMap;
import java.util.Map;

import javax.swing.ImageIcon;


/**
 * ACR񋟂NXłB
 * @author Takashi Nishikawa
 */
public class JXIconDepository {
	/** JXIconDepository IuWFNg */
	private static JXIconDepository depository;

	/** Ԃ\߂̕ */
	public static final String STATE_NONE = "";
	public static final String STATE_DISABLED = "_disabled";
	public static final String STATE_PRESSED = "_pressed";
	public static final String STATE_ROLLOVER = "_rollover";
	
	/** ACRi[}bv */
	private Map iconMap;

	/** ACR̃t@C */
	public static final String DEFAULT_IMAGE = "tool_bar_default_button";
	public static final String TOOL_BAR_CREATE_FRAME_IMAGE = "tool_bar_create_frame_button";
	public static final String TOOL_BAR_LOAD_PRESET_IMAGE = "tool_bar_load_preset_button";
	public static final String TOOL_BAR_SAVE_PRESET_IMAGE = "tool_bar_save_preset_button";
	public static final String TOOL_BAR_SAVE_AS_PRESET_IMAGE = "tool_bar_save_as_preset_button";
	public static final String TOOL_BAR_XML2FO_IMAGE = "tool_bar_xml2fo_button";
	public static final String TOOL_BAR_XML2PDF_IMAGE = "tool_bar_xml2pdf_button";
	public static final String TOOL_BAR_FO2PDF_IMAGE = "tool_bar_fo2pdf_button";
	public static final String TOOL_BAR_FO2RTF_IMAGE = "tool_bar_fo2rtf_button";
	public static final String TOOL_BAR_FO2AWT_IMAGE = "tool_bar_fo2awt_button";
	public static final String TOOL_BAR_XML2EPUB_IMAGE = "tool_bar_xml2epub_button";
	public static final String TOOL_BAR_CONFIG_IMAGE = "tool_bar_config_button";
	public static final String TOOL_BAR_CLEAR_LOG_IMAGE = "tool_bar_clear_log_button";
	public static final String FANTASTIKK_16PX = "16px";
	public static final String FANTASTIKK_32PX = "32px";
	public static final String FANTASTIKK_48PX = "48px";
	public static final String FANTASTIKK_128PX = "128px";

	/** ACRpt@C̊gq */
	public static final String EXT_PNG = ".png";
	
	/**
	 * RXgN^
	 */
	private JXIconDepository() {
		iconMap = new HashMap();

		iconMap.put(DEFAULT_IMAGE, new ImageIcon(getClass().getResource(DEFAULT_IMAGE + EXT_PNG)));
		iconMap.put(DEFAULT_IMAGE + STATE_DISABLED, new ImageIcon(getClass().getResource(DEFAULT_IMAGE + STATE_DISABLED + EXT_PNG)));
		iconMap.put(DEFAULT_IMAGE + STATE_PRESSED, new ImageIcon(getClass().getResource(DEFAULT_IMAGE + STATE_PRESSED + EXT_PNG)));
		iconMap.put(DEFAULT_IMAGE + STATE_ROLLOVER, new ImageIcon(getClass().getResource(DEFAULT_IMAGE + STATE_ROLLOVER + EXT_PNG)));
		iconMap.put(TOOL_BAR_CREATE_FRAME_IMAGE, new ImageIcon(getClass().getResource(TOOL_BAR_CREATE_FRAME_IMAGE + EXT_PNG)));
		iconMap.put(TOOL_BAR_CREATE_FRAME_IMAGE + STATE_DISABLED, new ImageIcon(getClass().getResource(TOOL_BAR_CREATE_FRAME_IMAGE + STATE_DISABLED + EXT_PNG)));
		iconMap.put(TOOL_BAR_CREATE_FRAME_IMAGE + STATE_PRESSED, new ImageIcon(getClass().getResource(TOOL_BAR_CREATE_FRAME_IMAGE + STATE_PRESSED + EXT_PNG)));
		iconMap.put(TOOL_BAR_CREATE_FRAME_IMAGE + STATE_ROLLOVER, new ImageIcon(getClass().getResource(TOOL_BAR_CREATE_FRAME_IMAGE + STATE_ROLLOVER + EXT_PNG)));
		iconMap.put(TOOL_BAR_LOAD_PRESET_IMAGE, new ImageIcon(getClass().getResource(TOOL_BAR_LOAD_PRESET_IMAGE + EXT_PNG)));
		iconMap.put(TOOL_BAR_LOAD_PRESET_IMAGE + STATE_DISABLED, new ImageIcon(getClass().getResource(TOOL_BAR_LOAD_PRESET_IMAGE + STATE_DISABLED + EXT_PNG)));
		iconMap.put(TOOL_BAR_LOAD_PRESET_IMAGE + STATE_PRESSED, new ImageIcon(getClass().getResource(TOOL_BAR_LOAD_PRESET_IMAGE + STATE_PRESSED + EXT_PNG)));
		iconMap.put(TOOL_BAR_LOAD_PRESET_IMAGE + STATE_ROLLOVER, new ImageIcon(getClass().getResource(TOOL_BAR_LOAD_PRESET_IMAGE + STATE_ROLLOVER + EXT_PNG)));
		iconMap.put(TOOL_BAR_SAVE_PRESET_IMAGE, new ImageIcon(getClass().getResource(TOOL_BAR_SAVE_PRESET_IMAGE + EXT_PNG)));
		iconMap.put(TOOL_BAR_SAVE_PRESET_IMAGE + STATE_DISABLED, new ImageIcon(getClass().getResource(TOOL_BAR_SAVE_PRESET_IMAGE + STATE_DISABLED + EXT_PNG)));
		iconMap.put(TOOL_BAR_SAVE_PRESET_IMAGE + STATE_PRESSED, new ImageIcon(getClass().getResource(TOOL_BAR_SAVE_PRESET_IMAGE + STATE_PRESSED + EXT_PNG)));
		iconMap.put(TOOL_BAR_SAVE_PRESET_IMAGE + STATE_ROLLOVER, new ImageIcon(getClass().getResource(TOOL_BAR_SAVE_PRESET_IMAGE + STATE_ROLLOVER + EXT_PNG)));
		iconMap.put(TOOL_BAR_SAVE_AS_PRESET_IMAGE, new ImageIcon(getClass().getResource(TOOL_BAR_SAVE_AS_PRESET_IMAGE + EXT_PNG)));
		iconMap.put(TOOL_BAR_SAVE_AS_PRESET_IMAGE + STATE_DISABLED, new ImageIcon(getClass().getResource(TOOL_BAR_SAVE_AS_PRESET_IMAGE + STATE_DISABLED + EXT_PNG)));
		iconMap.put(TOOL_BAR_SAVE_AS_PRESET_IMAGE + STATE_PRESSED, new ImageIcon(getClass().getResource(TOOL_BAR_SAVE_AS_PRESET_IMAGE + STATE_PRESSED + EXT_PNG)));
		iconMap.put(TOOL_BAR_SAVE_AS_PRESET_IMAGE + STATE_ROLLOVER, new ImageIcon(getClass().getResource(TOOL_BAR_SAVE_AS_PRESET_IMAGE + STATE_ROLLOVER + EXT_PNG)));
		iconMap.put(TOOL_BAR_XML2FO_IMAGE, new ImageIcon(getClass().getResource(TOOL_BAR_XML2FO_IMAGE + EXT_PNG)));
		iconMap.put(TOOL_BAR_XML2FO_IMAGE + STATE_DISABLED, new ImageIcon(getClass().getResource(TOOL_BAR_XML2FO_IMAGE + STATE_DISABLED + EXT_PNG)));
		iconMap.put(TOOL_BAR_XML2FO_IMAGE + STATE_PRESSED, new ImageIcon(getClass().getResource(TOOL_BAR_XML2FO_IMAGE + STATE_PRESSED + EXT_PNG)));
		iconMap.put(TOOL_BAR_XML2FO_IMAGE + STATE_ROLLOVER, new ImageIcon(getClass().getResource(TOOL_BAR_XML2FO_IMAGE + STATE_ROLLOVER + EXT_PNG)));
		iconMap.put(TOOL_BAR_XML2PDF_IMAGE, new ImageIcon(getClass().getResource(TOOL_BAR_XML2PDF_IMAGE + EXT_PNG)));
		iconMap.put(TOOL_BAR_XML2PDF_IMAGE + STATE_DISABLED, new ImageIcon(getClass().getResource(TOOL_BAR_XML2PDF_IMAGE + STATE_DISABLED + EXT_PNG)));
		iconMap.put(TOOL_BAR_XML2PDF_IMAGE + STATE_PRESSED, new ImageIcon(getClass().getResource(TOOL_BAR_XML2PDF_IMAGE + STATE_PRESSED + EXT_PNG)));
		iconMap.put(TOOL_BAR_XML2PDF_IMAGE + STATE_ROLLOVER, new ImageIcon(getClass().getResource(TOOL_BAR_XML2PDF_IMAGE + STATE_ROLLOVER + EXT_PNG)));
		iconMap.put(TOOL_BAR_FO2PDF_IMAGE, new ImageIcon(getClass().getResource(TOOL_BAR_FO2PDF_IMAGE + EXT_PNG)));
		iconMap.put(TOOL_BAR_FO2PDF_IMAGE + STATE_DISABLED, new ImageIcon(getClass().getResource(TOOL_BAR_FO2PDF_IMAGE + STATE_DISABLED + EXT_PNG)));
		iconMap.put(TOOL_BAR_FO2PDF_IMAGE + STATE_PRESSED, new ImageIcon(getClass().getResource(TOOL_BAR_FO2PDF_IMAGE + STATE_PRESSED + EXT_PNG)));
		iconMap.put(TOOL_BAR_FO2PDF_IMAGE + STATE_ROLLOVER, new ImageIcon(getClass().getResource(TOOL_BAR_FO2PDF_IMAGE + STATE_ROLLOVER + EXT_PNG)));
		iconMap.put(TOOL_BAR_FO2RTF_IMAGE, new ImageIcon(getClass().getResource(TOOL_BAR_FO2RTF_IMAGE + EXT_PNG)));
		iconMap.put(TOOL_BAR_FO2RTF_IMAGE + STATE_DISABLED, new ImageIcon(getClass().getResource(TOOL_BAR_FO2RTF_IMAGE + STATE_DISABLED + EXT_PNG)));
		iconMap.put(TOOL_BAR_FO2RTF_IMAGE + STATE_PRESSED, new ImageIcon(getClass().getResource(TOOL_BAR_FO2RTF_IMAGE + STATE_PRESSED + EXT_PNG)));
		iconMap.put(TOOL_BAR_FO2RTF_IMAGE + STATE_ROLLOVER, new ImageIcon(getClass().getResource(TOOL_BAR_FO2RTF_IMAGE + STATE_ROLLOVER + EXT_PNG)));
		iconMap.put(TOOL_BAR_FO2AWT_IMAGE, new ImageIcon(getClass().getResource(TOOL_BAR_FO2AWT_IMAGE + EXT_PNG)));
		iconMap.put(TOOL_BAR_FO2AWT_IMAGE + STATE_DISABLED, new ImageIcon(getClass().getResource(TOOL_BAR_FO2AWT_IMAGE + STATE_DISABLED + EXT_PNG)));
		iconMap.put(TOOL_BAR_FO2AWT_IMAGE + STATE_PRESSED, new ImageIcon(getClass().getResource(TOOL_BAR_FO2AWT_IMAGE + STATE_PRESSED + EXT_PNG)));
		iconMap.put(TOOL_BAR_FO2AWT_IMAGE + STATE_ROLLOVER, new ImageIcon(getClass().getResource(TOOL_BAR_FO2AWT_IMAGE + STATE_ROLLOVER + EXT_PNG)));
		iconMap.put(TOOL_BAR_XML2EPUB_IMAGE, new ImageIcon(getClass().getResource(TOOL_BAR_XML2EPUB_IMAGE + EXT_PNG)));
		iconMap.put(TOOL_BAR_XML2EPUB_IMAGE + STATE_DISABLED, new ImageIcon(getClass().getResource(TOOL_BAR_XML2EPUB_IMAGE + STATE_DISABLED + EXT_PNG)));
		iconMap.put(TOOL_BAR_XML2EPUB_IMAGE + STATE_PRESSED, new ImageIcon(getClass().getResource(TOOL_BAR_XML2EPUB_IMAGE + STATE_PRESSED + EXT_PNG)));
		iconMap.put(TOOL_BAR_XML2EPUB_IMAGE + STATE_ROLLOVER, new ImageIcon(getClass().getResource(TOOL_BAR_XML2EPUB_IMAGE + STATE_ROLLOVER + EXT_PNG)));
		iconMap.put(TOOL_BAR_CONFIG_IMAGE, new ImageIcon(getClass().getResource(TOOL_BAR_CONFIG_IMAGE + EXT_PNG)));
		iconMap.put(TOOL_BAR_CONFIG_IMAGE + STATE_DISABLED, new ImageIcon(getClass().getResource(TOOL_BAR_CONFIG_IMAGE + STATE_DISABLED + EXT_PNG)));
		iconMap.put(TOOL_BAR_CONFIG_IMAGE + STATE_PRESSED, new ImageIcon(getClass().getResource(TOOL_BAR_CONFIG_IMAGE + STATE_PRESSED + EXT_PNG)));
		iconMap.put(TOOL_BAR_CONFIG_IMAGE + STATE_ROLLOVER, new ImageIcon(getClass().getResource(TOOL_BAR_CONFIG_IMAGE + STATE_ROLLOVER + EXT_PNG)));
		iconMap.put(TOOL_BAR_CLEAR_LOG_IMAGE, new ImageIcon(getClass().getResource(TOOL_BAR_CLEAR_LOG_IMAGE + EXT_PNG)));
		iconMap.put(TOOL_BAR_CLEAR_LOG_IMAGE + STATE_DISABLED, new ImageIcon(getClass().getResource(TOOL_BAR_CLEAR_LOG_IMAGE + STATE_DISABLED + EXT_PNG)));
		iconMap.put(TOOL_BAR_CLEAR_LOG_IMAGE + STATE_PRESSED, new ImageIcon(getClass().getResource(TOOL_BAR_CLEAR_LOG_IMAGE + STATE_PRESSED + EXT_PNG)));
		iconMap.put(TOOL_BAR_CLEAR_LOG_IMAGE + STATE_ROLLOVER, new ImageIcon(getClass().getResource(TOOL_BAR_CLEAR_LOG_IMAGE + STATE_ROLLOVER + EXT_PNG)));
		iconMap.put(FANTASTIKK_16PX, new ImageIcon(getClass().getResource(FANTASTIKK_16PX + EXT_PNG)));
		iconMap.put(FANTASTIKK_32PX, new ImageIcon(getClass().getResource(FANTASTIKK_32PX + EXT_PNG)));
		iconMap.put(FANTASTIKK_48PX, new ImageIcon(getClass().getResource(FANTASTIKK_48PX + EXT_PNG)));
		iconMap.put(FANTASTIKK_128PX, new ImageIcon(getClass().getResource(FANTASTIKK_128PX + EXT_PNG)));
	}

	/**
	 * JXIconDepository IuWFNgԂ܂
	 * @return JXIconDepository IuWFNg
	 */
	public static JXIconDepository getInstance() {
		if (depository == null) {
			depository = new JXIconDepository();
		}

		return depository;
	}

	/**
	 * ACRԂ܂B
	 * @param name ACR̖O
	 * @param state  (STATE_NONE, STATE_DISABLED, STATE_PRESSED, STATE_ROLLOVER)
	 * @return ACR
	 */
	public ImageIcon getIcon(String name, String state) {
		if (iconMap.containsKey(name + state)) {
			return (ImageIcon)iconMap.get(name + state);
		} else if (iconMap.containsKey(name + STATE_NONE)) {
			return (ImageIcon)iconMap.get(name + STATE_NONE);
		} else {
			return (ImageIcon)iconMap.get(DEFAULT_IMAGE + state);
		}
	}
}
