package fantastikk.gui.panel;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.Icon;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.ListSelectionModel;
import javax.swing.colorchooser.AbstractColorChooserPanel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import fantastikk.CMYKColorValues;
import fantastikk.properties.JXPropertyDepository;
import fantastikk.util.ColorUtility;

/**
 * OŐFI邽߂ ColorChooserPanel łB
 * @author Takashi Nishikawa
 */
public class JXColorNameColorChooserPanel extends AbstractColorChooserPanel {
	/** ftHgEVAEo[W ID */
	private static final long serialVersionUID = 1L;

	/** GUI R|[lg */
	private JPanel innerPanel;
	private JList list;
	private JScrollPane scrollPane;

	/**
	 * `[UplV\z܂B
	 */
	protected void buildChooser() {
		if (innerPanel != null) {
			return;
		}

		list = new JList(ColorUtility.colorNameTable);
		list.setFixedCellWidth(300);
		list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

		list.addListSelectionListener(new ListSelectionListener() {
			/**
			 *  I͈͓̒lύXꂽƂɌĂяo܂B
			 *  @param lse ύXLqCxg
			 */
			public void valueChanged(ListSelectionEvent lse) {
				if (!lse.getValueIsAdjusting()) {
					updateColorSelectionModelColor();
				}
			}
		});

		scrollPane = new JScrollPane(list);
		innerPanel = new JPanel();
		this.add(innerPanel);

		GridBagLayout gb = new GridBagLayout();
		innerPanel.setLayout(gb);
		GridBagConstraints c = new GridBagConstraints();
		c.insets = new Insets(0, 0, 0, 0);		// R|[lgԂ̌

		c.gridx = 0;
		c.gridy = 0;
		c.fill = GridBagConstraints.BOTH;
		c.anchor = GridBagConstraints.EAST;
		c.weightx = 100.0;
		c.weighty = 100.0;
		gb.setConstraints(scrollPane, c);
		innerPanel.add(scrollPane);
	}

	/**
	 * pl̕\i[镶Ԃ܂B
	 * @return \pl̖O
	 */
	public String getDisplayName() {
		return JXPropertyDepository.getInstance().getString(JXPropertyDepository.PROPERTIES_LABEL, "chooser_color_name_title");
	}

	/**
	 * pl̑傫ȕ\ACRԂ܂B
	 * @return 傫ȕ\ACR
	 */
	public Icon getLargeDisplayIcon() {
		return null;
	}

	/**
	 * pl̏ȕ\ACRԂ܂B
	 * @return ȕ\ACR
	 */
	public Icon getSmallDisplayIcon() {
		return null;
	}

	/**
	 * f̏ԂύXƎIɌĂяo܂B
	 */
	public void updateChooser() {
	}

	/**
	 * ColorSelectionModel ̐FXV܂B
	 */
	private void updateColorSelectionModelColor() {
		if (list != null && !list.isSelectionEmpty()) {
			CMYKColorValues values = 
				ColorUtility.getCMYKColorValues(ColorUtility.colorNameTable[list.getSelectedIndex()], new float[] {0.0f, 0.0f, 0.0f, 0.0f});
			
			getColorSelectionModel().setSelectedColor(values.getColor());
		}
	}

	/**
	 * F̖Oݒ肵܂B
	 * @param colorName F̖O
	 */
	public void setColorName(String colorName) {
		list.clearSelection();

		if (colorName != null) {
			for (int i = 0; i < ColorUtility.colorNameTable.length; i++) {
				if (colorName.equals(ColorUtility.colorNameTable[i])) {
					list.setSelectedIndex(i);
					list.ensureIndexIsVisible(i);
					break;
				}
			}
		}
	}
}
