package fantastikk.gui.panel;

import java.awt.Component;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.math.BigDecimal;

import javax.swing.Box;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JSpinner;
import javax.swing.JTextField;
import javax.swing.SpinnerNumberModel;
import javax.swing.SwingConstants;
import javax.swing.JSpinner.DefaultEditor;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;


import org.w3c.dom.Element;

import fantastikk.properties.JXPropertyDepository;
import fantastikk.util.PatternUtility;
import fantastikk.util.UnitUtility;

/**
 * l͗p̃plłB
 * @author Takashi Nishikawa
 */
public class JXNumberValuePanel extends JXAbstractValuePanel {
	/** ftHgEVAEo[W ID */
	private static final long serialVersionUID = 1L;

	/** lǂ */
	private boolean isInteger = false;

	/** ől */
	private double maxValue = 0;

	/** ŏl */
	private double minValue = 0;

	/** Xebvl */
	private double stepValue = 1.0;

	/** ڐ */
	private static final int stepLimit = 256;

	/** ftHg̒l */
	private double defaultValue = 0;

	/** Pʂ̏l */
	protected String initialSelectedUnit = "";

	/** ύXO̒l (comboBox̓͒lɎgp) */
	private double previousValue;

	/** Il̕ύXm[hɔfꍇ true (ʏ falseÃplǋL\ȃXg̔z̏ꍇ true) */
	private boolean alterable = false;

	/** GUI i */
	private DefaultComboBoxModel comboBoxModel;
	private JComboBox comboBox;
	private JComponent component;
	private JComponent unitComponent;
	private JLabel label;
	private JLabel unitLabel;
	private JComboBox unitComboBox;
	private JSpinner spinner;
	private SpinnerNumberModel spinnerModel;

	/**
	 * RXgN^
	 * @param element Element
	 */
	public JXNumberValuePanel(Element element) {
		this(element, NORMAL_SIZE);
	}

	/**
	 * RXgN^
	 * @param element Element
	 * @param int TCY̏
	 */
	public JXNumberValuePanel(Element element, int size) {
		super();
		super.element = element;
		super.size = size;
		createGUI();
	}

	/**
	 * GUI 쐻܂B
	 */
	private void createGUI() {
		JXPropertyDepository propertyDepository = JXPropertyDepository.getInstance();

		initialSelectedValue = element.getAttribute("selected");
		String labelStr = element.getAttribute("label");
		String unitStr = element.getAttribute("unit");
		String typeStr = element.getAttribute("type");
		initialSelectedUnit = element.getAttribute("selected-unit");
		Number stepSizeObj = null;

		try {
			minValue = Double.parseDouble(element.getAttribute("min"));
		} catch (NumberFormatException nfe) {
			nfe.printStackTrace();
		}

		try {
			maxValue = Double.parseDouble(element.getAttribute("max"));
		} catch (NumberFormatException nfe) {
			nfe.printStackTrace();
		}

		try {
			if (typeStr.equals("spinner")) {
				stepSizeObj = UnitUtility.getStepValue(unitStr, initialSelectedUnit);
				stepValue = stepSizeObj.doubleValue();
			} else {
				stepValue = Double.parseDouble(element.getAttribute("step"));
			}
		} catch (NumberFormatException nfe) {
			nfe.printStackTrace();
		}

		try {
			defaultValue = Double.parseDouble(element.getAttribute("selected"));
		} catch (NumberFormatException nfe) {
			nfe.printStackTrace();
		}

		/* ŏlAőlAXebvlAݒl̏ꍇ͐lƂĈ */
		try {
			this.isInteger = false;
			Integer.parseInt(element.getAttribute("min"));
			Integer.parseInt(element.getAttribute("max"));
			Integer.parseInt(element.getAttribute("selected"));

			if (typeStr.equals("spinner")) {
				this.isInteger = stepSizeObj instanceof Integer;
			} else {
				Integer.parseInt(element.getAttribute("step"));
				this.isInteger = true;
			}
		} catch (NumberFormatException nfe) {
//			nfe.printStackTrace();
		}

		if (maxValue < minValue) {
			maxValue = minValue;
		}

		if (defaultValue < minValue) {
			defaultValue = minValue;
		}

		if (defaultValue > maxValue) {
			defaultValue = maxValue;
		}

		label = new JLabel(labelStr);
		label.setPreferredSize(LABEL_SIZE[size]);

		/* c[`bv̐ݒ */
		String toolTipTextStr = element.getAttribute("tooltip-text");

		if (toolTipTextStr != null && !toolTipTextStr.equals("")) {
			label.setToolTipText(toolTipTextStr);
		}

		previousValue = defaultValue;

		/* type ɂXsiR{{bNX쐻 */
		if (typeStr.equals("spinner")) {
			try {
				if (isInteger) {
					spinnerModel = new SpinnerNumberModel((int)defaultValue, (int)minValue, (int)maxValue, (int)stepValue);
				} else {
					spinnerModel = new SpinnerNumberModel(defaultValue, minValue, maxValue, stepValue);
				}

				spinner = new JSpinner(spinnerModel);

				/* tH[JXXiݒ */
				(((DefaultEditor)(spinner.getEditor())).getTextField()).addFocusListener(new JXNumberFocusListener());
			} catch (IllegalArgumentException iae) {
				iae.printStackTrace();
			} finally {
				if (spinner == null) {
					spinner = new JSpinner();
				}

				spinner.addChangeListener(new JXNumberSpinnerChangeListener());
				spinner.setPreferredSize(INT_INPUT_SIZE[size]);
				component = spinner;
			}
		} else {
			comboBoxModel = new DefaultComboBoxModel();

			if (isInteger) {
				int endValue = (int)stepValue * stepLimit;

				for (int i = (int)minValue; (i <= (int)maxValue) && (i < endValue); i += (int)stepValue) {	// ől܂
					comboBoxModel.addElement("" + i);
				}
			} else {
				try {
					/* double ƉŽʂsRȂ̂ BigDecimal gp */
					BigDecimal labelBDValue = new BigDecimal("" + minValue);
					BigDecimal stepBDValue = new BigDecimal("" + stepValue);

					double endValue = stepValue * (double)stepLimit;

					for (double d = 0.0; (labelBDValue.doubleValue() <= maxValue) && (d < endValue); d += stepValue) {	// ől܂
						comboBoxModel.addElement("" + labelBDValue.doubleValue());
						labelBDValue = labelBDValue.add(stepBDValue);
					}
				} catch (NumberFormatException nfe) {
					nfe.printStackTrace();
				}
			}

			comboBox = new JComboBox(comboBoxModel);

			if (isInteger) {
				comboBox.setSelectedItem("" + (int)defaultValue);
			} else {
				comboBox.setSelectedItem("" + defaultValue);
			}

			((JTextField)comboBox.getEditor().getEditorComponent()).setHorizontalAlignment(SwingConstants.RIGHT);

			/* tH[JXXiݒ */
			((JTextField)comboBox.getEditor().getEditorComponent()).addFocusListener(new JXNumberFocusListener());

			comboBox.setEditable(true);		// ҏW\ɂ
			component = comboBox;
			comboBox.addItemListener(new JXNumberComboBoxItemListener());		// ͒l^Ilێp̃Xi
			comboBox.setPreferredSize(INT_INPUT_SIZE[size]);
		}

		/* Pʕ\𐶐 */
		String[] unitStrArray = unitStr.split("\\s*,\\s*");

		if (unitStrArray.length == 1) {
			unitLabel = new JLabel(unitStr.trim());
			unitLabel.setPreferredSize(UNIT_SIZE[size]);
			unitComponent = unitLabel;
		} else {
			DefaultComboBoxModel model = new DefaultComboBoxModel();

			for (int i = 0; i < unitStrArray.length; i++) {
				model.addElement(unitStrArray[i]);
			}

			model.setSelectedItem(unitStrArray[0]);

			for (int i = 0; i < unitStrArray.length; i++) {
				if (unitStrArray[i].equals(initialSelectedUnit)) {
					model.setSelectedItem(unitStrArray[i]);
				}
			}

			unitComboBox = new JComboBox(model);
			unitComboBox.addItemListener(new JXUnitComboBoxItemListener());		// Ilێp̃Xi
			unitComboBox.setPreferredSize(UNIT_SIZE[size]);
			unitComponent = unitComboBox;
		}

		/* ǂ擾 (ftHg͉) */
		boolean visible = PatternUtility.PATTERN_NO_OR_FALSE.matcher(element.getAttribute("visible")).matches() ? false : true;

		if (visible) {
			GridBagLayout gb = new GridBagLayout();
			this.setLayout(gb);
			GridBagConstraints c = new GridBagConstraints();
			c.insets = new Insets(0, 20, 0, 0);		// R|[lgԂ̌

			c.gridx = 0;
			c.gridy = 0;
			c.fill = GridBagConstraints.HORIZONTAL;
			c.anchor = GridBagConstraints.EAST;
			c.weightx = 50.0;
			c.weighty = 0.0;
			gb.setConstraints(label, c);

			if (size != COMPLEX_CHILD_SIZE) {
				this.add(label);
			}

			c.gridx = 1;
//			c.gridy = 0;
//			c.fill = GridBagConstraints.HORIZONTAL;
			c.anchor = GridBagConstraints.EAST;
			c.weightx = 25.0;
			c.weighty = 0.0;
			gb.setConstraints(component, c);
			this.add(component);

			c.gridx = 2;
//			c.gridy = 0;
			c.fill = GridBagConstraints.NONE;
			c.anchor = GridBagConstraints.WEST;
			c.weightx = 15.0;
			c.weighty = 0.0;
			gb.setConstraints(unitComponent, c);
			this.add(unitComponent);

			if (size != APPENDLIST_CHILD_SIZE) {
				Component spacer = Box.createHorizontalStrut(10);

				c.gridx = 3;
//				c.gridy = 0;
				c.fill = GridBagConstraints.NONE;
				c.anchor = GridBagConstraints.WEST;
				c.weightx = 10.0;
				c.weighty = 0.0;
				gb.setConstraints(spacer, c);
				this.add(spacer);
			}
		} else {
			this.setVisible(visible);
		}

		/* ҏW\擾 (ftHg͕ҏW\) */
		boolean editable = PatternUtility.PATTERN_NO_OR_FALSE.matcher(element.getAttribute("editable")).matches() ? false : true;
		component.setEnabled(editable);

		if (unitComboBox != null) {
			unitComboBox.setEnabled(editable);
		}

		if (!editable) {
			component.setToolTipText(propertyDepository.getString(JXPropertyDepository.PROPERTIES_LABEL, "can_not_change"));

			if (unitComboBox != null) {
				unitComboBox.setToolTipText(propertyDepository.getString(JXPropertyDepository.PROPERTIES_LABEL, "can_not_change"));
			}
		}
	}

	/**
	 * Il̕ύXm[hɔf邩ǂݒ肵܂B
	 * @param Il̕ύXm[hɔfꍇ true
	 */
	public void setAlterable(boolean alterable) {
		/* ҏWs̏ꍇ͔fȂĂ悢 */
		this.alterable = PatternUtility.PATTERN_NO_OR_FALSE.matcher(element.getAttribute("editable")).matches() ? false : alterable;
	}

	/**
	 * GUI őIꂽl DOM m[h ɔf܂B
	 */
	public void updateNodeStatus() {
		String currentValue = "";
		String currentUnit = "";

		if (component == spinner) {
			currentValue = spinner.getValue().toString();
		} else if (component == comboBox) {
			currentValue = (String)comboBox.getSelectedItem();
		}

		if (unitComponent == unitLabel) {
			currentUnit = unitLabel.getText();
		} else if (unitComponent == unitComboBox) {
			currentUnit = (String)unitComboBox.getSelectedItem();
		}

		if (element != null) {
			element.setAttribute("selected", currentValue);
			element.setAttribute("selected-unit", currentUnit);
		}
	}

	/**
	 * DOM m[h̏Ԃɖ߂܂B
	 */
	public void setBackNodeStatus() {
		super.setBackNodeStatus();

		if (element != null) {
			element.setAttribute("selected-unit", initialSelectedUnit);
		}
	}

	/**
	 * ҏW^s؂ւ܂B
	 * @param editable ҏW (true) ܂͕s (false)
	 */
	public void setEditable(boolean editable) {
		if (!PatternUtility.PATTERN_NO_OR_FALSE.matcher(element.getAttribute("editable")).matches()) {
			component.setEnabled(editable);

			if (unitComboBox != null) {
				unitComboBox.setEnabled(editable);
			}
		}
	}

	/**
	 * Xsi̓͒l`FbNm肵܂B
	 * @param value ͒l
	 */
	public void checkAndFixSpinnerValue(String value) {
		/* ͒llŁAŏlől͈̔͂ɂ邱Ƃ`FbN */
		if (isInteger) {
			try {
				int newValue = Integer.parseInt(value);

				if (newValue < minValue || newValue > maxValue) {
					/* O̒lɖ߂ */
					spinner.setValue(new Integer((int)previousValue));
					(((DefaultEditor)(spinner.getEditor())).getTextField()).setText("" + (int)previousValue);
				} else {
					spinner.setValue(new Integer(newValue));
					previousValue = newValue;

					if (alterable && !PatternUtility.PATTERN_NO_OR_FALSE.matcher(element.getAttribute("editable")).matches()) {
						element.setAttribute("selected", value);
					}
				}
			} catch (NumberFormatException nfe) {
				/* O̒lɖ߂ */
				spinner.setValue(new Integer((int)previousValue));
				(((DefaultEditor)(spinner.getEditor())).getTextField()).setText("" + (int)previousValue);
			}
		} else {
			try {
				double newValue = Double.parseDouble(value);

				if (newValue < minValue || newValue > maxValue) {
					/* O̒lɖ߂ */
					spinner.setValue(new Double(previousValue));
					(((DefaultEditor)(spinner.getEditor())).getTextField()).setText("" + previousValue);
				} else {
					spinner.setValue(new Double(newValue));
					previousValue = newValue;

					if (alterable && !PatternUtility.PATTERN_NO_OR_FALSE.matcher(element.getAttribute("editable")).matches()) {
						element.setAttribute("selected", value);
					}
				}
			} catch (NumberFormatException nfe) {
				/* O̒lɖ߂ */
				spinner.setValue(new Double(previousValue));
				(((DefaultEditor)(spinner.getEditor())).getTextField()).setText("" + previousValue);
			}
		}
	}

	/**
	 * R{{bNX̓͒l`FbNm肵܂B
	 * @param value ͒l
	 */
	public void checkAndFixComboBoxValue(String value) {
		/* ͒llŁAŏlől͈̔͂ɂ邱Ƃ`FbN */
		if (isInteger) {
			try {
				int newValue = Integer.parseInt(value);

				if (newValue < minValue || newValue > maxValue) {
					/* O̒lɖ߂ */
					comboBoxModel.setSelectedItem("" + (int)previousValue);
					((JTextField)comboBox.getEditor().getEditorComponent()).setText("" + (int)previousValue);
				} else {
					comboBoxModel.setSelectedItem("" + newValue);
					previousValue = newValue;

					if (alterable && !PatternUtility.PATTERN_NO_OR_FALSE.matcher(element.getAttribute("editable")).matches()) {
						element.setAttribute("selected", value);
					}
				}
			} catch (NumberFormatException nfe) {
				/* O̒lɖ߂ */
				comboBoxModel.setSelectedItem("" + (int)previousValue);
				((JTextField)comboBox.getEditor().getEditorComponent()).setText("" + (int)previousValue);
			}
		} else {
			try {
				double newValue = Double.parseDouble(value);

				if (newValue < minValue || newValue > maxValue) {
					/* O̒lɖ߂ */
					comboBoxModel.setSelectedItem("" + previousValue);
					((JTextField)comboBox.getEditor().getEditorComponent()).setText("" + previousValue);
				} else {
					comboBoxModel.setSelectedItem("" + newValue);
					previousValue = newValue;

					if (alterable && !PatternUtility.PATTERN_NO_OR_FALSE.matcher(element.getAttribute("editable")).matches()) {
						element.setAttribute("selected", value);
					}
				}
			} catch (NumberFormatException nfe) {
				/* O̒lɖ߂ */
				comboBoxModel.setSelectedItem("" + previousValue);
				((JTextField)comboBox.getEditor().getEditorComponent()).setText("" + previousValue);
			}
		}
	}

	/**
	 * ItemEvent NX (Il̃m[hւ̔fp)
	 * @author Takashi Nishikawa
	 */
	class JXUnitComboBoxItemListener implements ItemListener {
		/**
		 * [UɂčڂI܂͑IꂽƂɌĂяo܂B
		 * @param ie ڂI܂͑IꂽƂCxg
		 */
		public void itemStateChanged(ItemEvent ie) {
			if (!PatternUtility.PATTERN_NO_OR_FALSE.matcher(element.getAttribute("editable")).matches()) {
				String selectedUnit = (String)unitComboBox.getSelectedItem();
				Number stepSizeObj = UnitUtility.getStepValue(selectedUnit);
				stepValue = stepSizeObj.doubleValue();
				isInteger = stepSizeObj instanceof Integer;

				/* GUI ɂXebvlƌݒlύX */
				Number currentValue = (Number)spinner.getValue();

				if (isInteger) {
					spinnerModel = new SpinnerNumberModel(currentValue.intValue(), (int)minValue, (int)maxValue, (int)stepValue);
				} else {
					spinnerModel = new SpinnerNumberModel(currentValue.doubleValue(), minValue, maxValue, stepValue);
				}

				spinner.setModel(spinnerModel);

				if (alterable) {
					element.setAttribute("selected-unit", selectedUnit);
				}
			}
		}
	}

	/**
	 * ItemEvent NX (͒lAIl̃m[hւ̔fp)
	 * @author Takashi Nishikawa
	 */
	class JXNumberComboBoxItemListener implements ItemListener {
		/**
		 * [UɂčڂI܂͑IꂽƂɌĂяo܂B
		 * @param ie ڂI܂͑IꂽƂCxg
		 */
		public void itemStateChanged(ItemEvent ie) {
			/* R{{bNX̓͒l`FbNm */
			checkAndFixComboBoxValue((String)comboBox.getSelectedItem());
		}
	}

	/**
	 * ChangeEvent NX (Il̃m[hւ̔fp)
	 * @author Takashi Nishikawa
	 */
	class JXNumberSpinnerChangeListener implements ChangeListener {
		/**
		 * Xi[̑Ώۂ̏ԂύXꂽƂɌĂяo܂B
		 * @param ce ChangeEvent
		 */
		public void stateChanged(ChangeEvent ce) {
			if (alterable && !PatternUtility.PATTERN_NO_OR_FALSE.matcher(element.getAttribute("editable")).matches()) {
				element.setAttribute("selected", spinner.getValue().toString());
			}
		}
	}

	/**
	 * L[{[htH[JXCxg󂯎܂B(͗ɃtH[JXƂꂪfȂ߂̑΍)
	 * @author Takashi Nishikawa
	 */
	private class JXNumberFocusListener implements FocusListener {
		/**
		 * RXgN^
		 */
		public JXNumberFocusListener() {
			super();
		}

		/**
		 * R|[lgL[{[htH[JX擾ƌĂяo܂B
		 * @param fe L[{[htH[JXCxg
		 */
		public void focusGained(FocusEvent fe) {
			/* Ȃ */
		}

		/**
		 * R|[lgL[{[htH[JXƌĂяo܂B
		 * @param fe L[{[htH[JXCxg
		 */
		public void focusLost(FocusEvent fe) {
			/* Xsi܂̓R{{bNX̓̃eLXgtB[h̓͒l */
			String valueOfEditorStr = "";

			if (component == spinner) {
				valueOfEditorStr = (((DefaultEditor)(spinner.getEditor())).getTextField()).getText();

				if (valueOfEditorStr == null || !valueOfEditorStr.equals(spinner.getValue().toString())) {
					/* Xsi̓͒l`FbNm */
					checkAndFixSpinnerValue(valueOfEditorStr);
				}

			} else if (component == comboBox) {
				valueOfEditorStr = ((JTextField)comboBox.getEditor().getEditorComponent()).getText();

				if (valueOfEditorStr == null || !valueOfEditorStr.equals((String)comboBox.getSelectedItem())) {
					/* R{{bNX̓͒l`FbNm */
					checkAndFixComboBoxValue(valueOfEditorStr);
				}
			}
		}
	}
}
