package fantastikk.proc.fo.fop;

import java.io.File;

import javax.xml.transform.Result;
import javax.xml.transform.Source;
import javax.xml.transform.Transformer;
import javax.xml.transform.sax.SAXResult;
import javax.xml.transform.stream.StreamSource;

import org.apache.fop.apps.FOUserAgent;
import org.apache.fop.apps.Fop;
import org.apache.fop.apps.MimeConstants;

import fantastikk.util.FileUtility;

/**
 * Apache FOP ɂ FO ̓e\鏈ʂ̃XbhŎs邽߂̃NXłB
 * @author Takashi Nishikawa
 */
public class JXFo2awtFOPProcess extends JXAbstractFopProcess {
	/**
	 * sȂ܂B
	 * @return ̐ (Atrue)
	 */
	protected boolean process() {
		/* ۃtO */
		boolean ret = false;

		Transformer transformer = null;
		Source src = null;
		Result res = null;

		try {
			FOUserAgent foUserAgent = fopFactory.newFOUserAgent();
			foUserAgent.setBaseURL(FileUtility.getDirectoryUrlPath(inputPath));	// 摜𑊑΃pXŎw肷̂ɕKv

			Fop fop = fopFactory.newFop(MimeConstants.MIME_FOP_AWT_PREVIEW, foUserAgent);
			transformer = tFactory.newTransformer();
			transformer.setErrorListener(errorListener);
			errorListener.setVerbose(true);

			src = new StreamSource(new File(inputPath));
			res = new SAXResult(fop.getDefaultHandler());

			/* FOP Jn */
			transformer.transform(src, res);
			ret = true;
		} catch (Throwable t) {
			setOccurrence(t);
		} finally {

			/* FOP ̃LbVNA */
			if (fopFactory != null) {
				fopFactory.getImageManager().getCache().clearCache();
			}

			transformer = null;
			src = null;
			res = null;
		}

		return ret;
	}
}
