package fantastikk.proc.fo.fop;

import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;

import javax.xml.transform.Result;
import javax.xml.transform.Source;
import javax.xml.transform.Transformer;
import javax.xml.transform.sax.SAXResult;
import javax.xml.transform.stream.StreamSource;

import org.apache.fop.apps.FOUserAgent;
import org.apache.fop.apps.Fop;
import org.apache.fop.apps.MimeConstants;

import fantastikk.util.FileUtility;

/**
 * Apache FOP ɂ FO  RTF ւ̕ϊʂ̃XbhŎs邽߂̃NXłB
 * @author Takashi Nishikawa
 */
public class JXFo2rtfFOPProcess extends JXAbstractFopProcess {
	/**
	 * sȂ܂B
	 * @return ̐ (Atrue)
	 */
	protected boolean process() {
		/* ۃtO */
		boolean ret = false;

		BufferedOutputStream bs = null;
		Transformer transformer = null;
		Source src = null;
		Result res = null;

		try {
			FOUserAgent foUserAgent = fopFactory.newFOUserAgent();
			foUserAgent.setBaseURL(FileUtility.getDirectoryUrlPath(inputPath));	// 摜𑊑΃pXŎw肷̂ɕKv

			bs = new BufferedOutputStream(new FileOutputStream(new File(outputPath)));

			Fop fop = fopFactory.newFop(MimeConstants.MIME_RTF, foUserAgent, bs);
			transformer = tFactory.newTransformer();
			transformer.setErrorListener(errorListener);
			errorListener.setVerbose(true);

			src = new StreamSource(new File(inputPath));
			res = new SAXResult(fop.getDefaultHandler());

			/* FOP Jn */
			transformer.transform(src, res);
			ret = true;
		} catch (Throwable t) {
			setOccurrence(t);
		} finally {
			if (bs != null) {
				try {
					bs.close();
				} catch (IOException ioe) {
				}
			}

			/* FOP ̃LbVNA */
			if (fopFactory != null) {
				fopFactory.getImageManager().getCache().clearCache();
			}

			bs = null;
			transformer = null;
			src = null;
			res = null;
		}

		return ret;
	}
}
