package fantastikk.proc.fo.fop;

import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;

import javax.xml.transform.Result;
import javax.xml.transform.Source;
import javax.xml.transform.Transformer;
import javax.xml.transform.sax.SAXResult;
import javax.xml.transform.stream.StreamSource;

import org.apache.fop.apps.FOUserAgent;
import org.apache.fop.apps.Fop;
import org.apache.fop.apps.MimeConstants;

import fantastikk.JXConfiguration;
import fantastikk.util.FileUtility;

/**
 * Apache FOP ɂ XML  PDF ւ̕ϊʂ̃XbhŎs邽߂̃NXłB
 * @author Takashi Nishikawa
 */
public class JXXml2pdfFOPProcess extends JXAbstractFopProcess {
	/**
	 * sȂ܂B
	 * @return ̐ (Atrue)
	 */
	protected boolean process() {
		/* ۃtO */
		boolean ret = false;

		/* o͌ʂ̈ꎞt@CpfBNg̃NA */
		FileUtility.clearDirectory(JXConfiguration.TMP_OUTPUT_PATH);

		/* ꎞt@C쐻 */
		File temporary = null;
		String temporaryFilePath = "";
		int num = 0;

		while (temporary == null || temporary.exists()) {
			temporaryFilePath = JXConfiguration.TMP_OUTPUT_PATH + File.separator + "temporary_file_" + (num++) +".fo";
			temporary = new File(temporaryFilePath);
		}

		/* XML  FO ւ̕ϊ (ʏ) */
		if (super.xml2xml(inputPath, temporaryFilePath)) {
			BufferedOutputStream bs = null;
			Transformer transformer = null;
			Source src = null;
			Result res = null;

			/* FOP ɂ PDF o */
			try {
				System.gc();

				FOUserAgent foUserAgent = fopFactory.newFOUserAgent();
				foUserAgent.setBaseURL(FileUtility.getDirectoryUrlPath(inputPath));	// 摜𑊑΃pXŎw肷̂ɕKv
				setRendererOptions(foUserAgent);	// o̓IvV̐ݒ

				bs = new BufferedOutputStream(new FileOutputStream(new File(outputPath)));

				Fop fop = fopFactory.newFop(MimeConstants.MIME_PDF, foUserAgent, bs);

				transformer = tFactory.newTransformer();
				transformer.setErrorListener(errorListener);
				errorListener.setVerbose(true);

				src = new StreamSource(temporary);
				res = new SAXResult(fop.getDefaultHandler());

				/* FOP Jn */
				transformer.transform(src, res);
				ret = true;
			} catch (Throwable t) {
				setOccurrence(t);
			} finally {
				if (bs != null) {
					try {
						bs.close();
					} catch (IOException ioe) {
					}
				}

				/* FOP ̃LbVNA */
				if (fopFactory != null) {
					fopFactory.getImageManager().getCache().clearCache();
				}

				bs = null;
				transformer = null;
				src = null;
				res = null;
			}
		}

		/* ꎞt@C폜 */
		if (temporary != null) {
			/* obNAbv폜 */
			temporary.delete();
			temporary = null;
		}

		return ret;
	}
}
