package fantastikk.proc.fo.xf;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;

import fantastikk.JXConfiguration;
import fantastikk.JXController;
import fantastikk.properties.JXPropertyDepository;
import fantastikk.util.FileUtility;

/**
 * AH Formatter ɂ XML  PDF ւ̕ϊʂ̃XbhŎs邽߂̃NXłB
 * @author Takashi Nishikawa
 */
public class JXXml2pdfXFProcess extends JXAbstractXFProcess {
	/**
	 * sȂ܂B
	 * @return ̐ (Atrue)
	 */
	protected boolean process() {
		/* ۃtO */
		boolean ret = false;

		/* AH Formatter CXg[fBNg */
		String xslFormatterDirectory = JXConfiguration.getInstance().getXslFormatterDirectory();

		/* o͌ʂ̈ꎞt@CpfBNg̃NA */
		FileUtility.clearDirectory(JXConfiguration.TMP_OUTPUT_PATH);

		/* ꎞt@C쐻 */
		File temporary = null;
		String temporaryFilePath = "";
		int num = 0;

		while (temporary == null || temporary.exists()) {
			temporaryFilePath = JXConfiguration.TMP_OUTPUT_PATH + File.separator + "temporary_file_" + (num++) +".fo";
			temporary = new File(temporaryFilePath);
		}

		/* XML  FO ւ̕ϊ (ʏ) */
		if (super.xml2xml(inputPath, temporaryFilePath)) {
			/* sR}h */
			StringBuffer comanndBuffer = new StringBuffer();
			comanndBuffer.append(xslFormatterDirectory);
			comanndBuffer.append(File.separator);

			/* R[h */
			final String code;

			/* Wo͂ƃG[o͂̓eobt@ */
			final StringBuffer buffer = new StringBuffer();

			String osName = System.getProperty("os.name");

			if(osName.indexOf("Windows") >= 0) {		// Windows ̏ꍇ
				/** Windows ̏ꍇ AH Formatter ( XSL Formatter) ̃o[WɂăR}hقȂ̂łŊmF */
				String exeFileName = null;

				for (int i = 0; i < EXEC_FILES.length; i++) {
					if (new File(xslFormatterDirectory + File.separator + EXEC_FILES[i]).exists()) {
						exeFileName = EXEC_FILES[i];
						break;
					}
				}

				if (exeFileName == null) {
					JXPropertyDepository propertyDepository = JXPropertyDepository.getInstance();
					String message_1 = propertyDepository.getString(JXPropertyDepository.PROPERTIES_LINE, "ah_formatter_exe_not_found_1");
					String message_2 = propertyDepository.getString(JXPropertyDepository.PROPERTIES_LINE, "ah_formatter_exe_not_found_2");
					setOccurrence(new FileNotFoundException(message_1 + xslFormatterDirectory + message_2));
					return ret;
				}

				code = "SJIS";
				comanndBuffer.append(exeFileName);
			} else {
				code = "UTF-8";
				comanndBuffer.append(RUN_SH);
			}

			comanndBuffer.append(" -d \"");
			comanndBuffer.append(temporaryFilePath);
			comanndBuffer.append("\" -o \"");
			comanndBuffer.append(outputPath);
			comanndBuffer.append("\" -base \"");
			comanndBuffer.append(inputPath);	// x[XURI
			comanndBuffer.append("\" -extlevel ");
			comanndBuffer.append("4");	// G[x 4:vIG[ꍇ
			setRendererOptions(comanndBuffer);	// o̓IvV̐ݒ
			command = comanndBuffer.toString();

			try {
				Process process = null;
				
				if(osName.indexOf("Windows") >= 0) {		// Windows ̏ꍇ
					process = Runtime.getRuntime().exec(command, null, new File(xslFormatterDirectory));
				} else {
					
					String[] cmdArray = {"/bin/sh", "-c", command};	// Runtime#exec ŎsAVFoRŎsȂƂȂs邽
					process = Runtime.getRuntime().exec(cmdArray);
				}

				final InputStream is = process.getInputStream();

				new Thread() {
					public void run() {
						BufferedReader br = null;
						String line;

						try {
							br = new BufferedReader(new InputStreamReader(is, code));  // ΍

							while ((line = br.readLine()) != null) {
								System.out.println(line);
								buffer.append(line);
								buffer.append("\n");
							}

							is.close();
						} catch (Exception e) {
							e.printStackTrace();
						} finally {
							if (br != null) {
								try {
									br.close();
								} catch (IOException e) {
									e.printStackTrace();
								}
							}
						}
					}
				}.start();

				final InputStream es = process.getErrorStream();

				new Thread() {
					public void run() {
						BufferedReader br = null;
						String line;

						try {
							br = new BufferedReader(new InputStreamReader(es, code));  // ΍

							while ((line = br.readLine()) != null) {
								System.out.println(line);
								buffer.append(line);
								buffer.append("\n");
						    }

							es.close();
						} catch (Exception e) {
							e.printStackTrace();
						} finally {
							if (br != null) {
								try {
									br.close();
								} catch (IOException e) {
									e.printStackTrace();
								}
							}
						}
					}
				}.start();

				process.waitFor();
				ret = (process.exitValue() == 0);
				process.destroy();
			} catch (Throwable t) {
				setOccurrence(t);
			} finally {
				JXController.getInstance().printMessage(buffer.toString(), false);
			}
		}

		/* ꎞt@C폜 */
		if (temporary != null) {
			/* obNAbv폜 */
			temporary.delete();
			temporary = null;
		}

		return ret;
	}
}
