package fantastikk.proc.fo.xf.jif;

import java.io.File;

import jp.co.antenna.XfoJavaCtl.XfoObj;
import jp.co.antenna.XfoJavaCtl.XfoException;

import fantastikk.JXConfiguration;
import fantastikk.proc.transform.JXXsltProcess;
import fantastikk.properties.JXPropertyDepository;
import fantastikk.util.FileUtility;

/**
 * AH Formatter (Java C^[tF[X) ɂ XML  PDF ւ̕ϊʂ̃XbhŎs邽߂̃NXłB
 * @author Takashi Nishikawa
 */
public class JXXml2pdfXFjProcess extends JXXsltProcess {
	/**
	 * sȂ܂B
	 * @return ̐ (Atrue)
	 */
	protected boolean process() {
		/* ۃtO */
		boolean ret = false;

		/* o͌ʂ̈ꎞt@CpfBNg̃NA */
		FileUtility.clearDirectory(JXConfiguration.TMP_OUTPUT_PATH);

		/* ꎞt@C쐻 */
		File temporary = null;
		String temporaryFilePath = "";
		int num = 0;

		while (temporary == null || temporary.exists()) {
			temporaryFilePath = JXConfiguration.TMP_OUTPUT_PATH + File.separator + "temporary_file_" + (num++) +".fo";
			temporary = new File(temporaryFilePath);
		}

		/* XML  FO ւ̕ϊ (ʏ) */
		if (super.xml2xml(inputPath, temporaryFilePath)) {
			XfoObj axfo = null;

			try {
				axfo = new XfoObj();
				JXXFjLogger logger = new JXXFjLogger();
				axfo.setMessageListener(logger);
				axfo.setDocumentURI(temporaryFilePath);
				axfo.setOutputFilePath(outputPath);
				axfo.setExitLevel(4);	// głŃG[ꍇ̏̒~A 4:vIG[ꍇ
				axfo.execute();
				ret = true;
			} catch (Throwable t) {
				setOccurrence(t);
			} finally {
				if (axfo != null) {
					try {
						axfo.releaseObjectEx();
					} catch (XfoException e) {
						JXPropertyDepository propertyDepository = JXPropertyDepository.getInstance();
						String errorLevelPrefix = propertyDepository.getString(JXPropertyDepository.PROPERTIES_LINE, "ah_formatter_error_level_prefix");
						String errorCodePrefix = propertyDepository.getString(JXPropertyDepository.PROPERTIES_LINE, "ah_formatter_error_code_prefix");
						System.out.println(errorLevelPrefix + e.getErrorLevel() + "\n" + errorCodePrefix + e.getErrorCode() + "\n" + e.getErrorMessage());
					}
				}
			}
		}

		/* ꎞt@C폜 */
		if (temporary != null) {
			/* obNAbv폜 */
			temporary.delete();
			temporary = null;
		}

		return ret;
	}
}
