package fantastikk.proc.transform;

import java.io.BufferedOutputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.util.Map;

import javax.xml.transform.OutputKeys;
import javax.xml.transform.Transformer;
import javax.xml.transform.stream.StreamResult;
import javax.xml.transform.stream.StreamSource;

import fantastikk.JXConfiguration;


/**
 * XML  XML ւ̕ϊʂ̃XbhŎs邽߂̒ۃNXłB
 * @author Takashi Nishikawa
 */
public abstract class JXAbstractXsltProcess extends JXAbstractXmlProcess {
	/** ̓t@C̃pX */
	protected String inputPath;

	/** o̓t@C̃pX */
	protected String outputPath;

	/** o̓IvV */
	protected Map outputOptions;

	/** X^CV[g̃t@C̃pX */
	protected String styleSheetFilePath;

	/** o͓e (t@Cɏo͂Ȃ) */
	protected String output;

	/**
	 * ̓t@C̃pXݒ肵܂B
	 * @param inputPath ̓t@C̃pX
	 */
	public void setInputPath(String inputPath) {
		this.inputPath = inputPath;
	}

	/**
	 * o̓t@C̃pXݒ肵܂B
	 * @param outputFilePath o̓t@C̃pX
	 */
	public void setOutputPath(String outputPath) {
		this.outputPath = outputPath;
	}

	/**
	 * o̓IvVݒ肵܂B
	 * @param outputOptions o̓IvV
	 */
	public void setOutOptions(Map outputOptions) {
		this.outputOptions = outputOptions;
	}

	/**
	 * o͓e (t@Cɏo͂Ȃ) Ԃ܂
	 * @param styleSheetFilePath X^CV[g̃t@C̃pX
	 */
	public String getOutput() {
		return output;
	}

	/**
	 * X^CV[g̃t@C̃pXݒ肵܂B
	 * @param styleSheetFilePath X^CV[g̃t@C̃pX
	 */
	public void setStyleSheetFilePath(String styleSheetFilePath) {
		this.styleSheetFilePath = styleSheetFilePath;
	}

	/**
	 * XML  XML ւ̕ϊ (ʏ)
	 * @param sourceXmlFilePath ̓t@C (XML) ̃pX
	 * @param resultXmlFilePath o̓t@C (XML) ̃pX
	 * @return ̐ (Atrue)
	 */
	protected boolean xml2xml(String sourceXmlFilePath, String resultXmlFilePath) {
		/* ۃtO */
		boolean ret = false;

		OutputStream os = null;
		BufferedOutputStream bs = null;
		Transformer transformer = null;
		StreamSource sSource_xml = null;
		StreamSource sSource_xsl = null;
		StreamResult sResult = null;

		JXConfiguration configuration = JXConfiguration.getInstance();

		/* XSLT */
		try {
			if (resultXmlFilePath == null) {
				os = new ByteArrayOutputStream();
			} else {
				os = new FileOutputStream(resultXmlFilePath);
			}

			bs = new BufferedOutputStream(os);

			if (configuration.isDtdFilePathEnable()) {
				sSource_xml = new StreamSource();
				sSource_xml.setInputStream(new FileInputStream(new File(sourceXmlFilePath)));
				sSource_xml.setSystemId(configuration.getDtdFilePath());  //DTD̃t@CpXʂ߂ɃoCgXg[ʂɐݒ肷 suga
			} else {
				sSource_xml = new StreamSource(new File(sourceXmlFilePath));
			}

			sSource_xsl = new StreamSource(new File(styleSheetFilePath));
			sResult = new StreamResult(bs);

			transformer = tFactory.newTransformer(sSource_xsl);
			transformer.setErrorListener(errorListener);
			errorListener.setVerbose(true);
			transformer.setOutputProperty(OutputKeys.ENCODING, this.encoding);
			if (indent) {
				transformer.setOutputProperty(OutputKeys.INDENT, "yes");
			}
			transformer.transform(sSource_xml, sResult);
			bs.flush();

			if (resultXmlFilePath == null) {
				output = ((ByteArrayOutputStream)os).toString(this.encoding);
			}
			ret = true;
		} catch(Throwable t) {
			setOccurrence(t);
		} finally {
			if (bs != null) {
				try {
					bs.close();
				} catch (IOException ioe) {
					setOccurrence(ioe);
				}
			}

			bs = null;
			transformer = null;
			sSource_xml = null;
			sSource_xsl = null;
			sResult = null;
		}

		return ret;
	}
}
