package fantastikk.proc.transform;

import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;

import javax.xml.transform.OutputKeys;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.Document;
import org.w3c.dom.Node;


/**
 * XML ̏o͂ʂ̃XbhŎs邽߂̃NXłB
 * @author Takashi Nishikawa
 */
public class JXXmlOutputProcess extends JXAbstractXmlProcess {
	/** ͂ Document IuWFNg */
	private Document inputDocument;

	/** o̓t@C̃pX */
	protected String outputPath;

	/**
	 * ͂ Document IuWFNgݒ肵܂B
	 * @param inputDocument ͂ Document IuWFNg
	 */
	public void setInputDocument(Document inputDocument) {
		this.inputDocument = inputDocument;
	}

	/**
	 * o̓t@C̃pXݒ肵܂B
	 * @param outputFilePath o̓t@C̃pX
	 */
	public void setOutputPath(String outputPath) {
		this.outputPath = outputPath;
	}

	/**
	 * ̏sȂ܂B
	 */
	protected void prepare() {
	}

	/**
	 * sȂ܂B
	 * @return ̐ (Atrue)
	 */
	protected boolean process() {
		/* XML ̃t@Co */
		return this.outputXmlDocument(inputDocument, outputPath);
	}

	/**
	 * Document IuWFNg XML ̃t@Co͂܂Bϊsɔď㏑ۑ̍ۂɂ̓obNAbv悤ɂ܂B
	 * @param document Document IuWFNg
	 * @param t@C̃pX
	 * @return ۑ̐ ( true)
	 */
	private boolean outputXmlDocument(Document document, String path) {
		/* o͐ */
		boolean result = false;

		/* obNAbv (AobNAbv̕Kvꍇ true) */
		boolean renameResult = true;

		/* obNAbvꂽt@C̃pX */
		String backUpFilePath = null;

		/* o͗pXg[ */
		BufferedOutputStream bs = null;
		Transformer transformer = null;

		try {
			Node root = document.getDocumentElement();

			if (root != null) {
				File backUpFile = new File(path);		// obNAbvt@C
				final String ext = ".bak";		// obNAbvꂽt@C̊gq
				int suffix = 1;		// t@C̖OƏdȂ悤ɂ邽߂̐

				if (backUpFile.exists() && backUpFile.length() > 0L) {
					/* ̖OƏdȂ悤ɃobNAbvt@C̖O𐶐 */
					backUpFilePath = path + ext;
					File backUpDestFile = new File(backUpFilePath);

					while (backUpDestFile.exists()) {
						suffix++;
						backUpFilePath = path + "_" + suffix + ext;
						backUpDestFile = new File(backUpFilePath);
					}

					/* ㏑ۑt@C̖OύX */
					renameResult = backUpFile.renameTo(backUpDestFile);
					backUpFile = null;
					backUpDestFile = null;
				}

				if (renameResult) {
					bs = new BufferedOutputStream(new FileOutputStream(path));
					DOMSource dSource = new DOMSource(root);
					StreamResult sResult = new StreamResult(bs);
					transformer = tFactory.newTransformer();
					transformer.setErrorListener(errorListener);
					errorListener.setVerbose(true);
					transformer.setOutputProperty(OutputKeys.ENCODING, this.encoding);
					if (indent) {
						transformer.setOutputProperty(OutputKeys.INDENT, "yes");
					}
					transformer.transform(dSource, sResult);
					bs.flush();
					result = true;
				}
			}
		} catch (TransformerConfigurationException tce) {
			tce.printStackTrace();
		} catch (TransformerException tfe) {
			tfe.printStackTrace();
		} catch (IOException ioe) {
			ioe.printStackTrace();
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			try {
				if (bs != null) {
					bs.close();
				}

				if (result) {
					if (backUpFilePath != null) {
						/* obNAbv폜 */
						new File(backUpFilePath).delete();
					}
				} else {
					File file = new File(path);

					if (file.exists()) {
						file.delete();
					}

					/* obNAbv߂ */
					new File(backUpFilePath).renameTo(new File(path));
				}
			} catch (Exception e) {
				e.printStackTrace();
			}

			transformer = null;
		}

		return result;
	}
}
