package fantastikk.proc.velocity;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Iterator;
import java.util.Map;
import java.util.Properties;

import org.apache.velocity.Template;
import org.apache.velocity.VelocityContext;
import org.apache.velocity.app.VelocityEngine;
import org.apache.velocity.exception.ParseErrorException;
import org.apache.velocity.exception.ResourceNotFoundException;

import fantastikk.proc.JXAbstractProcess;
import fantastikk.util.FileUtility;

/**
 * Velocity ̏ʂ̃XbhŎs邽߂̃NXłB
 * @author Takashi Nishikawa
 */
public class JXVelocityProcess extends JXAbstractProcess {
	/** VelocityEngine IuWFNg*/
	private VelocityEngine vEngine;

	/** VelocityEngine IuWFNg*/
	private VelocityContext vContext;

	/** Velocity ev[g̃t@C̃pX */
	private String templatePath;

	/** o̓t@C̃pX */
	private String outputPath;

	/** t@C̃GR[fBO */
	private String encoding = "UTF-8";

	/**
	 * RXgN^
	 */
	public JXVelocityProcess() {
		vEngine = new VelocityEngine();
		vContext = new VelocityContext();
	}

	/**
	 * ͒lݒ肵܂B
	 * @param inputName ͒l̖O
	 * @param inputValue ͒l
	 */
	public void setInputValue(String inputName, String inputValue) {
		this.vContext.put(inputName, inputValue);
	}

	/**
	 * ͒l܂Ƃ߂Đݒ肵܂B
	 * @param map ͒l
	 */
	public void setAll(Map map) {
		for (Iterator iterator = map.keySet().iterator(); iterator.hasNext();) {
			String inputName = (String)iterator.next();
			String inputValue = (String)map.get(inputName);
			this.vContext.put(inputName, inputValue);
		}
	}

	/**
	 * ͒l܂B
	 * @param inputName ͒l̖O
	 */
	public void removeInputValue(String inputName) {
		this.vContext.remove(inputName);
	}

	/**
	 * Velocity ev[g̃t@C̃pXݒ肵܂B
	 * @param templatePath Velocity ev[g̃t@C̃pX
	 */
	public void setTemplatePath(String templatePath) {
		this.templatePath = templatePath;
	}

	/**
	 * o̓t@C̃pXݒ肵܂B
	 * @param outputFilePath o̓t@C̃pX
	 */
	public void setOutputPath(String outputPath) {
		this.outputPath = outputPath;
	}

	/**
	 * t@C̃GR[fBOݒ肵܂B
	 * @param encoding t@C̃GR[fBO
	 */
	public void setEncoding(String encoding) {
		this.encoding = encoding;
	}

	/**
	 * ̏sȂ܂B
	 */
	protected void prepare() {
		setOccurrence(null);

		Properties properties = new Properties();
		properties.setProperty("resource.loader", "FILE");	// \[X[_̖
		properties.setProperty("FILE.resource.loader.class", 
			"org.apache.velocity.runtime.resource.loader.FileResourceLoader");	// \[X[_̃[h
		properties.setProperty("FILE.resource.loader.path", FileUtility.getDirectoryPath(this.templatePath));	// \[X[_\[X邽߂̃[gpX
		properties.setProperty("FILE.resource.loader.cache", "true");	// [_̃LbV̐ݒ
		properties.setProperty("input.encoding", this.encoding);	// ev[g̓̓GR[fBO
		properties.setProperty("output.encoding", this.encoding);	// o̓Xg[̂߂̕GR[fBO

		try {
			/* Velocity ̏ */
			vEngine.init(properties);
		} catch (Exception e) {
			setOccurrence(e);
		}
	}

	/**
	 * sȂ܂B
	 * @return ̐ (Atrue)
	 */
	protected boolean process() {
		/* Velocity ̏ */
		return executeVelocityProcess();
	}

	/**
	 * Velocity ̏sȂ܂B
	 * @param 
	 * @param 
	 * @return ̐ (Atrue)
	 */
	protected boolean executeVelocityProcess() {
		/* ۃtO */
		boolean ret = false;

		/* ۂ̃`FbN */
		if (getOccurrence() != null) {
			return ret;
		}

		BufferedWriter writer = null;

		try {
			/* ev[g̍쐬 */
			Template vTemplate = vEngine.getTemplate(FileUtility.getName(this.templatePath), this.encoding);

			/* o͐̏ */
			File outputDir = new File(FileUtility.getDirectoryPath(this.outputPath));
			if (!outputDir.exists()) {
				outputDir.mkdir();
			} else if (!outputDir.isDirectory()) {
				outputDir.delete();
				outputDir.mkdir();
			}

			writer = new BufferedWriter(new FileWriter(this.outputPath));

			/* ev[gƃ}[W */
			vTemplate.merge(vContext, writer);
			writer.flush();
			ret = true;
		} catch (ResourceNotFoundException rnfe) {
			setOccurrence(rnfe);
		} catch (ParseErrorException pee) {
			setOccurrence(pee);
		} catch (Exception e) {
			setOccurrence(e);
		} finally {
			if (writer != null) {
				try {
					writer.close();
				} catch (IOException ioe) {
				}
			}
		}

		return ret;
	}
}
