package fantastikk.properties;

import java.util.Locale;
import java.util.ResourceBundle;

import fantastikk.JXConfiguration;


/**
 * vpeBt@Cǂݍނ߂̃NXłB
 * @author Takashi Nishikawa
 */
public class JXPropertyDepository {
	/** JXPropertyDepository IuWFNg */
	private static JXPropertyDepository depository;

	/** ResourceBundle IuWFNg */
	private ResourceBundle labelResourceBundle;
	private ResourceBundle lineResourceBundle;
	private ResourceBundle menuResourceBundle;

	/** vpeBt@C̃JeS̒萔 */
	public static final String PROPERTIES_LABEL = "label";
	public static final String PROPERTIES_LINE = "line";
	public static final String PROPERTIES_MENU = "menu";

	/**
	 * RXgN^
	 */
	private JXPropertyDepository() {
		/* 擾 */
		String language = JXConfiguration.getInstance().getLanguage();

		Locale locale = null;
		if (JXConfiguration.LANGUAGE_EN.equals(language)) {
			locale = new Locale(JXConfiguration.LANGUAGE_EN, "US");
		} else {
			locale = new Locale(JXConfiguration.LANGUAGE_JA, "JP");
		}

		labelResourceBundle = ResourceBundle.getBundle("fantastikk.properties." + PROPERTIES_LABEL , locale);
		lineResourceBundle = ResourceBundle.getBundle("fantastikk.properties." + PROPERTIES_LINE, locale);
		menuResourceBundle = ResourceBundle.getBundle("fantastikk.properties." + PROPERTIES_MENU, locale);
	}
	
	/**
	 * JXPropertyDepository IuWFNgԂ܂B
	 */
	public static JXPropertyDepository getInstance() {
		if (depository == null) {
			depository = new JXPropertyDepository();
		}

		return depository;
	}

	/**
	 * JeSƃL[ɃvpeBt@C̓e̕Ԃ܂B
	 * @param category ̃JeS (PROPERTIES_LABEL  PROPERTIES_LINE  PROPERTIES_MENU)
	 * @param key ̃L[
	 * @return Y镶 (݂Ȃꍇ͋󕶎Ԃ)
	 */
	public String getString(String category, String key) {
		String result = null;

		if (PROPERTIES_LABEL.equals(category)) {
			result = labelResourceBundle.getString(key);
		} else if (PROPERTIES_LINE.equals(category)) {
			result = lineResourceBundle.getString(key);
		} else if (PROPERTIES_MENU.equals(category)) {
			result = menuResourceBundle.getString(key);
		}

		return result == null ? "" : result;
	}
}
