package fantastikk.util;

import java.io.File;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLClassLoader;


/**
 * sɓIɃNXpXǉ邽߂̃[eBeBNXłB
 * @author Takashi Nishikawa
 */
public class ClassPathUtility {
	/** JAR t@C̊gq */
	public static final String JAR_EXT = "jar";

	/**
 	 * sɓIɃNXpXǉ܂B
 	 * @param file t@C
	 * @throws NoSuchMethodException 
	 * @throws SecurityException 
	 * @throws InvocationTargetException 
	 * @throws IllegalAccessException 
	 * @throws MalformedURLException 
	 * @throws IllegalArgumentException 
	 */
	public static void addClassPath(File file) 
		throws SecurityException, NoSuchMethodException, IllegalArgumentException, MalformedURLException, IllegalAccessException, InvocationTargetException {
		
		if (file != null && !file.isHidden() && JAR_EXT.equals(FileUtility.getExtension(file))) {
			Method method = URLClassLoader.class.getDeclaredMethod("addURL", new Class[] {URL.class});	// \bh protected URLClassLoader#addUrl() 擾
			method.setAccessible(true);  // ANZX\ɂ
			method.invoke((URLClassLoader)ClassLoader.getSystemClassLoader(), new Object[] {file.toURI().toURL()});  // URLClassLoader#addUrl() R[ (VXeNX[_[ URLClassLoaderłƂĂ)
		}
	}

	/**
 	 * sɓIɃNXpXǉ܂B(ċAI)
 	 * @param files t@C̔z
	 * @throws InvocationTargetException 
	 * @throws IllegalAccessException 
	 * @throws NoSuchMethodException 
	 * @throws MalformedURLException 
	 * @throws IllegalArgumentException 
	 * @throws SecurityException 
	 */
	public static void addClassPath(File[] files)
		throws SecurityException, IllegalArgumentException, MalformedURLException, NoSuchMethodException, IllegalAccessException, InvocationTargetException {
		
		for (int i = 0; i < files.length; i++) {
			if (files[i].isDirectory()) {
				addClassPath(files[i].listFiles());
			} else {
				addClassPath(files[i]);
			}
		}
	}

	/**
	 * NXpXɊ܂܂邩ǂԂ܂B
	 * @param name JAR ̖O (*.jar)
	 * @return NXpXɊ܂܂邩ǂ
	 */
	public static boolean containsClassPath(String name) {
		/* JAR t@C̃Xgo */
		URL[] url = ((URLClassLoader)ClassLoader.getSystemClassLoader()).getURLs();
		String terminal = "/" + name;
		
		for (int i = 0; i < url.length; i++) {
			String path = url[i].getFile();

			if (path.endsWith(terminal)) {
				return true;
			}
		}

		return false;
	}
}
