package fantastikk.util;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.net.MalformedURLException;
import java.nio.channels.FileChannel;
import java.util.Map;
import java.util.TreeMap;

/**
 * t@C֘Ã[eBeBNXłB
 * @author Takashi Nishikawa
 */
public class FileUtility {
	/**
	 * RXgN^
	 */
	private FileUtility() {
	}

	/**
	 * t@C̊gqŕԂ܂B擾łȂ null Ԃ܂B
	 * @param file t@C
	 */
	public static String getExtension(File file) {
		if (file == null){
			return null;
		} else {
			return getExtension(file.getName());
		}
	}

	/**
 	 * t@C̊gqŕԂ܂B擾łȂ null Ԃ܂B
 	 * @param filename t@C̖O (pXłǂ)
	 */
	public static String getExtension(String filename) {
		/* Ō̃sIhʒu擾 */
		int index = filename.lastIndexOf('.');

		if (index == (-1) ) {
			return null;
		}

		if ( ( index > 0 ) &&(index < filename.length()) ) {
			/* Ō̃sIh̕ŕԂ */
			return filename.substring(index + 1).toLowerCase();
		} else {
			return null;
		}
	}

	/**
	 * t@CpXԂ܂BfBNg̏ꍇ͂̂܂ܕԂ܂B
	 * @param path t@C̃pX
	 * @return fBNg̖O
	 */
	public static String getDirectoryPath(String path) {
		File file = new File(path);

		if (file.isDirectory()) {
			return path;
		} else {
			return path.substring(0, path.lastIndexOf(File.separator));
		}
	}

	/**
	 * t@CpX (URL `) Ԃ܂BfBNg̏ꍇ͂̂܂ܕԂ܂B
	 * @param path t@C̃pX (URL `Afile/ ł͂܂AZp[^ / , fBNg̏ꍇ͖ / )
	 * @return fBNg̖O
	 */
	public static String getDirectoryUrlPath(String path) {
		String ret = "";
		File file = new File(path);

		try {
			if (file.isDirectory()) {
				ret = file.toURI().toURL().toString();
			} else {
				ret = file.getParentFile().toURI().toURL().toString();
			}
		} catch (MalformedURLException e) {
			e.printStackTrace();
		}

		return ret;
	}

	/**
	 * t@C^fBNg̖OԂ܂B
	 * @param path t@C^fBNg̃pX
	 */
	public static String getName(String path) {
		File file = new File(path);
		return file.getName();
	}

	/**
	 * t@C݂邩𒲂ׂ܂B
	 * @paran path t@C̃pX
	 */
	public static boolean isValidPath(String path) {
		if (path.indexOf(File.separator) >= 0) {
			return new File(path).exists();
		}

		return false;
	}

	/**
	 * t@C̃pX URL ̌` (΃pX) ŕԂ܂B
	 * @param file t@C
	 * @return URL ̌`̃pX (/ ł͂܂΃pXAZp[^ / , fBNg̏ꍇ͖ / )
	 */
	public static String toUrlPath(File file) {
		String ret = "";

		try {
			ret = file.toURI().toURL().getPath();
		} catch (MalformedURLException e) {
			e.printStackTrace();
		}

		return ret;
	}

	/**
	 * pX (΃pX)  URL ̌`ɕϊĕԂ܂B
	 * @param path pX
	 * @return URL ̌`̃pX (/ ł͂܂΃pXAZp[^ / , fBNg̏ꍇ͖ / )
	 */
	public static String toUrlPath(String path) {
		return toUrlPath(new File(path));
	}

	/**
	 * gqȂꍇAgq⊮܂B
	 * @param path pX
	 * @param ext gq
	 * @return gq⊮pX
	 */
	public static String appendExtention(String path, String ext) {
		String extOfPath = getExtension(getName(path));

		if (extOfPath == null) {
			return path + "." + ext;
		} else if (extOfPath.equals("")) {
			return path + ext;
		} else {
			return path;
		}
	}

	/**
	 * gqĕԂ܂B
	 * @param path pX
	 * @return gqpX
	 */
	public static String removeExtention(String path) {
		/* Ō̃sIhʒu擾 */
		int index = path.lastIndexOf('.');

		if ( ( index > 0 ) &&(index < path.length() ) ) {
			/* Ō̃sIhO̕Ԃ */
			return path.substring(0, index);
		} else {
			return path;
		}
	}

	/**
	 * w肵fBNg̓e܂B݂Ȃꍇ̓fBNg쐬܂B
	 * @param target Rs[ɂȂfBNg (݂Ȃꍇ̓fBNg쐬At@Cꍇ͏ăfBNg쐬܂)
	 */
	public static void clearDirectory(String target) {
		File targetDirectory = new File(target);

		if (targetDirectory.exists()) {
			delete(targetDirectory);
		}

		targetDirectory.mkdir();
	}

	/**
	 * w肵fBNg̓e𓯊܂BRs[fBNgłȂꍇARs[ƃRs[悪ꍇ͉܂B
	 * @param source Rs[ɂȂfBNg
	 * @param target Rs[ɂȂfBNg (݂Ȃꍇ̓fBNg쐬At@Cꍇ͏ăfBNg쐬܂)
	 */
	public static void synchronizeDirectory(String source, String target) {
		File sourceDirectory = new File(source);
		File targetDirectory = new File(target);

		if (sourceDirectory.exists() && sourceDirectory.isDirectory() && !sourceDirectory.equals(targetDirectory)) {
			if (targetDirectory.exists()) {
				/* Rs[ */
				delete(targetDirectory);
			}

			targetDirectory.mkdir();

			/* Rs[ */
			copy(sourceDirectory, targetDirectory);
		}
	}

	/**
	 * t@C܂̓fBNgRs[܂B
	 * @param source Rs[
	 * @param target Rs[
	 */
	private static void copy(File source, File target) {
		if (source.isDirectory()) {
			if (!target.isDirectory()) {
				target.mkdir();
			}

			File[] children = source.listFiles();

			for (int i = 0; i < children.length; i++) {
				copy(children[i], new File(target, children[i].getName()));
			}
		} else {
			try {
				FileChannel sourceChannel = new FileInputStream(source).getChannel();
				FileChannel targetChannel = new FileOutputStream(target).getChannel();
				sourceChannel.transferTo(0, sourceChannel.size(), targetChannel);
				sourceChannel.close();
				targetChannel.close();
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}

	/**
	 * t@C܂̓fBNg܂B
	 * @param file t@C܂̓fBNg
	 */
	private static void delete(File file) {
		if (file.isDirectory()) {
			File[] children = file.listFiles();

			for (int i = 0; i < children.length; i++) {
				delete(children[i]);
			}
		}

		file.delete();
	}

	/**
	 * 摜t@C̃pXƎʂ܂񂾃}bvԂ܂B
	 * @param path 摜t@C̃fBNg̃pX
	 * @param directoryName fBNg (ׂẴpX̐擪ɕt)
	 * @return 摜t@C̃pXƎʂ̃}bv
	 */
	public static Map getImageFilePathMap(String path, String directoryName) {
		Map map = new TreeMap();
		File directory = new File(path);

		if (directory.exists() && directory.isDirectory()) {
			try {
				addImageFilePath(map, directory.listFiles(), directory, directoryName);
			} catch (IOException e) {
			}
		}

		return map;
	}

	/**
	 * 摜t@C̃pXƎʂ}bvɒǉ܂B
	 * @param map 摜t@C̃pXƎʂ̃}bv
	 * @param files t@C̔z
	 * @param rootDirectory [gfBNg
	 * @param directoryName fBNg (ׂẴpX̐擪ɕt)
	 * @return 摜t@C̃pXƎʂ̃}bv
	 * @throws IOException o͗O
	 */
	private static void addImageFilePath(Map map, File[] files, File rootDirectory, String directoryName) throws IOException {
		int pathLength = rootDirectory.getCanonicalPath().length();
		
		for (int i = 0; i < files.length; i++) {
			if (files[i].isDirectory()) {
				addImageFilePath(map, files[i].listFiles(), rootDirectory, directoryName);
			} else if (!files[i].isHidden()
					&& !files[i].getName().startsWith(".")) {	// Windows  hbgt@CRs[Ȃ (t@C Mac Rs[ꍇz)
				String type = getImageType(files[i]);
				
				if (type != null) {
					String path = null;
					if (directoryName.length() > 0) {
						path = directoryName + "/"+ files[i].getPath().substring(pathLength + 1).replace('\\', '/');
					} else {
						path = files[i].getPath().substring(pathLength + 1).replace('\\', '/');
					}
					
					map.put(path, type);
				}
			}
		}	
	}

	/**
	 * gqɁA摜̎ނԂ܂B
	 * @param file t@C
	 * @return 摜̎ނ̕ (ꍇ null)
	 */
	public static String getImageType(File file) {
		String extension = getExtension(file);

		if (PatternUtility.PATTERN_EXT_JPG.matcher(extension).matches()) {
			 return "image/jpeg";
		} else if (PatternUtility.PATTERN_EXT_PNG.matcher(extension).matches()) {
			 return "image/png";
		} else if (PatternUtility.PATTERN_EXT_GIF.matcher(extension).matches()) {
			 return "image/gif";
		} else if (PatternUtility.PATTERN_EXT_BMP.matcher(extension).matches()) {
			 return "image/bmp";
		} else if (PatternUtility.PATTERN_EXT_TIFF.matcher(extension).matches()) {
			 return "image/tiff";
		}

		return null;
	}
}
