<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="2.0"
    xmlns="http://www.w3.org/1999/xhtml" xml:lang="ja">
    <xsl:template match="table">
        <xsl:choose>
            <!--xhtmlでは，li/tableは妥当でない　1009桑野-->
            <xsl:when test="parent::node()/name()!='li'">
                <table frame="border" cellpadding="3%">
                    <xsl:apply-templates select="@*"/>
                    <xsl:if test="caption">
                        <xsl:apply-templates select="caption"/>
                    </xsl:if>
                    <xsl:if test="tr[th]">
                        <thead>
                            <xsl:apply-templates select="tr[th]"/>
                        </thead>
                    </xsl:if>
                    <xsl:if test="tr[td]">
                        <tbody>
                            <xsl:apply-templates select="tr[td]"/>
                        </tbody>
                    </xsl:if>
                </table>
            </xsl:when>
            <xsl:otherwise>
                <xsl:value-of select="."/>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    <xsl:template match="tr">
        <tr>
            <xsl:apply-templates/>
        </tr>
    </xsl:template>
    <xsl:template match="th">
        <th>
            <xsl:call-template name="colspan_rowspan"/>
            <xsl:apply-templates/>
        </th>
    </xsl:template>
    <xsl:template match="td">
        <td>
            <xsl:call-template name="colspan_rowspan"/>
            <xsl:apply-templates/>
        </td>
    </xsl:template>
    <xsl:template name="colspan_rowspan">
        <xsl:if test="@class[starts-with(.,'colspan-')]">
            <xsl:attribute name="colspan">
                <xsl:value-of select="substring-after(@class[starts-with(.,'colspan-')],'-')"/>
            </xsl:attribute>
        </xsl:if>
        <xsl:if test="@class[starts-with(.,'rowspan-')]">
            <xsl:attribute name="colspan">
                <xsl:value-of select="substring-after(@class[starts-with(.,'rowspan-')],'-')"/>
            </xsl:attribute>
        </xsl:if>
    </xsl:template>
</xsl:stylesheet>
