<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:fo="http://www.w3.org/1999/XSL/Format">
	<!--
  ============================================================
    XMLコンソーシアム  XMP部会  技術系SG  jepaX用スタイルシート
  ============================================================
    block.xsl  【ブロック要素】
  ============================================================
 	2008-06-25  ver.1.0  by S.Aoki
	2008-07-17  ver.1.01 checked  by M.Fujishima
	2010-03-24  added reversal mode by K.Kuwano
  ============================================================
-->
	<!-- 外部ファイルの読み込み -->
	<xsl:include href="block_var.xsl"/>
	<!-- 'p'の設定(ここではテンプレートに渡すのみ) -->
	<xsl:template match="p">
		<xsl:choose>
			<xsl:when test="parent::caption">
				<xsl:apply-templates/>
			</xsl:when>
			<xsl:otherwise>
				<fo:block>
					<xsl:if test="@id!=''">
						<xsl:attribute name="id">
							<xsl:value-of select="@id"/>
						</xsl:attribute>
					</xsl:if>
					<xsl:apply-templates/>
				</fo:block>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!-- 'pre'の設定 -->
	<xsl:template match="pre">
		<fo:block break-after="{$b_pre_breakafter}" span="{$b_pre_span}" color="{$block_pre_fontcolor}">
			<fo:block space-before="{$b_pre_spacebefore}" space-before.conditionality="retain"
				space-after="{$b_pre_spaceafter}" space-after.conditionality="retain"
				start-indent="{$b_pre_startindent}" end-indent="{$b_pre_endindent}"
				border-style="{$b_pre_borderstyle}" border-color="{$block_pre_bordercolor}"
				border-width="{$b_pre_borderwidth}" padding="{$b_pre_padding}"
				background-color="{$block_pre_bgcolor}" text-indent="{$b_pre_text-indent}">
				<xsl:if test="@id!=''">
					<xsl:attribute name="id">
						<xsl:value-of select="@id"/>
					</xsl:attribute>
				</xsl:if>
				<fo:block white-space="pre" wrap-option="wrap" font-family="{$b_pre_fontfamily}"
					font-size="{$b_pre_fontsize}" line-height="{$b_pre_lineheight}">
					<xsl:apply-templates/>
				</fo:block>
			</fo:block>
		</fo:block>
	</xsl:template>
</xsl:stylesheet>
