<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
  <!--
  ============================================================
    XMLコンソーシアム  XMP部会  技術系SG  jepaX用スタイルシート
  ============================================================
    block_var.xsl  【ブロック要素】
  ============================================================
    2008-06-25  ver.1.0  by S.Aoki
	  2008-07-17  ver.1.01 checked  by M.Fujishima 
	  2008-08-19  deletion of regulated value  by K.Kuwano
	  2010-03-24  added reversal mode by K.Kuwano
	  ============================================================
-->
  <!-- フォント -->
  <xsl:param name="b_pre_fontstyle">ゴシック</xsl:param>
  <!-- この変数に関する要素内容の削除は不可 -->
  <xsl:variable name="b_pre_fontfamily">
    <xsl:choose>
      <xsl:when test="$b_pre_fontstyle='ゴシック'">IPAUIGothic</xsl:when>
      <xsl:when test="$b_pre_fontstyle='明朝'">IPAMincho</xsl:when>
      <xsl:otherwise>IPAUIGothic</xsl:otherwise>
    </xsl:choose>
  </xsl:variable>
  <!-- 文字サイズ -->
  <xsl:param name="b_pre_fontsize">100%</xsl:param>
  <!-- 行の高さ -->
  <xsl:param name="b_pre_lineheight">150%</xsl:param>
  <!-- 前段落との空き -->
  <xsl:param name="b_pre_spacebefore">6.75mm</xsl:param>
  <!-- 後段落との空き -->
  <xsl:param name="b_pre_spaceafter">6.75mm</xsl:param>
  <!-- 左インデント -->
  <xsl:param name="b_pre_startindent">3.0em</xsl:param>
  <!-- 右インデント -->
  <xsl:param name="b_pre_endindent">1.0em</xsl:param>
  <!-- 終了後改ページ -->
  <xsl:param name="b_pre_breakafter">auto</xsl:param>
  <!-- 段組を無視してぶち抜く -->
  <xsl:param name="b_pre_span">none</xsl:param>
<!-- 1行目行頭のインデント -->
  <xsl:param name="b_pre_text-indent">0em</xsl:param>  
  <!-- 背景の罫線の種類 -->
  <xsl:param name="b_pre_borderstyle">none</xsl:param>
  <!-- 背景の罫線の色 -->
  <xsl:param name="b_pre_bordercolor">#FFFFFF</xsl:param>
  <xsl:variable name="block_pre_bordercolor">
    <xsl:choose>
      <xsl:when test="$Hanten='false'">
        <xsl:value-of select="$b_pre_borderstyle"/>
      </xsl:when>
      <xsl:otherwise>white</xsl:otherwise>
    </xsl:choose>

  </xsl:variable>
  <!-- 背景の罫線の太さ -->
  <xsl:param name="b_pre_borderwidth">1.0mm</xsl:param>
  <!-- 背景との間隔 -->
  <xsl:param name="b_pre_padding">3.0mm</xsl:param>
  <!-- 背景色 -->
  <xsl:param name="b_pre_bgcolor">#CCCCCC</xsl:param>
  <xsl:variable name="block_pre_bgcolor">
    <xsl:choose>
      <xsl:when test="$Hanten='false'">
        <xsl:value-of select="$b_pre_bgcolor"/>
      </xsl:when>
      <xsl:otherwise>black</xsl:otherwise>
    </xsl:choose>
  </xsl:variable>
  <!-- 文字色 -->
  <xsl:variable name="block_pre_fontcolor">
    <xsl:choose>
      <xsl:when test="$Hanten='false'">black</xsl:when>
      <xsl:otherwise>white</xsl:otherwise>
    </xsl:choose>
  </xsl:variable>
</xsl:stylesheet>
