<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<!--
  ============================================================
    XMLコンソーシアム  XMP部会  技術系SG  jepaX用スタイルシート
  ============================================================
    float_var.xsl  【図要素】
  ============================================================
    2008-06-25  ver.1.0  by S.Aoki
    2008-07-17  ver.1.01 checked  by M.Fujishima
    2008-08-19  deletion of regulated value  by K.Kuwano
    2009-04-24  ver.1.02  by S.Aoki　revised
    2010-08-24 revised  by H.Sato
    2010-10-13  add a functuion to configurate text-indent by K.Kuwano
    ============================================================
-->
	<!-- 画像の基準パス -->
	<!--xsl:param name="i_image_origin"/-->
	<!-- 前段落との空き -->
	<xsl:param name="f_figure_spacebefore"/>
	<!-- 後段落との空き -->
	<xsl:param name="f_figure_spaceafter"/>
	<!-- 図版の揃え方 -->
	<xsl:param name="f_figure_textalign"/>
	<!-- 終了後改ページ -->
	<xsl:param name="f_figure_breakafter"/>
	<!-- 段組を無視してぶち抜く -->
	<xsl:param name="f_figure_span"/>
	<!-- 図の位置制御用 -->
	<xsl:param name="f_table_first_column_flag">0</xsl:param>
	<xsl:param name="f_table_third_column_flag">1</xsl:param>
	<!-- キャプションの表示位置 -->
	<xsl:param name="f_caption"/>
	<xsl:variable name="f_caption_side">
		<xsl:choose>
			<xsl:when test="$f_caption='上側'">up</xsl:when>
			<xsl:when test="$f_caption='下側'">down</xsl:when>
			<xsl:otherwise>down</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!-- 図（float）の幅で折り返す -->
	<xsl:param name="wrap_with_float_width">true</xsl:param>
	<!-- キャプションのフォント -->
	<xsl:param name="f_caption_fontstyle"/>
	<xsl:variable name="f_caption_fontfamily">
		<xsl:choose>
			<xsl:when test="$f_caption_fontstyle='ゴシック'">IPAGothic</xsl:when>
			<xsl:when test="$f_caption_fontstyle='明朝'">IPAMincho</xsl:when>
			<xsl:otherwise>IPAGothic</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!-- キャプションの文字サイズ -->
	<xsl:param name="f_caption_fontsize"/>
	<!-- 行の高さ -->
	<xsl:param name="f_caption_lineheight"/>
	<!-- 1行目の行頭のインデント -->
	<xsl:param name="f_caption_text-indent">0em</xsl:param>
	<!-- 行の揃え方 -->
	<!-- 2010-07-19 -->
	<xsl:param name="f_caption_textalign">center</xsl:param>
	<!-- 罫巻の種類 -->
	<xsl:param name="f_figure_borderstyle"/>
	<!-- 罫巻の色 -->
	<xsl:param name="f_figure_bordercolor"/>
	<!-- 罫巻の太さ -->
	<xsl:param name="f_figure_borderwidth"/>
	<!-- 罫巻と図版との間隔 -->
	<xsl:param name="f_figure_padding"/>
	<!-- 2010.09.06 -->
	<!-- 画像の描画方法の選択 -->
	<xsl:param name="f_maxwidth_or_scale"/>
	<!-- 画像の最大幅 -->
	<xsl:param name="f_figure_max_width"/>
	<!-- 画像のサイズ -->
	<xsl:param name="f_figure_size"/>
	<!-- 背景色 -->
	<xsl:param name="f_figure_bgcolor"/>
</xsl:stylesheet>
