<?xml version="1.0" encoding="UTF-8"?>
<!--
	============================================================
	XMLコンソーシアム  XMP部会  技術系SG  jepaX用スタイルシート
	============================================================
	jepax.xsl  【全体】
	============================================================
	2008-05-12  ver.0.9  by K.Kuwano
	2008-07-19  ver.1.0  checked by Y.Tasaki
	2009-03-24  add the reversal mode by K.Kuwano
	2010-01-13  add the vertical mode (AHFormatter only)  by K.Kuwano
	2010-02-28  add the vertical mode into front and back by K.Kuwano
	2010-02-28  change break-after="auto" to break-after="page" of body by K.Kuwano
	2010-02-28  add break-before="page" to body and back by K.Kuwano
	2010-07-11  enabled edit nombre configuration by K.Kuwano
    2010-10-01  enabled generate bookmark by K.Kuwano
	============================================================
-->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:fo="http://www.w3.org/1999/XSL/Format">
	<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="no"/>
	<xsl:include href="jepax_var.xsl"/>
	<xsl:include href="logic.xsl"/>
	<xsl:include href="list.xsl"/>
	<xsl:include href="block.xsl"/>
	<xsl:include href="float.xsl"/>
	<xsl:include href="table.xsl"/>
	<xsl:include href="inline.xsl"/>
	<xsl:include href="common_attr.xsl"/>
<xsl:include href="generate_bookmark.xsl"/>
	<!--全要素について，不要な空白を削除-->
	<xsl:strip-space elements="*"/>
	<!--ルートノードにマッチし，ルート要素に処理を渡す-->
	<xsl:template match="/">
		<xsl:apply-templates/>
	</xsl:template>
	<!--ルート要素（jepax）にマッチ-->
	<xsl:template match="jepax">
		<fo:root language="ja" country="JP">
			<fo:layout-master-set>
				<fo:simple-page-master master-name="jepax_normal_spm_odd"
					page-height="{$j_page_height}" page-width="{$j_page_width}">
					<!-- formatterの場合，region-bodyにwriting-modeを設定しても効かないので，ここからは削除 2010_01_13 kuwano -->
					<fo:region-body margin-top="{$j_region_before_after}"
						margin-bottom="{$j_region_before_after}"
						margin-left="{$j_region_left_right}" margin-right="{$j_region_left_right}"
						column-count="{$j_column_count}" column-gap="{$j_column_gap}"
						background-color="{$j_hanten_bg}"/>
					<!--region-beforeなどのextentは，region-bodyのmarginに揃えた-->
					<fo:region-before extent="{$j_region_before_after}"
						background-color="{$j_hanten_bg}"/>
					<fo:region-after extent="{$j_region_before_after}"
						background-color="{$j_hanten_bg}" region-name="odd_region_after"/>
					<!--<fo:region-after extent="{$j_region_before_after}"
						background-color="{$j_hanten_bg}" region-name="odd_region_after"/>-->
					<fo:region-start extent="{$j_region_left_right}"
						background-color="{$j_hanten_bg}"/>
					<fo:region-end extent="{$j_region_left_right}" background-color="{$j_hanten_bg}"
					/>
				</fo:simple-page-master>
				<fo:simple-page-master master-name="jepax_normal_spm_even"
					page-height="{$j_page_height}" page-width="{$j_page_width}">
					<!-- formatterの場合，region-bodyにwriting-modeを設定しても効かないので，ここからは削除 2010_01_13 kuwano -->
					<fo:region-body margin-top="{$j_region_before_after}"
						margin-bottom="{$j_region_before_after}"
						margin-left="{$j_region_left_right}" margin-right="{$j_region_left_right}"
						column-count="{$j_column_count}" column-gap="{$j_column_gap}"
						background-color="{$j_hanten_bg}"/>
					<!--region-beforeなどのextentは，region-bodyのmarginに揃えた-->
					<fo:region-before extent="{$j_region_before_after}"
						background-color="{$j_hanten_bg}"/>
					<fo:region-after extent="{$j_region_before_after}"
						background-color="{$j_hanten_bg}" region-name="even_region_after"/>
					<!--<fo:region-after extent="{$j_region_before_after}"
						background-color="{$j_hanten_bg}" region-name="even_region_after"/>-->
					<fo:region-start extent="{$j_region_left_right}"
						background-color="{$j_hanten_bg}"/>
					<fo:region-end extent="{$j_region_left_right}" background-color="{$j_hanten_bg}"
					/>
				</fo:simple-page-master>
				<fo:page-sequence-master master-name="jepax_normal_psm">
					<fo:repeatable-page-master-alternatives maximum-repeats="no-limit">
						<fo:conditional-page-master-reference
							master-reference="jepax_normal_spm_odd">
							<xsl:attribute name="odd-or-even">
								<xsl:choose>
									<xsl:when test="$j_Writing_mode='lr-tb'">odd</xsl:when>
									<xsl:when test="$j_Writing_mode='tb-rl'">even</xsl:when>
								</xsl:choose>
							</xsl:attribute>
						</fo:conditional-page-master-reference>
						<fo:conditional-page-master-reference
							master-reference="jepax_normal_spm_even">
							<xsl:attribute name="odd-or-even">
								<xsl:choose>
									<xsl:when test="$j_Writing_mode='lr-tb'">even</xsl:when>
									<xsl:when test="$j_Writing_mode='tb-rl'">odd</xsl:when>
								</xsl:choose>
							</xsl:attribute>
						</fo:conditional-page-master-reference>
					</fo:repeatable-page-master-alternatives>
				</fo:page-sequence-master>
			</fo:layout-master-set>
			<!--PDFのしおりの処理　2010_10_01 kuwano -->
			<fo:bookmark-tree>
				<xsl:call-template name="generate_bookmark"/>
			</fo:bookmark-tree>
			<fo:page-sequence master-reference="jepax_normal_psm"
				initial-page-number="{$j_initial_page_number}"
				force-page-count="{$j_force_page_count}">
				<!--ノンブル-->
				<!--FOPがinside／outsideの区別ができないようなので、奇数／偶数で分けた 2010_07_11 kuwano -->
				<!--縦組み実装時は再度調整が必要 2010_07_11 kuwano -->
				<fo:static-content flow-name="odd_region_after">
					<fo:block xsl:use-attribute-sets="nombre nombre_odd">
						<fo:page-number/>
					</fo:block>
				</fo:static-content>
				<fo:static-content flow-name="even_region_after">
					<fo:block xsl:use-attribute-sets="nombre nombre_even">
						<fo:page-number/>
					</fo:block>
				</fo:static-content>
				<fo:flow flow-name="xsl-region-body">
					<xsl:if test="$j_front_cover='bookinfo'">
						<fo:block break-after="page" wrap-option="wrap" span="all">
							<xsl:apply-templates select="bookinfo"/>
						</fo:block>
					</xsl:if>
					<xsl:if test="front">
						<!-- frontにもwriting-modeを設定 2010_02_28 kuwano -->
						<fo:block-container>
							<!-- formatterの場合，region-bodyにwriting-modeを設定しても効かない。flow下にblock-containerを置いて，それにwriting-modeを設定する 2010_01_13 kuwano -->
							<xsl:attribute name="writing-mode">
								<xsl:choose>
									<xsl:when test="$common_fo_processor='ah_formatter'">
										<xsl:value-of select="$j_writing_mode"/>
									</xsl:when>
									<xsl:otherwise>lr-tb</xsl:otherwise>
								</xsl:choose>
							</xsl:attribute>
							<!-- @breakf-afterをautoからpageに変更 2010_02_28 kuwano -->
							<fo:block break-after="page" wrap-option="wrap">
								<xsl:apply-templates select="front"/>
								<!--暫定的にここでgenerateTOCを呼び出し　　2010_07_17 kuwano-->
								<xsl:call-template name="generateTOC"/>
							</fo:block>
						</fo:block-container>
					</xsl:if>
					<fo:block-container>
						<!-- formatterの場合，region-bodyにwriting-modeを設定しても効かない。flow下にblock-containerを置いて，それにwriting-modeを設定する 2010_01_13 kuwano -->
						<xsl:attribute name="writing-mode">
							<xsl:choose>
								<xsl:when test="$common_fo_processor='ah_formatter'">
									<xsl:value-of select="$j_writing_mode"/>
								</xsl:when>
								<xsl:otherwise>lr-tb</xsl:otherwise>
							</xsl:choose>
						</xsl:attribute>
						<!-- @break-before="page"を追加 2010_02_28 kuwano -->
						<fo:block break-after="page" break-before="page" wrap-option="wrap">
							<xsl:apply-templates select="body"/>
						</fo:block>
					</fo:block-container>
					<xsl:if test="back">
						<!-- backにもwriting-modeを設定 2010_02_28 kuwano -->
						<fo:block-container>
							<!-- formatterの場合，region-bodyにwriting-modeを設定しても効かない。flow下にblock-containerを置いて，それにwriting-modeを設定する 2010_01_13 kuwano -->
							<xsl:attribute name="writing-mode">
								<xsl:choose>
									<xsl:when test="$common_fo_processor='ah_formatter'">
										<xsl:value-of select="$j_writing_mode"/>
									</xsl:when>
									<xsl:otherwise>lr-tb</xsl:otherwise>
								</xsl:choose>
							</xsl:attribute>
							<!-- @break-before="page"を追加 2010_02_28 kuwano -->
							<fo:block wrap-option="wrap" break-before="page">
								<xsl:apply-templates select="back"/>
							</fo:block>
						</fo:block-container>
					</xsl:if>
				</fo:flow>
			</fo:page-sequence>
		</fo:root>
	</xsl:template>
	<xsl:template match="bookinfo">
		<xsl:if test="isbn/text()">
			<fo:block-container top="0mm" absolute-position="absolute">
				<fo:block xsl:use-attribute-sets="book_info_style">
					<xsl:value-of select="isbn"/>
				</fo:block>
			</fo:block-container>
		</xsl:if>
		<xsl:choose>
			<xsl:when test="$j_title_border='true'">
				<fo:block xsl:use-attribute-sets="title_border_style title_position">
					<fo:block xsl:use-attribute-sets="main_title_text">
						<xsl:apply-templates select="book-title"/>
					</fo:block>
					<xsl:if test="book-subtitle/text()">
						<fo:block xsl:use-attribute-sets="sub_title_text">
							<xsl:apply-templates select="book-subtitle"/>
						</fo:block>
					</xsl:if>
				</fo:block>
			</xsl:when>
			<xsl:otherwise>
				<fo:block xsl:use-attribute-sets="title_position">
					<fo:block xsl:use-attribute-sets="main_title_text">
						<xsl:apply-templates select="book-title"/>
					</fo:block>
					<xsl:if test="book-subtitle/text()">
						<fo:block xsl:use-attribute-sets="sub_title_text">
							<xsl:apply-templates select="book-subtitle"/>
						</fo:block>
					</xsl:if>
				</fo:block>
			</xsl:otherwise>
		</xsl:choose>
		<fo:block xsl:use-attribute-sets="book_info_style">
			<xsl:if test="edition/text()">
				<fo:block>
					<xsl:apply-templates select="edition"/>
				</fo:block>
			</xsl:if>
			<xsl:if test="series-title/text()">
				<fo:block>
					<xsl:apply-templates select="series-title"/>
				</fo:block>
			</xsl:if>
			<xsl:if test="book-author/text()">
				<xsl:for-each select="book-author">
					<fo:block>
						<xsl:apply-templates select="."/>
						<xsl:apply-templates select="@role"/>
					</fo:block>
				</xsl:for-each>
			</xsl:if>
			<xsl:if test="pub-date/text()">
				<fo:block>
					<xsl:text>刊行日：</xsl:text>
					<xsl:apply-templates select="pub-date"/>
				</fo:block>
			</xsl:if>
			<xsl:if test="publisher/text()">
				<fo:block>
					<xsl:text>刊行者：</xsl:text>
					<xsl:apply-templates select="publisher"/>
				</fo:block>
			</xsl:if>
		</fo:block>
	</xsl:template>
</xsl:stylesheet>
