<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="2.0">
	<!--
		============================================================
		XMLコンソーシアム  XMP部会  技術系SG  jepaX用スタイルシート
		============================================================
		jepax_var.xsl  【全体】
		============================================================
		2008-05-08  ver.0.9  by K.Kuwano
		2008-07-19  ver.1.0  checked by Y.Tasaki
		2008-08-19  deletion of regulated value  by K.Kuwano
		2009-03-24  add the reversal mode  by K.Kuwano
		2010-01-13  add the vertical mode (AHFormatter only)  by K.Kuwano
		2010-03-15  change nombre stlye  by K.Kuwano
		2010-07-11  enabled edit nombre configuration by K.Kuwano
		============================================================
	-->
	<!--白黒反転-->
	<xsl:param name="Hanten">true</xsl:param>
	<xsl:variable name="j_hanten_bg">
		<xsl:choose>
			<xsl:when test="$Hanten='true'">black</xsl:when>
			<xsl:when test="$Hanten='false'">white</xsl:when>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="j_hanten_ft">
		<xsl:choose>
			<xsl:when test="$Hanten='true'">white</xsl:when>
			<xsl:when test="$Hanten='false'">black</xsl:when>
		</xsl:choose>
	</xsl:variable>
	<!-- 誌面の物理サイズ-->
	<xsl:param name="j_page_width">148mm</xsl:param>
	<xsl:param name="j_page_height">210mm</xsl:param>
	<!-- 余白-->
	<!-- 天地の余白-->
	<!-- 値は正の数値。単位はmmまたはpt -->
	<!-- 指定省略時は20mmが格納される -->
	<xsl:param name="j_Region_before_after">15.0mm</xsl:param>
	<xsl:variable name="j_region_before_after">
		<xsl:choose>
			<xsl:when test="$j_Region_before_after!=''">
				<xsl:value-of select="$j_Region_before_after"/>
			</xsl:when>
			<xsl:otherwise>20mm</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!-- 左右の余白-->
	<!-- 値は正の数値。単位はmmまたはpt -->
	<!-- 指定省略時は15mmが格納される -->
	<xsl:param name="j_Region_left_right">10.0mm</xsl:param>
	<xsl:variable name="j_region_left_right">
		<xsl:choose>
			<xsl:when test="$j_Region_left_right!=''">
				<xsl:value-of select="$j_Region_left_right"/>
			</xsl:when>
			<xsl:otherwise>15mm</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!-- ノンブル-->
	<!-- 開始ノンブル -->
	<!-- 値は正の整数値。単位はなし -->
	<!--指定省略時あるいは数値以外指定時は1が格納される-->
	<xsl:param name="j_Initial_page_number">1</xsl:param>
	<xsl:variable name="j_initial_page_number">
		<xsl:choose>
			<xsl:when
				test="$j_Initial_page_number!='' and boolean(number($j_Initial_page_number))">
				<xsl:value-of select="$j_Initial_page_number"/>
			</xsl:when>
			<xsl:otherwise>1</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!-- ノンブルの体裁。 -->
	<xsl:param name="j_Page_number_font-family">IPAGothic</xsl:param>
	<xsl:param name="j_Page_number_font-size">5.0mm</xsl:param>
	<xsl:param name="j_Page_number_color">#000000</xsl:param>
	<xsl:attribute-set name="nombre">
		<xsl:attribute name="color" select="$j_hanten_ft"/>
		<!-- ノンブルの体裁変更　　2010_03_15 kuwano -->
		<xsl:attribute name="font-family" select="$j_Page_number_font-family"/>
		<xsl:attribute name="font-size" select="$j_Page_number_font-size"/>
		<xsl:attribute name="color" select="$j_Page_number_color"/>
		<xsl:attribute name="line-height">1em</xsl:attribute>
	</xsl:attribute-set>
	<xsl:param name="j_Page_number_text-align-last">center</xsl:param>
	<xsl:attribute-set name="nombre_odd">
		<xsl:attribute name="text-align-last"
			select="$j_Page_number_text-align-last"/>
	</xsl:attribute-set>
	<xsl:attribute-set name="nombre_even">
		<xsl:attribute name="text-align-last">
			<xsl:choose>
				<!--fopはtext-align-last=outside／insideが効かない。そのため、プロセッサがFOPで偶数ページの場合のみ、「外側」を「inside」に置き換える　2010_07_11 kuwano-->
				<xsl:when
					test="$common_fo_processor!='ah_formatter' and $j_Page_number_text-align-last='outside'"
					>inside</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="$j_Page_number_text-align-last"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:attribute>
	</xsl:attribute-set>
	<!-- 組み方向-->
	<xsl:param name="j_Writing_mode">tb-rl</xsl:param>
	<xsl:variable name="j_writing_mode">
		<xsl:choose>
			<xsl:when test="$j_Writing_mode='lr-tb'">lr-tb</xsl:when>
			<!-- 横組み固定を廃止　　20010_01_13 kuwano -->
			<xsl:when test="$j_Writing_mode='tb-rl'">tb-rl</xsl:when>
			<!-- 下記処理を廃止　　20010_01_13 kuwano -->
			<!-- jepax/jepaxinfo/pref-layout/@flowに値が設定されていれば，それを優先的に使う -->
			<!--<xsl:when test="jepax/jepaxinfo/pref-layout/@flow='horz'">lr-tb</xsl:when>
				<xsl:when test="jepax/jepaxinfo/pref-layout/@flow='vert'">tb-rl</xsl:when>-->
			<xsl:otherwise>lr-tb</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!-- 段組 -->
	<!-- 段組の数 -->
	<!-- 値は正の整数値。単位はなし -->
	<xsl:param name="j_Column_count">1</xsl:param>
	<xsl:variable name="j_column_count">
		<xsl:choose>
			<xsl:when test="$j_Column_count!=''">
				<xsl:value-of select="$j_Column_count"/>
			</xsl:when>
			<xsl:otherwise>1</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!-- 段組間の距離 -->
	<!-- 値は正の数値。単位はmmまたはpt -->
	<xsl:param name="j_Column_gap">10.0mm</xsl:param>
	<xsl:variable name="j_column_gap">
		<xsl:choose>
			<xsl:when test="$j_Column_gap!=''">
				<xsl:value-of select="$j_Column_gap"/>
			</xsl:when>
			<xsl:otherwise>10mm</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!-- 終了ページの設定 -->
	<!-- 値は「end-on-even」（偶数終わり）・「end-on-odd」（奇数終わり）・「no-force」（成り行き）のいずれか -->
	<xsl:param name="j_Force_page_count">end-on-odd</xsl:param>
	<xsl:variable name="j_force_page_count">
		<xsl:choose>
			<xsl:when test="$j_Force_page_count='end-on-even'"
				>end-on-even</xsl:when>
			<xsl:when test="$j_Force_page_count='end-on-odd'"
				>end-on-odd</xsl:when>
			<xsl:when test="$j_Force_page_count='no-force'">no-force</xsl:when>
			<xsl:otherwise>end-on-even</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!--表紙にbookinfoとdiv[@type='表紙']のどちらを使うか-->
	<xsl:param name="j_Front_cover">bookinfo</xsl:param>
	<xsl:variable name="j_front_cover">
		<xsl:value-of select="$j_Front_cover"/>
	</xsl:variable>
	<!-- 表紙の体裁設定 -->
	<!-- タイトルの枠の有無 -->
	<xsl:param name="j_Title_border">true</xsl:param>
	<xsl:variable name="j_title_border">
		<xsl:value-of select="$j_Title_border"/>
	</xsl:variable>
	<!-- タイトルの位置の設定 -->
	<xsl:param name="j_Title_space-before">50.0mm</xsl:param>
	<xsl:param name="j_Title_margin">15.0mm</xsl:param>
	<xsl:attribute-set name="title_position">
		<xsl:attribute name="color" select="$j_hanten_ft"/>
		<xsl:attribute name="space-before.conditionality">retain</xsl:attribute>
		<xsl:attribute name="space-before">
			<xsl:value-of select="$j_Title_space-before"/>
		</xsl:attribute>
		<xsl:attribute name="margin-left">
			<xsl:value-of select="$j_Title_margin"/>
		</xsl:attribute>
		<xsl:attribute name="margin-right">
			<xsl:value-of select="$j_Title_margin"/>
		</xsl:attribute>
	</xsl:attribute-set>
	<!-- タイトルを囲む枠の体裁 -->
	<xsl:param name="j_Title_border-style">solid</xsl:param>
	<xsl:param name="j_Title_border-color">#FFFFFF</xsl:param>
	<xsl:param name="j_Title_border-width">1.0mm</xsl:param>
	<xsl:param name="j_Title_padding">4.0mm</xsl:param>
	<xsl:attribute-set name="title_border_style">
		<xsl:attribute name="border-style">
			<xsl:value-of select="$j_Title_border-style"/>
		</xsl:attribute>
		<xsl:attribute name="border-color">
			<xsl:value-of select="$j_Title_border-color"/>
		</xsl:attribute>
		<xsl:attribute name="border-width">
			<xsl:value-of select="$j_Title_border-width"/>
		</xsl:attribute>
		<!-- タイトルを囲む枠とタイトルとの間隔 -->
		<xsl:attribute name="padding">
			<xsl:value-of select="$j_Title_padding"/>
		</xsl:attribute>
	</xsl:attribute-set>
	<!-- メインタイトルの文字設定 -->
	<!--デフォルト値-->
	<xsl:param name="j_Main_title_text_font-family">IPAGothic</xsl:param>
	<xsl:param name="j_Main_title_text_font-size">50.0pt</xsl:param>
	<xsl:param name="j_Main_title_text_line-height">75.0pt</xsl:param>
	<xsl:param name="j_Main_title_text_text-align">center</xsl:param>
	<xsl:param name="j_Main_title_text_text-align-last">center</xsl:param>
	<xsl:attribute-set name="main_title_text">
		<xsl:attribute name="color" select="$j_hanten_ft"/>
		<xsl:attribute name="font-family">
			<xsl:value-of select="$j_Main_title_text_font-family"/>
		</xsl:attribute>
		<xsl:attribute name="font-size">
			<xsl:value-of select="$j_Main_title_text_font-size"/>
		</xsl:attribute>
		<xsl:attribute name="line-height">
			<xsl:value-of select="$j_Main_title_text_line-height"/>
		</xsl:attribute>
		<xsl:attribute name="text-align">
			<xsl:value-of select="$j_Main_title_text_text-align"/>
		</xsl:attribute>
		<xsl:attribute name="text-align-last">
			<xsl:value-of select="$j_Main_title_text_text-align-last"/>
		</xsl:attribute>
	</xsl:attribute-set>
	<!-- サブタイトルの文字設定 -->
	<xsl:param name="j_Sub_title_text_font-family">IPAGothic</xsl:param>
	<xsl:param name="j_Sub_title_text_font-size">10.0pt</xsl:param>
	<xsl:param name="j_Sub_title_text_line-height">15.0pt</xsl:param>
	<xsl:param name="j_Sub_title_text_text-align">end</xsl:param>
	<xsl:param name="j_Sub_title_text_text-align-last">end</xsl:param>
	<xsl:param name="j_Sub_title_text_space-before">5.0mm</xsl:param>
	<xsl:attribute-set name="sub_title_text">
		<xsl:attribute name="color" select="$j_hanten_ft"/>
		<xsl:attribute name="font-family">
			<xsl:value-of select="$j_Sub_title_text_font-family"/>
		</xsl:attribute>
		<xsl:attribute name="font-size">
			<xsl:value-of select="$j_Sub_title_text_font-size"/>
		</xsl:attribute>
		<xsl:attribute name="line-height">
			<xsl:value-of select="$j_Sub_title_text_line-height"/>
		</xsl:attribute>
		<xsl:attribute name="text-align">
			<xsl:value-of select="$j_Sub_title_text_text-align"/>
		</xsl:attribute>
		<xsl:attribute name="text-align-last">
			<xsl:value-of select="$j_Sub_title_text_text-align-last"/>
		</xsl:attribute>
		<xsl:attribute name="space-before">
			<xsl:value-of select="$j_Sub_title_text_space-before"/>
		</xsl:attribute>
	</xsl:attribute-set>
	<!-- 版や著者に関する表示の体裁 -->
	<xsl:param name="j_Book_info_space-before">15.0mm</xsl:param>
	<xsl:param name="j_Book_info_font-family">IPAGothic</xsl:param>
	<xsl:param name="j_Book_info_font-size">10.0pt</xsl:param>
	<xsl:param name="j_Book_info_line-height">15.0pt</xsl:param>
	<xsl:param name="j_Book_info_text-align">end</xsl:param>
	<xsl:param name="j_Book_info_text-align-last">end</xsl:param>
	<xsl:param name="j_Book_info_margin">15.0mm</xsl:param>
	<xsl:attribute-set name="book_info_style">
		<xsl:attribute name="color" select="$j_hanten_ft"/>
		<!-- タイトル表示との垂直距離 -->
		<xsl:attribute name="space-before">
			<xsl:value-of select="$j_Book_info_space-before"/>
		</xsl:attribute>
		<!-- 文字設定 -->
		<xsl:attribute name="font-family">
			<xsl:value-of select="$j_Book_info_font-family"/>
		</xsl:attribute>
		<xsl:attribute name="font-size">
			<xsl:value-of select="$j_Book_info_font-size"/>
		</xsl:attribute>
		<xsl:attribute name="line-height">
			<xsl:value-of select="$j_Book_info_line-height"/>
		</xsl:attribute>
		<xsl:attribute name="text-align">
			<xsl:value-of select="$j_Book_info_text-align"/>
		</xsl:attribute>
		<xsl:attribute name="text-align-last">
			<xsl:value-of select="$j_Book_info_text-align-last"/>
		</xsl:attribute>
		<!-- 誌面の端からの左右のマージン -->
		<xsl:attribute name="margin-left">
			<xsl:value-of select="$j_Book_info_margin"/>
		</xsl:attribute>
		<xsl:attribute name="margin-right">
			<xsl:value-of select="$j_Book_info_margin"/>
		</xsl:attribute>
	</xsl:attribute-set>
</xsl:stylesheet>
