<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format" xmlns:axf="http://www.antennahouse.com/names/XSL/Extensions" version="1.0">
	<!--
  ============================================================
    XMLコンソーシアム  XMP部会  技術系SG  jepaX用スタイルシート
  ============================================================
    list_vars.xsl  【リスト要素】
  ============================================================
    2008-05-22  ver.0.6  by ytazaki@bug.co.jp
    2008-07-22  ver.1.0  checked T.Ito
    2008-07-23  ver.1.1  by ytazaki@bug.co.jp
    2008-08-19  deletion of regulated value  by K.Kuwano
	2008-09-05  revised  by K.Kuwano
	2009-12-21  ver.1.2  by jun@e-cascade.biz
	2010-03-24  attributes for B/W-reverse added by M.Fujishima
	2010-03-25  ref. to obsolete attributes commented out by J.Yoshida
	2010-10-13  add a functuion to configurate text-indent by K.Kuwano
	2011-01-15  rearrange constitution of any attribute-set by K.Kuwano
	2011-01-16  divide li_margin into li_margin_tb and li_margin_lr by K.Kuwano
  ============================================================
-->
	<!--白黒反転-->
	<xsl:param name="lHanten" select="$Hanten"/>
	<xsl:variable name="l_hanten_bg">black</xsl:variable>
	<xsl:variable name="l_hanten_ft">white</xsl:variable>
	<xsl:param name="li_border-color">black</xsl:param>
	<xsl:param name="li_border-style">none</xsl:param>
	<xsl:param name="li_border-width">0.1mm</xsl:param>
	<!-- フラグ -->
	<!--  半角のみ,数字は桁数が有効、英字は1桁のみ -->
	<xsl:param name="li_number_format">1.</xsl:param>
	<xsl:variable name="list_number_format">
		<xsl:choose>
			<xsl:when test="$li_number_format!=''">
				<xsl:value-of select="$li_number_format"/>
			</xsl:when>
			<xsl:otherwise>1.</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:param name="li_number_level"/>
	<xsl:variable name="list_number_level">
		<xsl:choose>
			<xsl:when test="$li_number_format!='1.'">
				<xsl:value-of select="multiple"/>
			</xsl:when>
			<xsl:otherwise>single</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:param name="li_unnumbered_label">・</xsl:param>
	<xsl:variable name="list_unnumbered_label">
		<xsl:choose>
			<xsl:when test="$li_unnumbered_label!=''">
				<xsl:value-of select="$li_unnumbered_label"/>
			</xsl:when>
			<xsl:otherwise>・</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!-- アクセス性に関するプロパティ -->
	<xsl:param name="li_source-document"/>
	<xsl:variable name="list_source-document">
		<xsl:value-of select="$li_source-document"/>
	</xsl:variable>
	<xsl:param name="li_role"/>
	<xsl:variable name="list_role">
		<xsl:value-of select="$li_role"/>
	</xsl:variable>
	<!-- background-attachment:( scroll | fixed | inherit) -->
	<xsl:param name="li_background-attachment">fixed</xsl:param>
	<xsl:variable name="list_background-attachment">
		<xsl:choose>
			<xsl:when test="$li_background-attachment!=''">
				<xsl:value-of select="$li_background-attachment"/>
			</xsl:when>
			<xsl:otherwise>scroll</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!-- 背景、ボーダー、パディングのプロパティ -->
	<!-- background-color:( <color> | transparent | inherit) -->
	<xsl:param name="li_background-color">#FFFFFF</xsl:param>
	<xsl:variable name="list_background-color">
		<xsl:choose>
			<xsl:when test="$lHanten='true'">
				<xsl:value-of select="$l_hanten_bg"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$li_background-color"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!-- background-image:( <URI>  | none ) -->
	<xsl:param name="li_background-image">none</xsl:param>
	<xsl:variable name="list_background-image">
		<xsl:choose>
			<xsl:when test="$li_background-image!=''">
				<xsl:value-of select="$li_background-image"/>
			</xsl:when>
			<xsl:otherwise>none</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!-- background-repeat:( repeat | repeat-x | repeat-y | no-repeat | inherit) -->
	<xsl:param name="li_background-repeat">repeat</xsl:param>
	<xsl:variable name="list_background-repeat">
		<xsl:choose>
			<xsl:when test="$li_background-repeat!=''">
				<xsl:value-of select="$li_background-repeat"/>
			</xsl:when>
			<xsl:otherwise>repeat</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!-- background-position-horizontal:( <percentage> | <length> | left | center |right | inherit) -->
	<xsl:param name="li_background-position-horizontal">center</xsl:param>
	<xsl:variable name="list_background-position-horizontal">
		<xsl:choose>
			<xsl:when test="$li_background-position-horizontal!=''">
				<xsl:value-of select="$li_background-position-horizontal"/>
			</xsl:when>
			<xsl:otherwise>center</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!-- background-position-vertical:( <percentage> | <length> | top | center |bottom | inherit) -->
	<xsl:param name="li_background-position-vertical">center</xsl:param>
	<xsl:variable name="list_background-position-vertical">
		<xsl:choose>
			<xsl:when test="$li_background-position-vertical!=''">
				<xsl:value-of select="$li_background-position-vertical"/>
			</xsl:when>
			<xsl:otherwise>center</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!-- 定義リスト固有のボーダー(罫線)設定 -->
	<!-- list_dl_border-color -->
	<xsl:param name="li_dl_border-color">
		<xsl:value-of select="$li_border-color"/>
	</xsl:param>
	<xsl:variable name="list_dl_border-before-color">
		<xsl:choose>
			<xsl:when test="$lHanten='true'">
				<xsl:value-of select="$l_hanten_ft"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$li_dl_border-color"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_dl_border-after-color">
		<xsl:choose>
			<xsl:when test="$lHanten='true'">
				<xsl:value-of select="$l_hanten_ft"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$li_dl_border-color"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_dl_border-start-color">
		<xsl:choose>
			<xsl:when test="$lHanten='true'">
				<xsl:value-of select="$l_hanten_ft"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$li_dl_border-color"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_dl_border-end-color">
		<xsl:choose>
			<xsl:when test="$lHanten='true'">
				<xsl:value-of select="$l_hanten_ft"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$li_dl_border-color"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_dl_border-top-color">
		<xsl:choose>
			<xsl:when test="$lHanten='true'">
				<xsl:value-of select="$l_hanten_ft"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$li_dl_border-color"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_dl_border-bottom-color">
		<xsl:choose>
			<xsl:when test="$lHanten='true'">
				<xsl:value-of select="$l_hanten_ft"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$li_dl_border-color"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_dl_border-left-color">
		<xsl:choose>
			<xsl:when test="$lHanten='true'">
				<xsl:value-of select="$l_hanten_ft"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$li_dl_border-color"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_dl_border-right-color">
		<xsl:choose>
			<xsl:when test="$lHanten='true'">
				<xsl:value-of select="$l_hanten_ft"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$li_dl_border-color"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!-- list_dl_border-style -->
	<xsl:param name="li_dl_border-style"><xsl:value-of select="$li_border-style"/></xsl:param>
	<xsl:variable name="list_dl_border-before-style">
		<xsl:choose>
			<xsl:when test="$li_dl_border-style!=''">
				<xsl:value-of select="$li_dl_border-style"/>
			</xsl:when>
			<xsl:otherwise>solid</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_dl_border-after-style">
		<xsl:choose>
			<xsl:when test="$li_dl_border-style!=''">
				<xsl:value-of select="$li_dl_border-style"/>
			</xsl:when>
			<xsl:otherwise>solid</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_dl_border-start-style">
		<xsl:choose>
			<xsl:when test="$li_dl_border-style!=''">
				<xsl:value-of select="$li_dl_border-style"/>
			</xsl:when>
			<xsl:otherwise>solid</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_dl_border-end-style">
		<xsl:choose>
			<xsl:when test="$li_dl_border-style!=''">
				<xsl:value-of select="$li_dl_border-style"/>
			</xsl:when>
			<xsl:otherwise>solid</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_dl_border-top-style">
		<xsl:choose>
			<xsl:when test="$li_dl_border-style!=''">
				<xsl:value-of select="$li_dl_border-style"/>
			</xsl:when>
			<xsl:otherwise>solid</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_dl_border-bottom-style">
		<xsl:choose>
			<xsl:when test="$li_dl_border-style!=''">
				<xsl:value-of select="$li_dl_border-style"/>
			</xsl:when>
			<xsl:otherwise>solid</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_dl_border-left-style">
		<xsl:choose>
			<xsl:when test="$li_dl_border-style!=''">
				<xsl:value-of select="$li_dl_border-style"/>
			</xsl:when>
			<xsl:otherwise>solid</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_dl_border-right-style">
		<xsl:choose>
			<xsl:when test="$li_dl_border-style!=''">
				<xsl:value-of select="$li_dl_border-style"/>
			</xsl:when>
			<xsl:otherwise>solid</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!-- list_dl_border-width -->
	<xsl:param name="li_dl_border-width"><xsl:value-of select="$li_border-width"/></xsl:param>
	<xsl:variable name="list_dl_border-before-width">
		<xsl:choose>
			<xsl:when test="$li_dl_border-width!=''">
				<xsl:value-of select="$li_dl_border-width"/>
			</xsl:when>
			<xsl:otherwise>0mm</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_dl_border-after-width">
		<xsl:choose>
			<xsl:when test="$li_dl_border-width!=''">
				<xsl:value-of select="$li_dl_border-width"/>
			</xsl:when>
			<xsl:otherwise>0mm</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_dl_border-start-width">
		<xsl:choose>
			<xsl:when test="$li_dl_border-width!=''">
				<xsl:value-of select="$li_dl_border-width"/>
			</xsl:when>
			<xsl:otherwise>0mm</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_dl_border-end-width">
		<xsl:choose>
			<xsl:when test="$li_dl_border-width!=''">
				<xsl:value-of select="$li_dl_border-width"/>
			</xsl:when>
			<xsl:otherwise>0mm</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_dl_border-top-width">
		<xsl:choose>
			<xsl:when test="$li_dl_border-width!=''">
				<xsl:value-of select="$li_dl_border-width"/>
			</xsl:when>
			<xsl:otherwise>0mm</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_dl_border-bottom-width">
		<xsl:choose>
			<xsl:when test="$li_dl_border-width!=''">
				<xsl:value-of select="$li_dl_border-width"/>
			</xsl:when>
			<xsl:otherwise>0mm</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_dl_border-left-width">
		<xsl:choose>
			<xsl:when test="$li_dl_border-width!=''">
				<xsl:value-of select="$li_dl_border-width"/>
			</xsl:when>
			<xsl:otherwise>0mm</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_dl_border-right-width">
		<xsl:choose>
			<xsl:when test="$li_dl_border-width!=''">
				<xsl:value-of select="$li_dl_border-width"/>
			</xsl:when>
			<xsl:otherwise>0mm</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!-- 順序つきリスト固有のボーダー(罫線)設定 -->
	<!-- list_ol_border-color -->
	<xsl:param name="li_ol_border-color">
		<xsl:value-of select="$li_border-color"/>
	</xsl:param>
	<xsl:variable name="list_ol_border-before-color">
		<xsl:choose>
			<xsl:when test="$lHanten='true'">
				<xsl:value-of select="$l_hanten_ft"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$li_ol_border-color"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_ol_border-after-color">
		<xsl:choose>
			<xsl:when test="$lHanten='true'">
				<xsl:value-of select="$l_hanten_ft"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$li_ol_border-color"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_ol_border-start-color">
		<xsl:choose>
			<xsl:when test="$lHanten='true'">
				<xsl:value-of select="$l_hanten_ft"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$li_ol_border-color"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_ol_border-end-color">
		<xsl:choose>
			<xsl:when test="$lHanten='true'">
				<xsl:value-of select="$l_hanten_ft"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$li_ol_border-color"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_ol_border-top-color">
		<xsl:choose>
			<xsl:when test="$lHanten='true'">
				<xsl:value-of select="$l_hanten_ft"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$li_ol_border-color"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_ol_border-bottom-color">
		<xsl:choose>
			<xsl:when test="$lHanten='true'">
				<xsl:value-of select="$l_hanten_ft"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$li_ol_border-color"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_ol_border-left-color">
		<xsl:choose>
			<xsl:when test="$lHanten='true'">
				<xsl:value-of select="$l_hanten_ft"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$li_ol_border-color"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_ol_border-right-color">
		<xsl:choose>
			<xsl:when test="$lHanten='true'">
				<xsl:value-of select="$l_hanten_ft"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$li_ol_border-color"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!-- list_ol_border-style -->
	<xsl:param name="li_ol_border-style"><xsl:value-of select="$li_border-style"/></xsl:param>
	<xsl:variable name="list_ol_border-before-style">
		<xsl:choose>
			<xsl:when test="$li_ol_border-style!=''">
				<xsl:value-of select="$li_ol_border-style"/>
			</xsl:when>
			<xsl:otherwise>solid</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_ol_border-after-style">
		<xsl:choose>
			<xsl:when test="$li_ol_border-style!=''">
				<xsl:value-of select="$li_ol_border-style"/>
			</xsl:when>
			<xsl:otherwise>solid</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_ol_border-start-style">
		<xsl:choose>
			<xsl:when test="$li_ol_border-style!=''">
				<xsl:value-of select="$li_ol_border-style"/>
			</xsl:when>
			<xsl:otherwise>solid</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_ol_border-end-style">
		<xsl:choose>
			<xsl:when test="$li_ol_border-style!=''">
				<xsl:value-of select="$li_ol_border-style"/>
			</xsl:when>
			<xsl:otherwise>solid</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_ol_border-top-style">
		<xsl:choose>
			<xsl:when test="$li_ol_border-style!=''">
				<xsl:value-of select="$li_ol_border-style"/>
			</xsl:when>
			<xsl:otherwise>solid</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_ol_border-bottom-style">
		<xsl:choose>
			<xsl:when test="$li_ol_border-style!=''">
				<xsl:value-of select="$li_ol_border-style"/>
			</xsl:when>
			<xsl:otherwise>solid</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_ol_border-left-style">
		<xsl:choose>
			<xsl:when test="$li_ol_border-style!=''">
				<xsl:value-of select="$li_ol_border-style"/>
			</xsl:when>
			<xsl:otherwise>solid</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_ol_border-right-style">
		<xsl:choose>
			<xsl:when test="$li_ol_border-style!=''">
				<xsl:value-of select="$li_ol_border-style"/>
			</xsl:when>
			<xsl:otherwise>solid</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!-- list_ol_border-width -->
	<xsl:param name="li_ol_border-width"><xsl:value-of select="$li_border-width"/></xsl:param>
	<xsl:variable name="list_ol_border-before-width">
		<xsl:choose>
			<xsl:when test="$li_ol_border-width!=''">
				<xsl:value-of select="$li_ol_border-width"/>
			</xsl:when>
			<xsl:otherwise>0mm</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_ol_border-after-width">
		<xsl:choose>
			<xsl:when test="$li_ol_border-width!=''">
				<xsl:value-of select="$li_ol_border-width"/>
			</xsl:when>
			<xsl:otherwise>0mm</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_ol_border-start-width">
		<xsl:choose>
			<xsl:when test="$li_ol_border-width!=''">
				<xsl:value-of select="$li_ol_border-width"/>
			</xsl:when>
			<xsl:otherwise>0mm</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_ol_border-end-width">
		<xsl:choose>
			<xsl:when test="$li_ol_border-width!=''">
				<xsl:value-of select="$li_ol_border-width"/>
			</xsl:when>
			<xsl:otherwise>0mm</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_ol_border-top-width">
		<xsl:choose>
			<xsl:when test="$li_ol_border-width!=''">
				<xsl:value-of select="$li_ol_border-width"/>
			</xsl:when>
			<xsl:otherwise>0mm</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_ol_border-bottom-width">
		<xsl:choose>
			<xsl:when test="$li_ol_border-width!=''">
				<xsl:value-of select="$li_ol_border-width"/>
			</xsl:when>
			<xsl:otherwise>0mm</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_ol_border-left-width">
		<xsl:choose>
			<xsl:when test="$li_ol_border-width!=''">
				<xsl:value-of select="$li_ol_border-width"/>
			</xsl:when>
			<xsl:otherwise>0mm</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_ol_border-right-width">
		<xsl:choose>
			<xsl:when test="$li_ol_border-width!=''">
				<xsl:value-of select="$li_ol_border-width"/>
			</xsl:when>
			<xsl:otherwise>0mm</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!-- 順序なしリスト固有のボーダー(罫線)設定 -->
	<!-- list_ul_border-color -->
	<xsl:param name="li_ul_border-color">
		<xsl:value-of select="$li_border-color"/>
	</xsl:param>
	<xsl:variable name="list_ul_border-before-color">
		<xsl:choose>
			<xsl:when test="$lHanten='true'">
				<xsl:value-of select="$l_hanten_ft"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$li_ul_border-color"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_ul_border-after-color">
		<xsl:choose>
			<xsl:when test="$lHanten='true'">
				<xsl:value-of select="$l_hanten_ft"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$li_ul_border-color"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_ul_border-start-color">
		<xsl:choose>
			<xsl:when test="$lHanten='true'">
				<xsl:value-of select="$l_hanten_ft"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$li_ul_border-color"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_ul_border-end-color">
		<xsl:choose>
			<xsl:when test="$lHanten='true'">
				<xsl:value-of select="$l_hanten_ft"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$li_ul_border-color"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_ul_border-top-color">
		<xsl:choose>
			<xsl:when test="$lHanten='true'">
				<xsl:value-of select="$l_hanten_ft"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$li_ul_border-color"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_ul_border-bottom-color">
		<xsl:choose>
			<xsl:when test="$lHanten='true'">
				<xsl:value-of select="$l_hanten_ft"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$li_ul_border-color"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_ul_border-left-color">
		<xsl:choose>
			<xsl:when test="$lHanten='true'">
				<xsl:value-of select="$l_hanten_ft"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$li_ul_border-color"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_ul_border-right-color">
		<xsl:choose>
			<xsl:when test="$lHanten='true'">
				<xsl:value-of select="$l_hanten_ft"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$li_ul_border-color"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!-- list_ul_border-style -->
	<xsl:param name="li_ul_border-style"><xsl:value-of select="$li_border-style"/></xsl:param>
	<xsl:variable name="list_ul_border-before-style">
		<xsl:choose>
			<xsl:when test="$li_ul_border-style!=''">
				<xsl:value-of select="$li_ul_border-style"/>
			</xsl:when>
			<xsl:otherwise>solid</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_ul_border-after-style">
		<xsl:choose>
			<xsl:when test="$li_ul_border-style!=''">
				<xsl:value-of select="$li_ul_border-style"/>
			</xsl:when>
			<xsl:otherwise>solid</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_ul_border-start-style">
		<xsl:choose>
			<xsl:when test="$li_ul_border-style!=''">
				<xsl:value-of select="$li_ul_border-style"/>
			</xsl:when>
			<xsl:otherwise>solid</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_ul_border-end-style">
		<xsl:choose>
			<xsl:when test="$li_ul_border-style!=''">
				<xsl:value-of select="$li_ul_border-style"/>
			</xsl:when>
			<xsl:otherwise>solid</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_ul_border-top-style">
		<xsl:choose>
			<xsl:when test="$li_ul_border-style!=''">
				<xsl:value-of select="$li_ul_border-style"/>
			</xsl:when>
			<xsl:otherwise>solid</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_ul_border-bottom-style">
		<xsl:choose>
			<xsl:when test="$li_ul_border-style!=''">
				<xsl:value-of select="$li_ul_border-style"/>
			</xsl:when>
			<xsl:otherwise>solid</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_ul_border-left-style">
		<xsl:choose>
			<xsl:when test="$li_ul_border-style!=''">
				<xsl:value-of select="$li_ul_border-style"/>
			</xsl:when>
			<xsl:otherwise>solid</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_ul_border-right-style">
		<xsl:choose>
			<xsl:when test="$li_ul_border-style!=''">
				<xsl:value-of select="$li_ul_border-style"/>
			</xsl:when>
			<xsl:otherwise>solid</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!-- list_ul_border-width -->
	<xsl:param name="li_ul_border-width"><xsl:value-of select="$li_border-width"/></xsl:param>
	<xsl:variable name="list_ul_border-before-width">
		<xsl:choose>
			<xsl:when test="$li_ul_border-width!=''">
				<xsl:value-of select="$li_ul_border-width"/>
			</xsl:when>
			<xsl:otherwise>0mm</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_ul_border-after-width">
		<xsl:choose>
			<xsl:when test="$li_ul_border-width!=''">
				<xsl:value-of select="$li_ul_border-width"/>
			</xsl:when>
			<xsl:otherwise>0mm</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_ul_border-start-width">
		<xsl:choose>
			<xsl:when test="$li_ul_border-width!=''">
				<xsl:value-of select="$li_ul_border-width"/>
			</xsl:when>
			<xsl:otherwise>0mm</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_ul_border-end-width">
		<xsl:choose>
			<xsl:when test="$li_ul_border-width!=''">
				<xsl:value-of select="$li_ul_border-width"/>
			</xsl:when>
			<xsl:otherwise>0mm</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_ul_border-top-width">
		<xsl:choose>
			<xsl:when test="$li_ul_border-width!=''">
				<xsl:value-of select="$li_ul_border-width"/>
			</xsl:when>
			<xsl:otherwise>0mm</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_ul_border-bottom-width">
		<xsl:choose>
			<xsl:when test="$li_ul_border-width!=''">
				<xsl:value-of select="$li_ul_border-width"/>
			</xsl:when>
			<xsl:otherwise>0mm</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_ul_border-left-width">
		<xsl:choose>
			<xsl:when test="$li_ul_border-width!=''">
				<xsl:value-of select="$li_ul_border-width"/>
			</xsl:when>
			<xsl:otherwise>0mm</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_ul_border-right-width">
		<xsl:choose>
			<xsl:when test="$li_ul_border-width!=''">
				<xsl:value-of select="$li_ul_border-width"/>
			</xsl:when>
			<xsl:otherwise>0mm</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!-- list_padding -->
	<xsl:param name="li_padding">0.0mm</xsl:param>
	<xsl:variable name="list_padding-before">
		<xsl:choose>
			<xsl:when test="$li_padding!=''">
				<xsl:value-of select="$li_padding"/>
			</xsl:when>
			<xsl:otherwise>0em</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_padding-after">
		<xsl:choose>
			<xsl:when test="$li_padding!=''">
				<xsl:value-of select="$li_padding"/>
			</xsl:when>
			<xsl:otherwise>0em</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_padding-start">
		<xsl:choose>
			<xsl:when test="$li_padding!=''">
				<xsl:value-of select="$li_padding"/>
			</xsl:when>
			<xsl:otherwise>0em</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_padding-end">
		<xsl:choose>
			<xsl:when test="$li_padding!=''">
				<xsl:value-of select="$li_padding"/>
			</xsl:when>
			<xsl:otherwise>0em</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_padding-top">
		<xsl:choose>
			<xsl:when test="$li_padding!=''">
				<xsl:value-of select="$li_padding"/>
			</xsl:when>
			<xsl:otherwise>0em</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_padding-bottom">
		<xsl:choose>
			<xsl:when test="$li_padding!=''">
				<xsl:value-of select="$li_padding"/>
			</xsl:when>
			<xsl:otherwise>0em</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_padding-left">
		<xsl:choose>
			<xsl:when test="$li_padding!=''">
				<xsl:value-of select="$li_padding"/>
			</xsl:when>
			<xsl:otherwise>0em</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_padding-right">
		<xsl:choose>
			<xsl:when test="$li_padding!=''">
				<xsl:value-of select="$li_padding"/>
			</xsl:when>
			<xsl:otherwise>0em</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!-- list-margin -->
	<xsl:param name="li_margin_tb">0.0em</xsl:param>
	<xsl:param name="li_margin_lr">0.0em</xsl:param>
	<xsl:variable name="list_margin-before">
		<xsl:choose>
			<xsl:when test="$li_margin_tb!=''">
				<xsl:value-of select="$li_margin_tb"/>
			</xsl:when>
			<xsl:otherwise>0em</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_margin-after">
		<xsl:choose>
			<xsl:when test="$li_margin_tb!=''">
				<xsl:value-of select="$li_margin_tb"/>
			</xsl:when>
			<xsl:otherwise>0em</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_margin-start">
		<xsl:choose>
			<xsl:when test="$li_margin_lr!=''">
				<xsl:value-of select="$li_margin_lr"/>
			</xsl:when>
			<xsl:otherwise>0em</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_margin-end">
		<xsl:choose>
			<xsl:when test="$li_margin_lr!=''">
				<xsl:value-of select="$li_margin_lr"/>
			</xsl:when>
			<xsl:otherwise>0em</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_margin-top">
		<xsl:choose>
			<xsl:when test="$li_margin_tb!=''">
				<xsl:value-of select="$li_margin_tb"/>
			</xsl:when>
			<xsl:otherwise>0em</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_margin-bottom">
		<xsl:choose>
			<xsl:when test="$li_margin_tb!=''">
				<xsl:value-of select="$li_margin_tb"/>
			</xsl:when>
			<xsl:otherwise>0em</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_margin-left">
		<xsl:choose>
			<xsl:when test="$li_margin_lr!=''">
				<xsl:value-of select="$li_margin_lr"/>
			</xsl:when>
			<xsl:otherwise>0em</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="list_margin-right">
		<xsl:choose>
			<xsl:when test="$li_margin_lr!=''">
				<xsl:value-of select="$li_margin_lr"/>
			</xsl:when>
			<xsl:otherwise>0em</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:param name="li_space-before">6.75mm</xsl:param>
	<xsl:variable name="list_space-before">
		<xsl:choose>
			<xsl:when test="$li_space-before!=''">
				<xsl:value-of select="$li_space-before"/>
			</xsl:when>
			<xsl:otherwise>0.1em</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:param name="li_space-after">6.75mm</xsl:param>
	<xsl:variable name="list_space-after">
		<xsl:choose>
			<xsl:when test="$li_space-after!=''">
				<xsl:value-of select="$li_space-after"/>
			</xsl:when>
			<xsl:otherwise>0.1em</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!-- break-*:( auto | column | page | even-page | odd-page | inherit) -->
	<xsl:param name="li_break-after">auto</xsl:param>
	<xsl:variable name="list_break-after">
		<xsl:choose>
			<xsl:when test="$li_break-after!=''">
				<xsl:value-of select="$li_break-after"/>
			</xsl:when>
			<xsl:otherwise>auto</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:param name="li_break-before">auto</xsl:param>
	<xsl:variable name="list_break-before">
		<xsl:choose>
			<xsl:when test="$li_break-before!=''">
				<xsl:value-of select="$li_break-before"/>
			</xsl:when>
			<xsl:otherwise>auto</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
    <!-- 2010/03/25 - attributes recently not used:
	<xsl:param name="li_id"/>
	<xsl:variable name="list_id">
		<xsl:value-of select="$li_id"/>
	</xsl:variable> -->
	<xsl:param name="li_intrusion-displace"/>
	<xsl:variable name="list_intrusion-displace">
		<xsl:value-of select="$li_intrusion-displace"/>
	</xsl:variable>
	<!-- keep-*:( keep | inherit) No conversion defined on FOP 0.94 
	<xsl:param name="list_keep-together" select="'keep'"></xsl:param>
	<xsl:param name="list_keep-with-next" select="'keep'"></xsl:param>
	<xsl:param name="list_keep-with-previous" select="'keep'"></xsl:param>-->
	<!-- provisional-distance-between-starts ( <length> | <percentage> | inherit) -->
	<xsl:param name="li_provisional-distance-between-starts">3.0em</xsl:param>
	<xsl:variable name="list_provisional-distance-between-starts">
		<xsl:choose>
			<xsl:when test="$li_provisional-distance-between-starts!=''">
				<xsl:value-of select="$li_provisional-distance-between-starts"/>
			</xsl:when>
			<xsl:otherwise>1em</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!-- provisional-label-separation ( <length> | <percentage> | inherit) -->
	<xsl:param name="li_provisional-label-separation">1.0em</xsl:param>
	<xsl:variable name="list_provisional-label-separation">
		<xsl:choose>
			<xsl:when test="$li_provisional-label-separation!=''">
				<xsl:value-of select="$li_provisional-label-separation"/>
			</xsl:when>
			<xsl:otherwise>0em</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!-- provisional-distance-between-starts ( <length> | <percentage> | inherit) -->
	<xsl:param name="li_ul_provisional-distance-between-starts"/>
	<xsl:variable name="list_ul_provisional-distance-between-starts">
		<xsl:choose>
			<xsl:when test="$li_ul_provisional-distance-between-starts!=''">
				<xsl:value-of select="$li_ul_provisional-distance-between-starts"/>
			</xsl:when>
			<xsl:otherwise>1em</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!-- provisional-label-separation ( <length> | <percentage> | inherit) -->
	<xsl:param name="li_ul_provisional-label-separation"/>
	<xsl:variable name="list_ul_provisional-label-separation">
		<xsl:choose>
			<xsl:when test="$li_ul_provisional-label-separation!=''">
				<xsl:value-of select="$li_ul_provisional-label-separation"/>
			</xsl:when>
			<xsl:otherwise>0em</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!-- provisional-label-separation ( <length> | <percentage> | inherit) -->
	<xsl:param name="li_dl_provisional-distance-between-starts">6.0em</xsl:param>
	<xsl:variable name="list_dl_provisional-distance-between-starts">
		<xsl:choose>
			<xsl:when test="$li_dl_provisional-distance-between-starts!=''">
				<xsl:value-of select="$li_dl_provisional-distance-between-starts"/>
			</xsl:when>
			<xsl:otherwise>1em</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!-- provisional-label-separation ( <length> | <percentage> | inherit) -->
	<xsl:param name="li_dl_provisional-label-separation">1.0em</xsl:param>
	<xsl:variable name="list_dl_provisional-label-separation">
		<xsl:choose>
			<xsl:when test="$li_dl_provisional-label-separation!=''">
				<xsl:value-of select="$li_dl_provisional-label-separation"/>
			</xsl:when>
			<xsl:otherwise>0em</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!-- repative-align:( before | baseline | inherit) -->
	<xsl:param name="li_relative-align"/>
	<xsl:variable name="list_relative-align">
		<xsl:choose>
			<xsl:when test="$li_relative-align!=''">
				<xsl:value-of select="$li_relative-align"/>
			</xsl:when>
			<xsl:otherwise>baseline</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!-- 文字、フォントのプロパティ -->
	<!-- white-space-collapse ( false | true | inherit) -->
	<xsl:param name="li_white-space-collapse">true</xsl:param>
	<xsl:variable name="list_white-space-collapse">
		<xsl:choose>
			<xsl:when test="$li_white-space-collapse!=''">
				<xsl:value-of select="$li_white-space-collapse"/>
			</xsl:when>
			<xsl:otherwise>inherit</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:param name="li_font-family">IPAGothic</xsl:param>
	<xsl:variable name="list_font-family">
		<xsl:choose>
			<xsl:when test="$li_font-family!=''">
				<xsl:value-of select="$li_font-family"/>
			</xsl:when>
			<xsl:otherwise>inherit</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!-- font-size ( <absolute-size> | <relative-size> | <length> | <percentage> | inherit) -->
	<xsl:param name="li_font-size">10.0pt</xsl:param>
	<xsl:variable name="list_font-size">
		<xsl:choose>
			<xsl:when test="$li_font-size!=''">
				<xsl:value-of select="$li_font-size"/>
			</xsl:when>
			<xsl:otherwise>inherit</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!-- line-height ( normal | <length> | <number> | <percentage> | <space> | inherit) -->
	<xsl:param name="li_line-height">15.0pt</xsl:param>
	<xsl:variable name="list_line-height">
		<xsl:choose>
			<xsl:when test="$li_line-height!=''">
				<xsl:value-of select="$li_line-height"/>
			</xsl:when>
			<xsl:otherwise>inherit</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
<!-- text-indent -->
	<xsl:param name="li_text-indent">0em</xsl:param>
	<xsl:variable name="list_text-indent">
		<xsl:choose>
			<xsl:when test="$li_text-indent!=''">
				<xsl:value-of select="$li_text-indent"/>
			</xsl:when>
			<xsl:otherwise>0em</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!-- text-align:( start | center | end | justify | inside | outside | left | right | <string> | inherit) -->
	<xsl:param name="li_text-align">justify</xsl:param>
	<xsl:variable name="list_text-align">
		<xsl:choose>
			<xsl:when test="$li_text-align!=''">
				<xsl:value-of select="$li_text-align"/>
			</xsl:when>
			<xsl:otherwise>justify</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!-- text-align-last:( relative | start | center | end | justify | inside | outside | left | right | inherit) -->
	<xsl:param name="li_text-align-last">start</xsl:param>
	<xsl:variable name="list_text-align-last">
		<xsl:choose>
			<xsl:when test="$li_text-align-last!=''">
				<xsl:value-of select="$li_text-align-last"/>
			</xsl:when>
			<xsl:otherwise>left</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!--fontcolor設定-->
	<xsl:variable name="list_font_color">
		<xsl:choose>
			<xsl:when test="$lHanten='true'">white</xsl:when>
			<xsl:otherwise>black</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!-- attribute sets -->
	<xsl:attribute-set name="list_block">
		<xsl:attribute name="white-space-collapse"><xsl:value-of select="$list_white-space-collapse"/></xsl:attribute>
		<xsl:attribute name="font-family"><xsl:value-of select="$list_font-family"/></xsl:attribute>
		<xsl:attribute name="font-size"><xsl:value-of select="$list_font-size"/></xsl:attribute>
		<xsl:attribute name="line-height"><xsl:value-of select="$list_line-height"/></xsl:attribute>
		<xsl:attribute name="text-indent"><xsl:value-of select="$list_text-indent"/></xsl:attribute>
		<xsl:attribute name="text-align"><xsl:value-of select="$list_text-align"/></xsl:attribute>
		<xsl:attribute name="text-align-last"><xsl:value-of select="$list_text-align-last"/></xsl:attribute>
		<xsl:attribute name="color"><xsl:value-of select="$list_font_color"/></xsl:attribute>
	</xsl:attribute-set>
	<xsl:attribute-set name="list_ul_list_block">
		<xsl:attribute name="provisional-distance-between-starts"><xsl:value-of select="$list_ul_provisional-distance-between-starts"/></xsl:attribute>
		<xsl:attribute name="provisional-label-separation"><xsl:value-of select="$list_ul_provisional-label-separation"/></xsl:attribute>
		<xsl:attribute name="white-space-collapse"><xsl:value-of select="$list_white-space-collapse"/></xsl:attribute>
		<!--罫線と改ページ，パディング・マージンそれぞれに関する属性をlist_ul_list_itemから移動　20110115桑野-->
		<xsl:attribute name="border-before-color"><xsl:value-of select="$list_ul_border-before-color"/></xsl:attribute>
		<xsl:attribute name="border-before-style"><xsl:value-of select="$list_ul_border-before-style"/></xsl:attribute>
		<xsl:attribute name="border-before-width"><xsl:value-of select="$list_ul_border-before-width"/></xsl:attribute>
		<xsl:attribute name="border-after-color"><xsl:value-of select="$list_ul_border-after-color"/></xsl:attribute>
		<xsl:attribute name="border-after-style"><xsl:value-of select="$list_ul_border-after-style"/></xsl:attribute>
		<xsl:attribute name="border-after-width"><xsl:value-of select="$list_ul_border-after-width"/></xsl:attribute>
		<xsl:attribute name="border-start-color"><xsl:value-of select="$list_ul_border-start-color"/></xsl:attribute>
		<xsl:attribute name="border-start-style"><xsl:value-of select="$list_ul_border-start-style"/></xsl:attribute>
		<xsl:attribute name="border-start-width"><xsl:value-of select="$list_ul_border-start-width"/></xsl:attribute>
		<xsl:attribute name="border-end-color"><xsl:value-of select="$list_ul_border-end-color"/></xsl:attribute>
		<xsl:attribute name="border-end-style"><xsl:value-of select="$list_ul_border-end-style"/></xsl:attribute>
		<xsl:attribute name="border-end-width"><xsl:value-of select="$list_ul_border-end-width"/></xsl:attribute>
		<xsl:attribute name="border-top-color"><xsl:value-of select="$list_ul_border-top-color"/></xsl:attribute>
		<xsl:attribute name="border-top-style"><xsl:value-of select="$list_ul_border-top-style"/></xsl:attribute>
		<xsl:attribute name="border-top-width"><xsl:value-of select="$list_ul_border-top-width"/></xsl:attribute>
		<xsl:attribute name="border-bottom-color"><xsl:value-of select="$list_ul_border-bottom-color"/></xsl:attribute>
		<xsl:attribute name="border-bottom-style"><xsl:value-of select="$list_ul_border-bottom-style"/></xsl:attribute>
		<xsl:attribute name="border-bottom-width"><xsl:value-of select="$list_ul_border-bottom-width"/></xsl:attribute>
		<xsl:attribute name="border-left-color"><xsl:value-of select="$list_ul_border-left-color"/></xsl:attribute>
		<xsl:attribute name="border-left-style"><xsl:value-of select="$list_ul_border-left-style"/></xsl:attribute>
		<xsl:attribute name="border-left-width"><xsl:value-of select="$list_ul_border-left-width"/></xsl:attribute>
		<xsl:attribute name="border-right-color"><xsl:value-of select="$list_ul_border-right-color"/></xsl:attribute>
		<xsl:attribute name="border-right-style"><xsl:value-of select="$list_ul_border-right-style"/></xsl:attribute>
		<xsl:attribute name="border-right-width"><xsl:value-of select="$list_ul_border-right-width"/></xsl:attribute>
		<xsl:attribute name="break-after"><xsl:value-of select="$list_break-after"/></xsl:attribute>
		<xsl:attribute name="break-before"><xsl:value-of select="$list_break-before"/></xsl:attribute>
		<xsl:attribute name="padding-before"><xsl:value-of select="$list_padding-before"/></xsl:attribute>
		<xsl:attribute name="padding-after"><xsl:value-of select="$list_padding-after"/></xsl:attribute>
		<xsl:attribute name="padding-start"><xsl:value-of select="$list_padding-start"/></xsl:attribute>
		<xsl:attribute name="padding-end"><xsl:value-of select="$list_padding-end"/></xsl:attribute>
		<xsl:attribute name="padding-top"><xsl:value-of select="$list_padding-top"/></xsl:attribute>
		<xsl:attribute name="padding-bottom"><xsl:value-of select="$list_padding-bottom"/></xsl:attribute>
		<xsl:attribute name="padding-left"><xsl:value-of select="$list_padding-left"/></xsl:attribute>
		<xsl:attribute name="padding-right"><xsl:value-of select="$list_padding-right"/></xsl:attribute>
		<xsl:attribute name="margin-top"><xsl:value-of select="$list_margin-top"/></xsl:attribute>
		<xsl:attribute name="margin-bottom"><xsl:value-of select="$list_margin-bottom"/></xsl:attribute>
		<xsl:attribute name="margin-left"><xsl:value-of select="$list_margin-left"/></xsl:attribute>
		<xsl:attribute name="margin-right"><xsl:value-of select="$list_margin-right"/></xsl:attribute>
	</xsl:attribute-set>
	<xsl:attribute-set name="list_ul_list_item">
		<xsl:attribute name="space-before"><xsl:value-of select="$list_space-before"/></xsl:attribute>
		<xsl:attribute name="space-after"><xsl:value-of select="$list_space-after"/></xsl:attribute>
		<xsl:attribute name="source-document"><xsl:value-of select="$list_source-document"/></xsl:attribute>
		<xsl:attribute name="role"><xsl:value-of select="$list_role"/></xsl:attribute>
		<!-- 2010/03/25 - obsolete(?) attribute :
			<xsl:attribute name="id"><xsl:value-of select="$list_id"/></xsl:attribute> -->
		<xsl:attribute name="relative-align"><xsl:value-of select="$list_relative-align"/></xsl:attribute>
		<xsl:attribute name="background-attachment"><xsl:value-of select="$list_background-attachment"/></xsl:attribute>
		<xsl:attribute name="background-color"><xsl:value-of select="$list_background-color"/></xsl:attribute>
		<xsl:attribute name="background-image"><xsl:value-of select="$list_background-image"/></xsl:attribute>
		<xsl:attribute name="background-repeat"><xsl:value-of select="$list_background-repeat"/></xsl:attribute>
		<xsl:attribute name="background-position-horizontal"><xsl:value-of select="$list_background-position-horizontal"/></xsl:attribute>
		<xsl:attribute name="background-position-vertical"><xsl:value-of select="$list_background-position-vertical"/></xsl:attribute>
	</xsl:attribute-set>
	<xsl:attribute-set name="list_ol_list_block">
		<xsl:attribute name="provisional-distance-between-starts"><xsl:choose><xsl:when test="$list_number_format='1.'"><xsl:value-of select="$list_ul_provisional-distance-between-starts"/></xsl:when><xsl:otherwise><xsl:value-of select="$list_provisional-distance-between-starts"/></xsl:otherwise></xsl:choose></xsl:attribute>
		<xsl:attribute name="provisional-label-separation"><xsl:choose><xsl:when test="$list_number_format='1.'"><xsl:value-of select="$list_ul_provisional-label-separation"/></xsl:when><xsl:otherwise><xsl:value-of select="$list_provisional-label-separation"/></xsl:otherwise></xsl:choose></xsl:attribute>
		<xsl:attribute name="white-space-collapse"><xsl:value-of select="$list_white-space-collapse"/></xsl:attribute>
		<!--罫線と改ページ，パディング・マージンそれぞれに関する属性をlist_ol_list_itemから移動　20110115桑野-->
		<xsl:attribute name="border-before-color"><xsl:value-of select="$list_ol_border-before-color"/></xsl:attribute>
		<xsl:attribute name="border-before-style"><xsl:value-of select="$list_ol_border-before-style"/></xsl:attribute>
		<xsl:attribute name="border-before-width"><xsl:value-of select="$list_ol_border-before-width"/></xsl:attribute>
		<xsl:attribute name="border-after-color"><xsl:value-of select="$list_ol_border-after-color"/></xsl:attribute>
		<xsl:attribute name="border-after-style"><xsl:value-of select="$list_ol_border-after-style"/></xsl:attribute>
		<xsl:attribute name="border-after-width"><xsl:value-of select="$list_ol_border-after-width"/></xsl:attribute>
		<xsl:attribute name="border-start-color"><xsl:value-of select="$list_ol_border-start-color"/></xsl:attribute>
		<xsl:attribute name="border-start-style"><xsl:value-of select="$list_ol_border-start-style"/></xsl:attribute>
		<xsl:attribute name="border-start-width"><xsl:value-of select="$list_ol_border-start-width"/></xsl:attribute>
		<xsl:attribute name="border-end-color"><xsl:value-of select="$list_ol_border-end-color"/></xsl:attribute>
		<xsl:attribute name="border-end-style"><xsl:value-of select="$list_ol_border-end-style"/></xsl:attribute>
		<xsl:attribute name="border-end-width"><xsl:value-of select="$list_ol_border-end-width"/></xsl:attribute>
		<xsl:attribute name="border-top-color"><xsl:value-of select="$list_ol_border-top-color"/></xsl:attribute>
		<xsl:attribute name="border-top-style"><xsl:value-of select="$list_ol_border-top-style"/></xsl:attribute>
		<xsl:attribute name="border-top-width"><xsl:value-of select="$list_ol_border-top-width"/></xsl:attribute>
		<xsl:attribute name="border-bottom-color"><xsl:value-of select="$list_ol_border-bottom-color"/></xsl:attribute>
		<xsl:attribute name="border-bottom-style"><xsl:value-of select="$list_ol_border-bottom-style"/></xsl:attribute>
		<xsl:attribute name="border-bottom-width"><xsl:value-of select="$list_ol_border-bottom-width"/></xsl:attribute>
		<xsl:attribute name="border-left-color"><xsl:value-of select="$list_ol_border-left-color"/></xsl:attribute>
		<xsl:attribute name="border-left-style"><xsl:value-of select="$list_ol_border-left-style"/></xsl:attribute>
		<xsl:attribute name="border-left-width"><xsl:value-of select="$list_ol_border-left-width"/></xsl:attribute>
		<xsl:attribute name="border-right-color"><xsl:value-of select="$list_ol_border-right-color"/></xsl:attribute>
		<xsl:attribute name="border-right-style"><xsl:value-of select="$list_ol_border-right-style"/></xsl:attribute>
		<xsl:attribute name="border-right-width"><xsl:value-of select="$list_ol_border-right-width"/></xsl:attribute>
		<xsl:attribute name="break-after"><xsl:value-of select="$list_break-after"/></xsl:attribute>
		<xsl:attribute name="break-before"><xsl:value-of select="$list_break-before"/></xsl:attribute>
		<xsl:attribute name="padding-before"><xsl:value-of select="$list_padding-before"/></xsl:attribute>
		<xsl:attribute name="padding-after"><xsl:value-of select="$list_padding-after"/></xsl:attribute>
		<xsl:attribute name="padding-start"><xsl:value-of select="$list_padding-start"/></xsl:attribute>
		<xsl:attribute name="padding-end"><xsl:value-of select="$list_padding-end"/></xsl:attribute>
		<xsl:attribute name="padding-top"><xsl:value-of select="$list_padding-top"/></xsl:attribute>
		<xsl:attribute name="padding-bottom"><xsl:value-of select="$list_padding-bottom"/></xsl:attribute>
		<xsl:attribute name="padding-left"><xsl:value-of select="$list_padding-left"/></xsl:attribute>
		<xsl:attribute name="padding-right"><xsl:value-of select="$list_padding-right"/></xsl:attribute>
		<xsl:attribute name="margin-top"><xsl:value-of select="$list_margin-top"/></xsl:attribute>
		<xsl:attribute name="margin-bottom"><xsl:value-of select="$list_margin-bottom"/></xsl:attribute>
		<xsl:attribute name="margin-left"><xsl:value-of select="$list_margin-left"/></xsl:attribute>
		<xsl:attribute name="margin-right"><xsl:value-of select="$list_margin-right"/></xsl:attribute>
	</xsl:attribute-set>
	<xsl:attribute-set name="list_ol_list_item">
		<xsl:attribute name="space-before"><xsl:value-of select="$list_space-before"/></xsl:attribute>
		<xsl:attribute name="space-after"><xsl:value-of select="$list_space-after"/></xsl:attribute>
		<xsl:attribute name="source-document"><xsl:value-of select="$list_source-document"/></xsl:attribute>
		<xsl:attribute name="role"><xsl:value-of select="$list_role"/></xsl:attribute>
		<!-- 2010/03/25 - obsolete(?) attribute :
			<xsl:attribute name="id"><xsl:value-of select="$list_id"/></xsl:attribute> -->
		<xsl:attribute name="relative-align"><xsl:value-of select="$list_relative-align"/></xsl:attribute>
		<xsl:attribute name="background-attachment"><xsl:value-of select="$list_background-attachment"/></xsl:attribute>
		<xsl:attribute name="background-color"><xsl:value-of select="$list_background-color"/></xsl:attribute>
		<xsl:attribute name="background-image"><xsl:value-of select="$list_background-image"/></xsl:attribute>
		<xsl:attribute name="background-repeat"><xsl:value-of select="$list_background-repeat"/></xsl:attribute>
		<xsl:attribute name="background-position-horizontal"><xsl:value-of select="$list_background-position-horizontal"/></xsl:attribute>
		<xsl:attribute name="background-position-vertical"><xsl:value-of select="$list_background-position-vertical"/></xsl:attribute>
	</xsl:attribute-set>
	<xsl:attribute-set name="list_dl_list_block">
		<xsl:attribute name="provisional-distance-between-starts"><xsl:value-of select="$list_dl_provisional-distance-between-starts"/></xsl:attribute>
		<xsl:attribute name="provisional-label-separation"><xsl:value-of select="$list_dl_provisional-label-separation"/></xsl:attribute>
		<xsl:attribute name="white-space-collapse"><xsl:value-of select="$list_white-space-collapse"/></xsl:attribute>
		<xsl:attribute name="border-before-color"><xsl:value-of select="$list_dl_border-before-color"/></xsl:attribute>
		<xsl:attribute name="border-before-style"><xsl:value-of select="$list_dl_border-before-style"/></xsl:attribute>
		<xsl:attribute name="border-before-width"><xsl:value-of select="$list_dl_border-before-width"/></xsl:attribute>
		<xsl:attribute name="border-after-color"><xsl:value-of select="$list_dl_border-after-color"/></xsl:attribute>
		<xsl:attribute name="border-after-style"><xsl:value-of select="$list_dl_border-after-style"/></xsl:attribute>
		<xsl:attribute name="border-after-width"><xsl:value-of select="$list_dl_border-after-width"/></xsl:attribute>
		<xsl:attribute name="border-start-color"><xsl:value-of select="$list_dl_border-start-color"/></xsl:attribute>
		<xsl:attribute name="border-start-style"><xsl:value-of select="$list_dl_border-start-style"/></xsl:attribute>
		<xsl:attribute name="border-start-width"><xsl:value-of select="$list_dl_border-start-width"/></xsl:attribute>
		<xsl:attribute name="border-end-color"><xsl:value-of select="$list_dl_border-end-color"/></xsl:attribute>
		<xsl:attribute name="border-end-style"><xsl:value-of select="$list_dl_border-end-style"/></xsl:attribute>
		<xsl:attribute name="border-end-width"><xsl:value-of select="$list_dl_border-end-width"/></xsl:attribute>
		<xsl:attribute name="border-top-color"><xsl:value-of select="$list_dl_border-top-color"/></xsl:attribute>
		<xsl:attribute name="border-top-style"><xsl:value-of select="$list_dl_border-top-style"/></xsl:attribute>
		<xsl:attribute name="border-top-width"><xsl:value-of select="$list_dl_border-top-width"/></xsl:attribute>
		<xsl:attribute name="border-bottom-color"><xsl:value-of select="$list_dl_border-bottom-color"/></xsl:attribute>
		<xsl:attribute name="border-bottom-style"><xsl:value-of select="$list_dl_border-bottom-style"/></xsl:attribute>
		<xsl:attribute name="border-bottom-width"><xsl:value-of select="$list_dl_border-bottom-width"/></xsl:attribute>
		<xsl:attribute name="border-left-color"><xsl:value-of select="$list_dl_border-left-color"/></xsl:attribute>
		<xsl:attribute name="border-left-style"><xsl:value-of select="$list_dl_border-left-style"/></xsl:attribute>
		<xsl:attribute name="border-left-width"><xsl:value-of select="$list_dl_border-left-width"/></xsl:attribute>
		<xsl:attribute name="border-right-color"><xsl:value-of select="$list_dl_border-right-color"/></xsl:attribute>
		<xsl:attribute name="border-right-style"><xsl:value-of select="$list_dl_border-right-style"/></xsl:attribute>
		<xsl:attribute name="border-right-width"><xsl:value-of select="$list_dl_border-right-width"/></xsl:attribute>
		<!--改ページ，パディング・マージンに関する属性をlist_dl_list_itemから移動　20110115桑野-->
		<xsl:attribute name="break-after"><xsl:value-of select="$list_break-after"/></xsl:attribute>
		<xsl:attribute name="break-before"><xsl:value-of select="$list_break-before"/></xsl:attribute>
		<xsl:attribute name="padding-before"><xsl:value-of select="$list_padding-before"/></xsl:attribute>
		<xsl:attribute name="padding-after"><xsl:value-of select="$list_padding-after"/></xsl:attribute>
		<xsl:attribute name="padding-start"><xsl:value-of select="$list_padding-start"/></xsl:attribute>
		<xsl:attribute name="padding-end"><xsl:value-of select="$list_padding-end"/></xsl:attribute>
		<xsl:attribute name="padding-top"><xsl:value-of select="$list_padding-top"/></xsl:attribute>
		<xsl:attribute name="padding-bottom"><xsl:value-of select="$list_padding-bottom"/></xsl:attribute>
		<xsl:attribute name="padding-left"><xsl:value-of select="$list_padding-left"/></xsl:attribute>
		<xsl:attribute name="padding-right"><xsl:value-of select="$list_padding-right"/></xsl:attribute>
		<xsl:attribute name="margin-top"><xsl:value-of select="$list_margin-top"/></xsl:attribute>
		<xsl:attribute name="margin-bottom"><xsl:value-of select="$list_margin-bottom"/></xsl:attribute>
		<xsl:attribute name="margin-left"><xsl:value-of select="$list_margin-left"/></xsl:attribute>
		<xsl:attribute name="margin-right"><xsl:value-of select="$list_margin-right"/></xsl:attribute>
	</xsl:attribute-set>
	<xsl:attribute-set name="list_dl_list_item">
		<xsl:attribute name="space-before"><xsl:value-of select="$list_space-before"/></xsl:attribute>
		<xsl:attribute name="space-after"><xsl:value-of select="$list_space-after"/></xsl:attribute>
		<xsl:attribute name="source-document"><xsl:value-of select="$list_source-document"/></xsl:attribute>
		<xsl:attribute name="role"><xsl:value-of select="$list_role"/></xsl:attribute>
		<!-- 2010/03/25 - obsolete(?) attribute :
			<xsl:attribute name="id"><xsl:value-of select="$list_id"/></xsl:attribute> -->
		<xsl:attribute name="relative-align"><xsl:value-of select="$list_relative-align"/></xsl:attribute>
		<xsl:attribute name="background-attachment"><xsl:value-of select="$list_background-attachment"/></xsl:attribute>
		<xsl:attribute name="background-color"><xsl:value-of select="$list_background-color"/></xsl:attribute>
		<xsl:attribute name="background-image"><xsl:value-of select="$list_background-image"/></xsl:attribute>
		<xsl:attribute name="background-repeat"><xsl:value-of select="$list_background-repeat"/></xsl:attribute>
		<xsl:attribute name="background-position-horizontal"><xsl:value-of select="$list_background-position-horizontal"/></xsl:attribute>
		<xsl:attribute name="background-position-vertical"><xsl:value-of select="$list_background-position-vertical"/></xsl:attribute>
	</xsl:attribute-set>
	<xsl:attribute-set name="list_list_item_label">
		<xsl:attribute name="space-before"><xsl:value-of select="$list_space-before"/></xsl:attribute>
		<!--  2010/03/25 - obsolete(?) attributes :
		<xsl:attribute name="source-document"><xsl:value-of select="$list_source-document"/></xsl:attribute>
		<xsl:attribute name="role"><xsl:value-of select="$list_role"/></xsl:attribute>
		<xsl:attribute name="id"><xsl:value-of select="$list_id"/></xsl:attribute> -->
	</xsl:attribute-set>
	<xsl:attribute-set name="list_list_item_body">
		<xsl:attribute name="space-before"><xsl:value-of select="$list_space-before"/></xsl:attribute>
	    <!--   2010/03/25 - obsolete(?) attributes :
		<xsl:attribute name="source-document"><xsl:value-of select="$list_source-document"/></xsl:attribute>
		<xsl:attribute name="role"><xsl:value-of select="$list_role"/></xsl:attribute>
		<xsl:attribute name="id"><xsl:value-of select="$list_id"/></xsl:attribute> -->
</xsl:attribute-set>
</xsl:stylesheet>
