<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:cmp="http://www.xmlconsortium.org/wg/crossmedia/"
	xmlns:fo="http://www.w3.org/1999/XSL/Format">
	<!--
		============================================================
		XMLコンソーシアム  XMP部会  技術系SG  jepaX用スタイルシート
		============================================================
		logic.xsl  【論理構造単位要素】
		============================================================
		2008-05-23  ver.0.9  by H.Sato
		2008-07-15  ver.1.0  checked by K.Kuwano
		2010-03-07  ver.1.0  revised by K.Kuwano
		2010-10-01  id_attribute modified by K.Kuwano
		2010-10-01  comment-out part deleted by K.Kuwano
		2010-10-23  add 'group0' and related logic by H.Sato
		2010-12-28  add header text "目次" to top of toc by K.Kuwano
		============================================================
	-->
	<xsl:include href="logic_attrset.xsl"/>
	<xsl:template match="div">
		<!-- idの処理 -->
		<fo:block>
			<xsl:attribute name="id">
				<xsl:choose>
					<xsl:when test="@id">
						<xsl:value-of select="@id"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="generate-id()"/>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:attribute>
			<xsl:choose>
				<!-- 表紙、目次の出力判断 -->
				<xsl:when
					test="(not(@type='表紙') or ($j_front_cover='div'))       and (not(@type='目次') or ($logic_div_mokuji_out = 'true')) ">
					<!-- ======================================================================== -->
					<xsl:choose>
						<xsl:when test="cmp:find_group(@type)=1">
							<fo:block xsl:use-attribute-sets="logic_div_group1">
								<xsl:apply-templates/>
							</fo:block>
						</xsl:when>
						<xsl:when test="cmp:find_group(@type)=2">
							<fo:block xsl:use-attribute-sets="logic_div_group2">
								<xsl:apply-templates/>
							</fo:block>
						</xsl:when>
						<xsl:when test="cmp:find_group(@type)=3">
							<fo:block xsl:use-attribute-sets="logic_div_group3">
								<xsl:apply-templates/>
							</fo:block>
						</xsl:when>
						<xsl:when test="cmp:find_group(@type)=-1">
							<xsl:choose>
								<xsl:when test="@type='表紙'">
									<fo:block
										xsl:use-attribute-sets="logic_div_hyoshi">
										<xsl:apply-templates/>
									</fo:block>
								</xsl:when>
								<xsl:when test="@type='あらすじ'">
									<fo:block
										xsl:use-attribute-sets="logic_div_arasuji">
										<xsl:apply-templates/>
									</fo:block>
								</xsl:when>
								<xsl:when test="@type='抄録'">
									<fo:block
										xsl:use-attribute-sets="logic_div_shoroku">
										<xsl:apply-templates/>
									</fo:block>
								</xsl:when>
								<xsl:when test="@type='著者紹介'">
									<fo:block
										xsl:use-attribute-sets="logic_div_chosha_shokai">
										<xsl:apply-templates/>
									</fo:block>
								</xsl:when>
								<xsl:when test="@type='とびら'">
									<fo:block
										xsl:use-attribute-sets="logic_div_tobira">
										<xsl:apply-templates/>
									</fo:block>
								</xsl:when>
								<xsl:when test="@type='謝辞'">
									<fo:block
										xsl:use-attribute-sets="logic_div_shaji">
										<xsl:apply-templates/>
									</fo:block>
								</xsl:when>
								<xsl:when test="@type='献辞'">
									<fo:block
										xsl:use-attribute-sets="logic_div_kenji">
										<xsl:apply-templates/>
									</fo:block>
								</xsl:when>
								<xsl:when test="@type='序文'">
									<fo:block
										xsl:use-attribute-sets="logic_div_jyobun">
										<xsl:apply-templates/>
									</fo:block>
								</xsl:when>
								<xsl:when test="@type='凡例'">
									<fo:block
										xsl:use-attribute-sets="logic_div_hanrei">
										<xsl:apply-templates/>
									</fo:block>
								</xsl:when>
								<xsl:when test="@type='目次'">
									<fo:block
										xsl:use-attribute-sets="logic_div_mokuji">
										<xsl:apply-templates/>
									</fo:block>
								</xsl:when>
								<xsl:when test="@type='図版目次'">
									<fo:block
										xsl:use-attribute-sets="logic_div_zuhan_mokuji">
										<xsl:apply-templates/>
									</fo:block>
								</xsl:when>
								<xsl:when test="@type='部'">
									<fo:block
										xsl:use-attribute-sets="logic_div_bu">
										<xsl:apply-templates/>
									</fo:block>
								</xsl:when>
								<xsl:when test="@type='篇'">
									<fo:block
										xsl:use-attribute-sets="logic_div_hen">
										<xsl:apply-templates/>
									</fo:block>
								</xsl:when>
								<xsl:when test="@type='章'">
									<fo:block
										xsl:use-attribute-sets="logic_div_sho">
										<xsl:apply-templates/>
									</fo:block>
								</xsl:when>
								<xsl:when test="@type='節'">
									<fo:block
										xsl:use-attribute-sets="logic_div_setsu">
										<xsl:apply-templates/>
									</fo:block>
								</xsl:when>
								<xsl:when test="@type='項1'">
									<fo:block
										xsl:use-attribute-sets="logic_div_ko1">
										<xsl:apply-templates/>
									</fo:block>
								</xsl:when>
								<xsl:when test="@type='項2'">
									<fo:block
										xsl:use-attribute-sets="logic_div_ko2">
										<xsl:apply-templates/>
									</fo:block>
								</xsl:when>
								<xsl:when test="@type='項3'">
									<fo:block
										xsl:use-attribute-sets="logic_div_ko3">
										<xsl:apply-templates/>
									</fo:block>
								</xsl:when>
								<xsl:when test="@type='項4'">
									<fo:block
										xsl:use-attribute-sets="logic_div_ko4">
										<xsl:apply-templates/>
									</fo:block>
								</xsl:when>
								<xsl:when test="@type='項5'">
									<fo:block
										xsl:use-attribute-sets="logic_div_ko5">
										<xsl:apply-templates/>
									</fo:block>
								</xsl:when>
								<xsl:when test="@type='項6'">
									<fo:block
										xsl:use-attribute-sets="logic_div_ko6">
										<xsl:apply-templates/>
									</fo:block>
								</xsl:when>
								<xsl:when test="@type='あとがき'">
									<fo:block
										xsl:use-attribute-sets="logic_div_atogaki">
										<xsl:apply-templates/>
									</fo:block>
								</xsl:when>
								<xsl:when test="@type='解説'">
									<fo:block
										xsl:use-attribute-sets="logic_div_kaisetsu">
										<xsl:apply-templates/>
									</fo:block>
								</xsl:when>
								<xsl:when test="@type='付録'">
									<fo:block
										xsl:use-attribute-sets="logic_div_furoku">
										<xsl:apply-templates/>
									</fo:block>
								</xsl:when>
								<xsl:when test="@type='索引'">
									<fo:block
										xsl:use-attribute-sets="logic_div_sakuin">
										<xsl:apply-templates/>
									</fo:block>
								</xsl:when>
								<xsl:when test="@type='用語集'">
									<fo:block
										xsl:use-attribute-sets="logic_div_yogoshu">
										<xsl:apply-templates/>
									</fo:block>
								</xsl:when>
								<xsl:when test="@type='年表'">
									<fo:block
										xsl:use-attribute-sets="logic_div_nenpyo">
										<xsl:apply-templates/>
									</fo:block>
								</xsl:when>
								<xsl:when test="@type='関連書籍'">
									<fo:block
										xsl:use-attribute-sets="logic_div_kanren_shoseki">
										<xsl:apply-templates/>
									</fo:block>
								</xsl:when>
								<xsl:when test="@type='奥付'">
									<fo:block
										xsl:use-attribute-sets="logic_div_okutsuki">
										<xsl:apply-templates/>
									</fo:block>
								</xsl:when>
								<xsl:when test="@type='引用'">
									<fo:block
										xsl:use-attribute-sets="logic_div_inyou">
										<xsl:apply-templates/>
									</fo:block>
								</xsl:when>
								<xsl:when test="@type='詩'">
									<fo:block
										xsl:use-attribute-sets="logic_div_shi">
										<xsl:apply-templates/>
									</fo:block>
								</xsl:when>
								<xsl:when test="@type='プログラムリスト'">
									<fo:block
										xsl:use-attribute-sets="logic_div_pglist">
										<xsl:apply-templates/>
									</fo:block>
								</xsl:when>
								<xsl:when test="@type='参考文献'">
									<fo:block
										xsl:use-attribute-sets="logic_div_sankou_bunken">
										<xsl:apply-templates/>
									</fo:block>
								</xsl:when>
								<xsl:when test="@type='囲み'">
									<fo:block
										xsl:use-attribute-sets="logic_div_kakomi">
										<xsl:apply-templates/>
									</fo:block>
								</xsl:when>
								<xsl:otherwise>
									<fo:block
										xsl:use-attribute-sets="logic_div_default">
										<xsl:apply-templates/>
									</fo:block>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:when>
						<!-- どのグループにも属していない論理単位構造要素 -->
						<xsl:otherwise>
							<fo:block xsl:use-attribute-sets="logic_div_default">
								<xsl:apply-templates/>
							</fo:block>
						</xsl:otherwise>
					</xsl:choose>
					<!-- xsl:if test="cmp:find_group(@type)=0"の終わり -->
					<!-- ======================================================================== -->
				</xsl:when>
				<xsl:otherwise>
					<!-- @type='表紙' かつ  $j_front_cover='div'でないとき -->
					<!-- @type='目次' かつ  $logic_div_mokuji_out = 'true'でないとき -->
					<!--xsl:message>
					<xsl:text> div/@type="</xsl:text>
					<xsl:value-of select="@type"/>
					<xsl:text>"は処理をスキップしました。</xsl:text>
				</xsl:message-->
				</xsl:otherwise>
			</xsl:choose>
		</fo:block>
	</xsl:template>
	<xsl:template match="head">
		<fo:block xsl:use-attribute-sets="logic_head">
			<xsl:apply-templates/>
		</fo:block>
	</xsl:template>
	<xsl:template match="head/no">
		<fo:inline xsl:use-attribute-sets="logic_head_no">
			<xsl:apply-templates/>
		</fo:inline>
	</xsl:template>
	<xsl:template match="head/title">
		<fo:inline xsl:use-attribute-sets="logic_head_title"
			id="{generate-id(.)}">
			<xsl:apply-templates/>
		</fo:inline>
	</xsl:template>
	<xsl:template match="head/subtitle">
		<fo:inline xsl:use-attribute-sets="logic_head_subtitle">
			<xsl:apply-templates/>
		</fo:inline>
	</xsl:template>
	<xsl:template match="head/author">
		<fo:inline xsl:use-attribute-sets="logic_head_author">
			<xsl:apply-templates/>
		</fo:inline>
	</xsl:template>
	<!--		note要素		リストとして処理	-->
	<xsl:template match="note">
		<fo:block xsl:use-attribute-sets="logic_note">
			<xsl:if test="@id">
				<xsl:if test="not(@id='')">
					<xsl:attribute name="id" select="@id"/>
				</xsl:if>
			</xsl:if>
			<fo:list-block>
				<xsl:attribute name="provisional-distance-between-starts">
					<xsl:value-of select="concat(string-length(no)+1, 'em')"/>
				</xsl:attribute>
				<fo:list-item xsl:use-attribute-sets="logic_note_list_item">
					<fo:list-item-label end-indent="label-end()">
						<fo:block>
							<xsl:value-of select="no"/>
						</fo:block>
					</fo:list-item-label>
					<!--noを持たないnoteもあるので，その際にはstart-indentの設定をしないように改訂　2010_03_07桑野-->
					<fo:list-item-body>
						<xsl:if test="no">
							<xsl:attribute name="start-indent"
								>body-start()</xsl:attribute>
						</xsl:if>
						<fo:block>
							<xsl:apply-templates select="*[name()!='no']"/>
						</fo:block>
					</fo:list-item-body>
				</fo:list-item>
			</fo:list-block>
		</fo:block>
	</xsl:template>
	<!--目次生成用テンプレート。暫定。出力項目（noとtitleか、とか）・体裁（書体・Q数・H送り・リーダーの体裁・階層ごとのマージンなど）はプリセットでコントロールできるようにする。桑野-->
	<xsl:template name="generateTOC">
		<xsl:if test="$logic_div_mokuji_out='auto'">
			<fo:block break-before="{$logic_div_mokuji_break-before}"
				break-after="{$logic_div_mokuji_break-after}" text-align="{$logic_div_mokuji_text-align}"
				text-align-last="{$logic_div_mokuji_text-align-last}"
				font-family="{$logic_div_mokuji_font-family}"
				font-size="{$logic_div_mokuji_font-size}"
				line-height="{$logic_div_mokuji_line-height}"
				color="{$mokuji_font_leader_color}">
				<fo:block xsl:use-attribute-sets="logic_head_title">目次</fo:block>
				<xsl:for-each select="//div/head/title">
					<fo:block>
						<xsl:attribute name="margin-left"><xsl:value-of
								select="count(ancestor::div)"
							/>em</xsl:attribute>
						<xsl:if test="parent::head/no">
							<xsl:value-of select="parent::head/no"/>
							<xsl:text>　</xsl:text>
						</xsl:if>
						<fo:basic-link internal-destination="{generate-id()}">
							<xsl:value-of select="."/>
							<fo:leader
								leader-pattern="{$logic_div_mokuji_learer-pattern}"
								rule-style="{$logic_div_mokuji_rule-style}"
								rule-thickness="{$logic_div_mokuji_rule-thickness}"
								color="{$mokuji_font_leader_color}"/>
							<fo:page-number-citation ref-id="{generate-id()}"/>
						</fo:basic-link>
					</fo:block>
				</xsl:for-each>
			</fo:block>
		</xsl:if>
	</xsl:template>
</xsl:stylesheet>
