<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<!--
		============================================================
		XMLコンソーシアム  XMP部会  技術系SG  jepaX用スタイルシート
		============================================================
		logic_var.xsl  【論理構造単位要素】
		============================================================
		2008-05-23  ver.0.9  by H.Sato
		2008-07-15  ver.0.95 by checked by K.Kuwano
		2008-08-19  deletion of regulated value  by K.Kuwano
		2008-09-09  revised   by K.Kuwano
		2010-08-25  add text-indent   by K.Kuwano
		2010-10-23  add 'group0' by H.Sato
		============================================================
	-->
	<!-- パラメータ -->
	<!-- グループ定義 -->
	<xsl:param name="group0"/>
	<xsl:param name="group1"/>
	<xsl:param name="group2"/>
	<xsl:param name="group3"/>
	<!-- グループ設定パラメータ -->
	<!--グループ1-->
	<xsl:param name="logic_div_group1_font-family">IPAGothic</xsl:param>
	<xsl:param name="logic_div_group1_font-size">40.0pt</xsl:param>
	<xsl:param name="logic_div_group1_line-height">60.0pt</xsl:param>
	<xsl:param name="logic_div_group1_space-before">30.0mm</xsl:param>
	<xsl:param name="logic_div_group1_space-after">30.0mm</xsl:param>
	<xsl:param name="logic_div_group1_text-indent">1.0em</xsl:param>
	<xsl:param name="logic_div_group1_start-indent">1.0em</xsl:param>
	<xsl:param name="logic_div_group1_end-indent">1.0em</xsl:param>
	<xsl:param name="logic_div_group1_text-align">justify</xsl:param>
	<xsl:param name="logic_div_group1_text-align-last">start</xsl:param>
	<xsl:param name="logic_div_group1_break-before">page</xsl:param>
	<xsl:param name="logic_div_group1_break-after">page</xsl:param>
	<!--グループ2-->
	<xsl:param name="logic_div_group2_font-family">IPAGothic</xsl:param>
	<xsl:param name="logic_div_group2_font-size">22.0pt</xsl:param>
	<xsl:param name="logic_div_group2_line-height">33.0pt</xsl:param>
	<xsl:param name="logic_div_group2_space-before">5.0mm</xsl:param>
	<xsl:param name="logic_div_group2_space-after">5.0mm</xsl:param>
	<xsl:param name="logic_div_group2_text-indent">1.0em</xsl:param>
	<xsl:param name="logic_div_group2_start-indent">1.0em</xsl:param>
	<xsl:param name="logic_div_group2_end-indent">1.0em</xsl:param>
	<xsl:param name="logic_div_group2_text-align">justify</xsl:param>
	<xsl:param name="logic_div_group2_text-align-last">start</xsl:param>
	<xsl:param name="logic_div_group2_break-before">auto</xsl:param>
	<xsl:param name="logic_div_group2_break-after">auto</xsl:param>
	<!--グループ3-->
	<xsl:param name="logic_div_group3_font-family">IPAGothic</xsl:param>
	<xsl:param name="logic_div_group3_font-size">22.0pt</xsl:param>
	<xsl:param name="logic_div_group3_line-height">33.0pt</xsl:param>
	<xsl:param name="logic_div_group3_space-before">5.0mm</xsl:param>
	<xsl:param name="logic_div_group3_space-after">5.0mm</xsl:param>
	<xsl:param name="logic_div_group3_text-indent">1.0em</xsl:param>
	<xsl:param name="logic_div_group3_start-indent">1.0em</xsl:param>
	<xsl:param name="logic_div_group3_end-indent">1.0em</xsl:param>
	<xsl:param name="logic_div_group3_text-align">justify</xsl:param>
	<xsl:param name="logic_div_group3_text-align-last">start</xsl:param>
	<xsl:param name="logic_div_group3_break-before">auto</xsl:param>
	<xsl:param name="logic_div_group3_break-after">auto</xsl:param>
	<!-- div 目次出力制御用 -->
	<xsl:param name="logic_div_mokuji_out">false</xsl:param>
	<!-- div 表紙 -->
	<xsl:param name="logic_div_hyoshi_font-family">IPAGothic</xsl:param>
	<xsl:param name="logic_div_hyoshi_font-size">20.0pt</xsl:param>
	<xsl:param name="logic_div_hyoshi_line-height">30.0pt</xsl:param>
	<xsl:param name="logic_div_hyoshi_space-before">10.0mm</xsl:param>
	<xsl:param name="logic_div_hyoshi_space-after">10.0mm</xsl:param>
	<xsl:param name="logic_div_hyoshi_text-indent">0em</xsl:param>
	<xsl:param name="logic_div_hyoshi_start-indent">10.0mm</xsl:param>
	<xsl:param name="logic_div_hyoshi_end-indent">10.0mm</xsl:param>
	<xsl:param name="logic_div_hyoshi_text-align">center</xsl:param>
	<xsl:param name="logic_div_hyoshi_text-align-last">center</xsl:param>
	<xsl:param name="logic_div_hyoshi_break-after">page</xsl:param>
	<xsl:param name="logic_div_hyoshi_span">all</xsl:param>
	<!-- div あらすじ -->
	<xsl:param name="logic_div_arasuji_font-family">IPAPMincho</xsl:param>
	<xsl:param name="logic_div_arasuji_font-size">12.0pt</xsl:param>
	<xsl:param name="logic_div_arasuji_line-height">18.0pt</xsl:param>
	<xsl:param name="logic_div_arasuji_space-before">6.75mm</xsl:param>
	<xsl:param name="logic_div_arasuji_space-after">6.75mm</xsl:param>
	<xsl:param name="logic_div_arasuji_text-indent">1em</xsl:param>
	<xsl:param name="logic_div_arasuji_start-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_arasuji_end-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_arasuji_text-align">justify</xsl:param>
	<xsl:param name="logic_div_arasuji_text-align-last">start</xsl:param>
	<xsl:param name="logic_div_arasuji_break-before">auto</xsl:param>
	<xsl:param name="logic_div_arasuji_break-after">auto</xsl:param>
	<!-- div 抄録 -->
	<xsl:param name="logic_div_shoroku_font-family">IPAPMincho</xsl:param>
	<xsl:param name="logic_div_shoroku_font-size">12.0pt</xsl:param>
	<xsl:param name="logic_div_shoroku_line-height">18.0pt</xsl:param>
	<xsl:param name="logic_div_shoroku_space-before">6.75mm</xsl:param>
	<xsl:param name="logic_div_shoroku_space-after">6.75mm</xsl:param>
	<xsl:param name="logic_div_shoroku_text-indent">1em</xsl:param>
	<xsl:param name="logic_div_shoroku_start-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_shoroku_end-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_shoroku_text-align">justify</xsl:param>
	<xsl:param name="logic_div_shoroku_text-align-last">start</xsl:param>
	<xsl:param name="logic_div_shoroku_break-before">auto</xsl:param>
	<xsl:param name="logic_div_shoroku_break-after">auto</xsl:param>
	<!-- div 著者紹介 -->
	<xsl:param name="logic_div_chosha_shokai_font-family">IPAPMincho</xsl:param>
	<xsl:param name="logic_div_chosha_shokai_font-size">12.0pt</xsl:param>
	<xsl:param name="logic_div_chosha_shokai_line-height">18.0pt</xsl:param>
	<xsl:param name="logic_div_chosha_shokai_space-before">6.75mm</xsl:param>
	<xsl:param name="logic_div_chosha_shokai_space-after">6.75mm</xsl:param>
	<xsl:param name="logic_div_chosha_shokai_text-indent">1em</xsl:param>
	<xsl:param name="logic_div_chosha_shokai_start-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_chosha_shokai_end-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_chosha_shokai_text-align">justify</xsl:param>
	<xsl:param name="logic_div_chosha_shokai_text-align-last">start</xsl:param>
	<xsl:param name="logic_div_chosha_shokai_break-before">auto</xsl:param>
	<xsl:param name="logic_div_chosha_shokai_break-after">auto</xsl:param>
	<!-- div とびら -->
	<xsl:param name="logic_div_tobira_font-family">IPAGothic</xsl:param>
	<xsl:param name="logic_div_tobira_font-size">20.0pt</xsl:param>
	<xsl:param name="logic_div_tobira_line-height">30.0pt</xsl:param>
	<xsl:param name="logic_div_tobira_space-before">10.0mm</xsl:param>
	<xsl:param name="logic_div_tobira_space-after">10.0mm</xsl:param>
	<xsl:param name="logic_div_tobira_text-indent">0em</xsl:param>
	<xsl:param name="logic_div_tobira_start-indent">5.0em</xsl:param>
	<xsl:param name="logic_div_tobira_end-indent">5.0em</xsl:param>
	<xsl:param name="logic_div_tobira_text-align">center</xsl:param>
	<xsl:param name="logic_div_tobira_text-align-last">center</xsl:param>
	<xsl:param name="logic_div_tobira_break-before">page</xsl:param>
	<xsl:param name="logic_div_tobira_break-after">page</xsl:param>
	<xsl:param name="logic_div_tobira_span">none</xsl:param>
	<!-- div 謝辞 -->
	<xsl:param name="logic_div_shaji_font-family">IPAPMincho</xsl:param>
	<xsl:param name="logic_div_shaji_font-size">12.0pt</xsl:param>
	<xsl:param name="logic_div_shaji_line-height">18.0pt</xsl:param>
	<xsl:param name="logic_div_shaji_space-before">6.75mm</xsl:param>
	<xsl:param name="logic_div_shaji_space-after">6.75mm</xsl:param>
	<xsl:param name="logic_div_shaji_text-indent">1em</xsl:param>
	<xsl:param name="logic_div_shaji_start-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_shaji_end-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_shaji_text-align">justify</xsl:param>
	<xsl:param name="logic_div_shaji_text-align-last">start</xsl:param>
	<xsl:param name="logic_div_shaji_break-before">auto</xsl:param>
	<xsl:param name="logic_div_shaji_break-after">auto</xsl:param>
	<!-- div 献辞 -->
	<xsl:param name="logic_div_kenji_font-family">IPAPMincho</xsl:param>
	<xsl:param name="logic_div_kenji_font-size">12.0pt</xsl:param>
	<xsl:param name="logic_div_kenji_line-height">18.0pt</xsl:param>
	<xsl:param name="logic_div_kenji_space-before">6.75mm</xsl:param>
	<xsl:param name="logic_div_kenji_space-after">6.75mm</xsl:param>
	<xsl:param name="logic_div_kenji_text-indent">1em</xsl:param>
	<xsl:param name="logic_div_kenji_start-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_kenji_end-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_kenji_text-align">justify</xsl:param>
	<xsl:param name="logic_div_kenji_text-align-last">start</xsl:param>
	<xsl:param name="logic_div_kenji_break-before">auto</xsl:param>
	<xsl:param name="logic_div_kenji_break-after">auto</xsl:param>
	<!-- div 序文 -->
	<xsl:param name="logic_div_jyobun_font-family">IPAPMincho</xsl:param>
	<xsl:param name="logic_div_jyobun_font-size">12.0pt</xsl:param>
	<xsl:param name="logic_div_jyobun_line-height">18.0pt</xsl:param>
	<xsl:param name="logic_div_jyobun_space-before">6.75mm</xsl:param>
	<xsl:param name="logic_div_jyobun_space-after">6.75mm</xsl:param>
	<xsl:param name="logic_div_jyobun_text-indent">1em</xsl:param>
	<xsl:param name="logic_div_jyobun_start-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_jyobun_end-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_jyobun_text-align">justify</xsl:param>
	<xsl:param name="logic_div_jyobun_text-align-last">start</xsl:param>
	<xsl:param name="logic_div_jyobun_break-before">page</xsl:param>
	<xsl:param name="logic_div_jyobun_break-after">page</xsl:param>
	<!-- div 凡例 -->
	<xsl:param name="logic_div_hanrei_font-family">IPAPMincho</xsl:param>
	<xsl:param name="logic_div_hanrei_font-size">12.0pt</xsl:param>
	<xsl:param name="logic_div_hanrei_line-height">18.0pt</xsl:param>
	<xsl:param name="logic_div_hanrei_space-before">6.75mm</xsl:param>
	<xsl:param name="logic_div_hanrei_space-after">6.75mm</xsl:param>
	<xsl:param name="logic_div_hanrei_text-indent">1em</xsl:param>
	<xsl:param name="logic_div_hanrei_start-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_hanrei_end-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_hanrei_text-align">justify</xsl:param>
	<xsl:param name="logic_div_hanrei_text-align-last">start</xsl:param>
	<xsl:param name="logic_div_hanrei_break-before">auto</xsl:param>
	<xsl:param name="logic_div_hanrei_break-after">auto</xsl:param>
	<!-- div 目次 -->
	<xsl:param name="logic_div_mokuji_font-family">IPAPMincho</xsl:param>
	<xsl:param name="logic_div_mokuji_font-size">12.0pt</xsl:param>
	<xsl:param name="logic_div_mokuji_line-height">18.0pt</xsl:param>
	<xsl:param name="logic_div_mokuji_space-before">6.75mm</xsl:param>
	<xsl:param name="logic_div_mokuji_space-after">6.75mm</xsl:param>
	<xsl:param name="logic_div_mokuji_text-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_mokuji_start-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_mokuji_end-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_mokuji_text-align">justify</xsl:param>
	<xsl:param name="logic_div_mokuji_text-align-last">start</xsl:param>
	<xsl:param name="logic_div_mokuji_break-before">auto</xsl:param>
	<xsl:param name="logic_div_mokuji_break-after">auto</xsl:param>
	<xsl:param name="logic_div_mokuji_learer-pattern">dots</xsl:param>
	<xsl:param name="logic_div_mokuji_rule-style"/>
	<xsl:param name="logic_div_mokuji_rule-thickness"/>
	<!-- div 図版目次 -->
	<xsl:param name="logic_div_zuhan_mokuji_font-family">IPAPMincho</xsl:param>
	<xsl:param name="logic_div_zuhan_mokuji_font-size">12.0pt</xsl:param>
	<xsl:param name="logic_div_zuhan_mokuji_line-height">18.0pt</xsl:param>
	<xsl:param name="logic_div_zuhan_mokuji_space-before">6.75mm</xsl:param>
	<xsl:param name="logic_div_zuhan_mokuji_space-after">6.75mm</xsl:param>
	<xsl:param name="logic_div_zuhan_mokuji_text-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_zuhan_mokuji_start-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_zuhan_mokuji_end-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_zuhan_mokuji_text-align">justify</xsl:param>
	<xsl:param name="logic_div_zuhan_mokuji_text-align-last">start</xsl:param>
	<xsl:param name="logic_div_zuhan_mokuji_break-before">auto</xsl:param>
	<xsl:param name="logic_div_zuhan_mokuji_break-after">auto</xsl:param>
	<!-- div 部 -->
	<xsl:param name="logic_div_bu_font-family">IPAPMincho</xsl:param>
	<xsl:param name="logic_div_bu_font-size">12.0pt</xsl:param>
	<xsl:param name="logic_div_bu_line-height">18.0pt</xsl:param>
	<xsl:param name="logic_div_bu_space-before">6.75mm</xsl:param>
	<xsl:param name="logic_div_bu_space-after">6.75mm</xsl:param>
	<xsl:param name="logic_div_bu_text-indent">1em</xsl:param>
	<xsl:param name="logic_div_bu_start-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_bu_end-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_bu_text-align">justify</xsl:param>
	<xsl:param name="logic_div_bu_text-align-last">start</xsl:param>
	<xsl:param name="logic_div_bu_break-before">page</xsl:param>
	<xsl:param name="logic_div_bu_break-after">page</xsl:param>
	<!-- div 篇 -->
	<xsl:param name="logic_div_hen_font-family">IPAPMincho</xsl:param>
	<xsl:param name="logic_div_hen_font-size">12.0pt</xsl:param>
	<xsl:param name="logic_div_hen_line-height">18.0pt</xsl:param>
	<xsl:param name="logic_div_hen_space-before">6.75mm</xsl:param>
	<xsl:param name="logic_div_hen_space-after">6.75mm</xsl:param>
	<xsl:param name="logic_div_hen_text-indent">1em</xsl:param>
	<xsl:param name="logic_div_hen_start-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_hen_end-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_hen_text-align">justify</xsl:param>
	<xsl:param name="logic_div_hen_text-align-last">start</xsl:param>
	<xsl:param name="logic_div_hen_break-before">page</xsl:param>
	<xsl:param name="logic_div_hen_break-after">page</xsl:param>
	<!-- div 章 -->
	<xsl:param name="logic_div_sho_font-family">IPAPMincho</xsl:param>
	<xsl:param name="logic_div_sho_font-size">12.0pt</xsl:param>
	<xsl:param name="logic_div_sho_line-height">18.0pt</xsl:param>
	<xsl:param name="logic_div_sho_space-before">6.75mm</xsl:param>
	<xsl:param name="logic_div_sho_space-after">6.75mm</xsl:param>
	<xsl:param name="logic_div_sho_text-indent">1em</xsl:param>
	<xsl:param name="logic_div_sho_start-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_sho_end-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_sho_text-align">justify</xsl:param>
	<xsl:param name="logic_div_sho_text-align-last">start</xsl:param>
	<xsl:param name="logic_div_sho_break-before">page</xsl:param>
	<xsl:param name="logic_div_sho_break-after">page</xsl:param>
	<!-- div 節 -->
	<xsl:param name="logic_div_setsu_font-family">IPAPMincho</xsl:param>
	<xsl:param name="logic_div_setsu_font-size">12.0pt</xsl:param>
	<xsl:param name="logic_div_setsu_line-height">18.0pt</xsl:param>
	<xsl:param name="logic_div_setsu_space-before">6.75mm</xsl:param>
	<xsl:param name="logic_div_setsu_space-after">6.75mm</xsl:param>
	<xsl:param name="logic_div_setsu_text-indent">1em</xsl:param>
	<xsl:param name="logic_div_setsu_start-indent">2.0em</xsl:param>
	<xsl:param name="logic_div_setsu_end-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_setsu_text-align">justify</xsl:param>
	<xsl:param name="logic_div_setsu_text-align-last">start</xsl:param>
	<xsl:param name="logic_div_setsu_break-before">auto</xsl:param>
	<xsl:param name="logic_div_setsu_break-after">auto</xsl:param>
	<!-- div 項1 -->
	<xsl:param name="logic_div_ko1_font-family">IPAPMincho</xsl:param>
	<xsl:param name="logic_div_ko1_font-size">12.0pt</xsl:param>
	<xsl:param name="logic_div_ko1_line-height">18.0pt</xsl:param>
	<xsl:param name="logic_div_ko1_space-before">6.75mm</xsl:param>
	<xsl:param name="logic_div_ko1_space-after">6.75mm</xsl:param>
	<xsl:param name="logic_div_ko1_text-indent">1em</xsl:param>
	<xsl:param name="logic_div_ko1_start-indent">2.0em</xsl:param>
	<xsl:param name="logic_div_ko1_end-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_ko1_text-align">justify</xsl:param>
	<xsl:param name="logic_div_ko1_text-align-last">start</xsl:param>
	<xsl:param name="logic_div_ko1_break-before">auto</xsl:param>
	<xsl:param name="logic_div_ko1_break-after">auto</xsl:param>
	<!-- div 項2 -->
	<!-- #### -->
	<xsl:param name="logic_div_ko2_font-family">IPAPMincho</xsl:param>
	<xsl:param name="logic_div_ko2_color">#000000</xsl:param>
	<xsl:param name="logic_div_ko2_font-size">12.0pt</xsl:param>
	<xsl:param name="logic_div_ko2_line-height">18.0pt</xsl:param>
	<xsl:param name="logic_div_ko2_space-before">6.75mm</xsl:param>
	<xsl:param name="logic_div_ko2_space-after">6.75mm</xsl:param>
	<xsl:param name="logic_div_ko2_text-indent">1em</xsl:param>
	<xsl:param name="logic_div_ko2_start-indent">2.0em</xsl:param>
	<xsl:param name="logic_div_ko2_end-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_ko2_text-align">justify</xsl:param>
	<xsl:param name="logic_div_ko2_text-align-last">start</xsl:param>
	<xsl:param name="logic_div_ko2_break-before">auto</xsl:param>
	<xsl:param name="logic_div_ko2_break-after">auto</xsl:param>
	<!-- div 項3 -->
	<xsl:param name="logic_div_ko3_font-family">IPAPMincho</xsl:param>
	<!-- #### -->
	<xsl:param name="logic_div_ko3_color">#000000</xsl:param>
	<xsl:param name="logic_div_ko3_font-size">12.0pt</xsl:param>
	<xsl:param name="logic_div_ko3_line-height">18.0pt</xsl:param>
	<xsl:param name="logic_div_ko3_space-before">6.75mm</xsl:param>
	<xsl:param name="logic_div_ko3_space-after">6.75mm</xsl:param>
	<xsl:param name="logic_div_ko3_text-indent">1em</xsl:param>
	<xsl:param name="logic_div_ko3_start-indent">2.0em</xsl:param>
	<xsl:param name="logic_div_ko3_end-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_ko3_text-align">justify</xsl:param>
	<xsl:param name="logic_div_ko3_text-align-last">start</xsl:param>
	<xsl:param name="logic_div_ko3_break-before">auto</xsl:param>
	<xsl:param name="logic_div_ko3_break-after">auto</xsl:param>
	<!-- div 項4 -->
	<xsl:param name="logic_div_ko4_font-family">IPAPMincho</xsl:param>
	<xsl:param name="logic_div_ko4_font-size">12.0pt</xsl:param>
	<xsl:param name="logic_div_ko4_line-height">18.0pt</xsl:param>
	<xsl:param name="logic_div_ko4_space-before">6.75mm</xsl:param>
	<xsl:param name="logic_div_ko4_space-after">6.75mm</xsl:param>
	<xsl:param name="logic_div_ko4_text-indent">1em</xsl:param>
	<xsl:param name="logic_div_ko4_start-indent">2.0em</xsl:param>
	<xsl:param name="logic_div_ko4_end-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_ko4_text-align">justify</xsl:param>
	<xsl:param name="logic_div_ko4_text-align-last">start</xsl:param>
	<xsl:param name="logic_div_ko4_break-before">auto</xsl:param>
	<xsl:param name="logic_div_ko4_break-after">auto</xsl:param>
	<!-- div 項5 -->
	<xsl:param name="logic_div_ko5_font-family">IPAPMincho</xsl:param>
	<xsl:param name="logic_div_ko5_font-size">12.0pt</xsl:param>
	<xsl:param name="logic_div_ko5_line-height">18.0pt</xsl:param>
	<xsl:param name="logic_div_ko5_space-before">6.75mm</xsl:param>
	<xsl:param name="logic_div_ko5_space-after">6.75mm</xsl:param>
	<xsl:param name="logic_div_ko5_text-indent">1em</xsl:param>
	<xsl:param name="logic_div_ko5_start-indent">2.0em</xsl:param>
	<xsl:param name="logic_div_ko5_end-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_ko5_text-align">justify</xsl:param>
	<xsl:param name="logic_div_ko5_text-align-last">start</xsl:param>
	<xsl:param name="logic_div_ko5_break-before">auto</xsl:param>
	<xsl:param name="logic_div_ko5_break-after">auto</xsl:param>
	<!-- div 項6 -->
	<xsl:param name="logic_div_ko6_font-family">IPAPMincho</xsl:param>
	<xsl:param name="logic_div_ko6_font-size">12.0pt</xsl:param>
	<xsl:param name="logic_div_ko6_line-height">18.0pt</xsl:param>
	<xsl:param name="logic_div_ko6_space-before">6.75mm</xsl:param>
	<xsl:param name="logic_div_ko6_space-after">6.75mm</xsl:param>
	<xsl:param name="logic_div_ko6_text-indent">1em</xsl:param>
	<xsl:param name="logic_div_ko6_start-indent">2.0em</xsl:param>
	<xsl:param name="logic_div_ko6_end-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_ko6_text-align">justify</xsl:param>
	<xsl:param name="logic_div_ko6_text-align-last">start</xsl:param>
	<xsl:param name="logic_div_ko6_break-before">auto</xsl:param>
	<xsl:param name="logic_div_ko6_break-after">auto</xsl:param>
	<!-- div あとがき -->
	<xsl:param name="logic_div_atogaki_font-family">IPAPMincho</xsl:param>
	<xsl:param name="logic_div_atogaki_font-size">12.0pt</xsl:param>
	<xsl:param name="logic_div_atogaki_line-height">18.0pt</xsl:param>
	<xsl:param name="logic_div_atogaki_space-before">6.75mm</xsl:param>
	<xsl:param name="logic_div_atogaki_space-after">6.75mm</xsl:param>
	<xsl:param name="logic_div_atogaki_text-indent">1em</xsl:param>
	<xsl:param name="logic_div_atogaki_start-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_atogaki_end-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_atogaki_text-align">justify</xsl:param>
	<xsl:param name="logic_div_atogaki_text-align-last">start</xsl:param>
	<xsl:param name="logic_div_atogaki_break-before">page</xsl:param>
	<xsl:param name="logic_div_atogaki_break-after">page</xsl:param>
	<!-- div 解説 -->
	<xsl:param name="logic_div_kaisetsu_font-family">IPAPMincho</xsl:param>
	<xsl:param name="logic_div_kaisetsu_font-size">12.0pt</xsl:param>
	<xsl:param name="logic_div_kaisetsu_line-height">18.0pt</xsl:param>
	<xsl:param name="logic_div_kaisetsu_space-before">6.75mm</xsl:param>
	<xsl:param name="logic_div_kaisetsu_space-after">6.75mm</xsl:param>
	<xsl:param name="logic_div_kaisetsu_text-indent">1em</xsl:param>
	<xsl:param name="logic_div_kaisetsu_start-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_kaisetsu_end-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_kaisetsu_text-align">justify</xsl:param>
	<xsl:param name="logic_div_kaisetsu_text-align-last">start</xsl:param>
	<xsl:param name="logic_div_kaisetsu_break-before">auto</xsl:param>
	<xsl:param name="logic_div_kaisetsu_break-after">auto</xsl:param>
	<!-- div 付録 -->
	<xsl:param name="logic_div_furoku_font-family">IPAPMincho</xsl:param>
	<xsl:param name="logic_div_furoku_font-size">12.0pt</xsl:param>
	<xsl:param name="logic_div_furoku_line-height">18.0pt</xsl:param>
	<xsl:param name="logic_div_furoku_space-before">6.75mm</xsl:param>
	<xsl:param name="logic_div_furoku_space-after">6.75mm</xsl:param>
	<xsl:param name="logic_div_furoku_text-indent">1em</xsl:param>
	<xsl:param name="logic_div_furoku_start-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_furoku_end-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_furoku_text-align">justify</xsl:param>
	<xsl:param name="logic_div_furoku_text-align-last">start</xsl:param>
	<xsl:param name="logic_div_furoku_break-before">auto</xsl:param>
	<xsl:param name="logic_div_furoku_break-after">auto</xsl:param>
	<!-- div 索引 -->
	<xsl:param name="logic_div_sakuin_font-family">IPAPMincho</xsl:param>
	<xsl:param name="logic_div_sakuin_font-size">12.0pt</xsl:param>
	<xsl:param name="logic_div_sakuin_line-height">18.0pt</xsl:param>
	<xsl:param name="logic_div_sakuin_space-before">6.75mm</xsl:param>
	<xsl:param name="logic_div_sakuin_space-after">6.75mm</xsl:param>
	<xsl:param name="logic_div_sakuin_text-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_sakuin_start-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_sakuin_end-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_sakuin_text-align">justify</xsl:param>
	<xsl:param name="logic_div_sakuin_text-align-last">start</xsl:param>
	<xsl:param name="logic_div_sakuin_break-before">auto</xsl:param>
	<xsl:param name="logic_div_sakuin_break-after">auto</xsl:param>
	<!-- div 用語集 -->
	<xsl:param name="logic_div_yogoshu_font-family">IPAPMincho</xsl:param>
	<xsl:param name="logic_div_yogoshu_font-size">10.0pt</xsl:param>
	<xsl:param name="logic_div_yogoshu_line-height">15.0pt</xsl:param>
	<xsl:param name="logic_div_yogoshu_space-before">5.6mm</xsl:param>
	<xsl:param name="logic_div_yogoshu_space-after">5.6mm</xsl:param>
	<xsl:param name="logic_div_yogoshu_text-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_yogoshu_start-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_yogoshu_end-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_yogoshu_text-align">justify</xsl:param>
	<xsl:param name="logic_div_yogoshu_text-align-last">start</xsl:param>
	<xsl:param name="logic_div_yogoshu_break-before">auto</xsl:param>
	<xsl:param name="logic_div_yogoshu_break-after">auto</xsl:param>
	<!-- div 年表 -->
	<xsl:param name="logic_div_nenpyo_font-family">IPAPMincho</xsl:param>
	<xsl:param name="logic_div_nenpyo_font-size">12.0pt</xsl:param>
	<xsl:param name="logic_div_nenpyo_line-height">18.0pt</xsl:param>
	<xsl:param name="logic_div_nenpyo_space-before">6.75mm</xsl:param>
	<xsl:param name="logic_div_nenpyo_space-after">6.75mm</xsl:param>
	<xsl:param name="logic_div_nenpyo_text-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_nenpyo_start-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_nenpyo_end-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_nenpyo_text-align">justify</xsl:param>
	<xsl:param name="logic_div_nenpyo_text-align-last">start</xsl:param>
	<xsl:param name="logic_div_nenpyo_break-before">auto</xsl:param>
	<xsl:param name="logic_div_nenpyo_break-after">auto</xsl:param>
	<!-- div 関連書籍 -->
	<xsl:param name="logic_div_kanren_shoseki_font-family"
		>IPAPMincho</xsl:param>
	<xsl:param name="logic_div_kanren_shoseki_font-size">12.0pt</xsl:param>
	<xsl:param name="logic_div_kanren_shoseki_line-height">18.0pt</xsl:param>
	<xsl:param name="logic_div_kanren_shoseki_space-before">6.75mm</xsl:param>
	<xsl:param name="logic_div_kanren_shoseki_space-after">6.75mm</xsl:param>
	<xsl:param name="logic_div_kanren_shoseki_text-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_kanren_shoseki_start-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_kanren_shoseki_end-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_kanren_shoseki_text-align">justify</xsl:param>
	<xsl:param name="logic_div_kanren_shoseki_text-align-last">start</xsl:param>
	<xsl:param name="logic_div_kanren_shoseki_break-before">auto</xsl:param>
	<xsl:param name="logic_div_kanren_shoseki_break-after">auto</xsl:param>
	<!-- div 奥付 -->
	<xsl:param name="logic_div_okutsuki_font-family">IPAPMincho</xsl:param>
	<xsl:param name="logic_div_okutsuki_font-size">12.0pt</xsl:param>
	<xsl:param name="logic_div_okutsuki_line-height">18.0pt</xsl:param>
	<xsl:param name="logic_div_okutsuki_space-before">6.75mm</xsl:param>
	<xsl:param name="logic_div_okutsuki_space-after">6.75mm</xsl:param>
	<xsl:param name="logic_div_okutsuki_text-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_okutsuki_start-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_okutsuki_end-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_okutsuki_text-align">justify</xsl:param>
	<xsl:param name="logic_div_okutsuki_text-align-last">start</xsl:param>
	<xsl:param name="logic_div_okutsuki_break-before">page</xsl:param>
	<xsl:param name="logic_div_okutsuki_break-after">page</xsl:param>
	<xsl:param name="logic_div_okutsuki_span">none</xsl:param>
	<!-- div 引用 -->
	<xsl:param name="logic_div_inyou_font-family">IPAPMincho</xsl:param>
	<xsl:param name="logic_div_inyou_font-size">12.0pt</xsl:param>
	<xsl:param name="logic_div_inyou_line-height">18.0pt</xsl:param>
	<xsl:param name="logic_div_inyou_space-before">6.75mm</xsl:param>
	<xsl:param name="logic_div_inyou_space-after">6.75mm</xsl:param>
	<xsl:param name="logic_div_inyou_text-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_inyou_start-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_inyou_end-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_inyou_text-align">justify</xsl:param>
	<xsl:param name="logic_div_inyou_text-align-last">start</xsl:param>
	<xsl:param name="logic_div_inyou_break-before">auto</xsl:param>
	<xsl:param name="logic_div_inyou_break-after">auto</xsl:param>
	<!-- div 詩 -->
	<xsl:param name="logic_div_shi_font-family">IPAPMincho</xsl:param>
	<xsl:param name="logic_div_shi_font-size">12.0pt</xsl:param>
	<xsl:param name="logic_div_shi_line-height">18.0pt</xsl:param>
	<xsl:param name="logic_div_shi_space-before">6.75mm</xsl:param>
	<xsl:param name="logic_div_shi_space-after">6.75mm</xsl:param>
	<xsl:param name="logic_div_shi_text-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_shi_start-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_shi_end-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_shi_text-align">justify</xsl:param>
	<xsl:param name="logic_div_shi_text-align-last">start</xsl:param>
	<xsl:param name="logic_div_shi_break-before">auto</xsl:param>
	<xsl:param name="logic_div_shi_break-after">auto</xsl:param>
	<!-- div プログラムリスト -->
	<xsl:param name="logic_div_pglist_font-family">IPAPMincho</xsl:param>
	<xsl:param name="logic_div_pglist_font-size">12.0pt</xsl:param>
	<xsl:param name="logic_div_pglist_line-height">18.0pt</xsl:param>
	<xsl:param name="logic_div_pglist_space-before">4.0mm</xsl:param>
	<xsl:param name="logic_div_pglist_space-after">4.0mm</xsl:param>
	<xsl:param name="logic_div_pglist_text-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_pglist_start-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_pglist_end-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_pglist_text-align">justify</xsl:param>
	<xsl:param name="logic_div_pglist_text-align-last">start</xsl:param>
	<xsl:param name="logic_div_pglist_break-before">auto</xsl:param>
	<xsl:param name="logic_div_pglist_break-after">auto</xsl:param>
	<!-- div 参考文献 -->
	<xsl:param name="logic_div_sankou_bunken_font-family">IPAPMincho</xsl:param>
	<xsl:param name="logic_div_sankou_bunken_font-size">12.0pt</xsl:param>
	<xsl:param name="logic_div_sankou_bunken_line-height">18.0pt</xsl:param>
	<xsl:param name="logic_div_sankou_bunken_space-before">6.75mm</xsl:param>
	<xsl:param name="logic_div_sankou_bunken_space-after">6.75mm</xsl:param>
	<xsl:param name="logic_div_sankou_bunken_text-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_sankou_bunken_start-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_sankou_bunken_end-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_sankou_bunken_text-align">justify</xsl:param>
	<xsl:param name="logic_div_sankou_bunken_text-align-last">start</xsl:param>
	<xsl:param name="logic_div_sankou_bunken_break-before">auto</xsl:param>
	<xsl:param name="logic_div_sankou_bunken_break-after">auto</xsl:param>
	<!-- div 囲み -->
	<xsl:param name="logic_div_kakomi_font-family">IPAPMincho</xsl:param>
	<xsl:param name="logic_div_kakomi_font-size">12.0pt</xsl:param>
	<xsl:param name="logic_div_kakomi_line-height">18.0pt</xsl:param>
	<xsl:param name="logic_div_kakomi_space-before">6.75mm</xsl:param>
	<xsl:param name="logic_div_kakomi_space-after">6.75mm</xsl:param>
	<xsl:param name="logic_div_kakomi_text-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_kakomi_start-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_kakomi_end-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_kakomi_text-align">justify</xsl:param>
	<xsl:param name="logic_div_kakomi_text-align-last">start</xsl:param>
	<xsl:param name="logic_div_kakomi_break-before">page</xsl:param>
	<xsl:param name="logic_div_kakomi_break-after">page</xsl:param>
	<!-- div default -->
	<xsl:param name="logic_div_default_font-family">IPAPMincho</xsl:param>
	<xsl:param name="logic_div_default_font-size">12.0pt</xsl:param>
	<xsl:param name="logic_div_default_line-height">18.0pt</xsl:param>
	<xsl:param name="logic_div_default_space-before">6.75mm</xsl:param>
	<xsl:param name="logic_div_default_space-after">6.75mm</xsl:param>
	<xsl:param name="logic_div_default_text-indent">1em</xsl:param>
	<xsl:param name="logic_div_default_start-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_default_end-indent">0.0em</xsl:param>
	<xsl:param name="logic_div_default_text-align">justify</xsl:param>
	<xsl:param name="logic_div_default_text-align-last">start</xsl:param>
	<xsl:param name="logic_div_default_break-before">auto</xsl:param>
	<xsl:param name="logic_div_default_break-after">auto</xsl:param>
	<!-- header -->
	<xsl:param name="logic_header_line-height">150%</xsl:param>
	<xsl:param name="logic_header_space-before">0.0mm</xsl:param>
	<xsl:param name="logic_header_space-after">6.75mm</xsl:param>
	<xsl:param name="logic_header_text-indent">0.0em</xsl:param>
	<xsl:param name="logic_header_start-indent">0.0em</xsl:param>
	<xsl:param name="logic_header_end-indent">0.0em</xsl:param>
	<xsl:param name="logic_header_text-align">justify</xsl:param>
	<xsl:param name="logic_header_text-align-last">start</xsl:param>
	<xsl:param name="logic_header_break-after">auto</xsl:param>
	<xsl:param name="logic_header_span">none</xsl:param>
	<xsl:param name="logic_header_keep-with-next.within-page">always</xsl:param>
	<xsl:param name="logic_header_keep-together.within-page">always</xsl:param>
	<!-- header no -->
	<xsl:param name="logic_header_no_font-family">IPAGothic</xsl:param>
	<xsl:param name="logic_header_no_font-size">150%</xsl:param>
	<!-- header title -->
	<xsl:param name="logic_header_title_font-family">IPAGothic</xsl:param>
	<xsl:param name="logic_header_title_font-size">150%</xsl:param>
	<!--k 追加　タイトルと，タイトル番号との間隔。プリセットも要追加-->
	<xsl:param name="logic_header_title_space-start">1.0em</xsl:param>
	<!-- header subtitle -->
	<xsl:param name="logic_header_subtitle_font-family">IPAGothic</xsl:param>
	<xsl:param name="logic_header_subtitle_font-size">125%</xsl:param>
	<xsl:param name="logic_header_subtitle_line-height">150%</xsl:param>
	<xsl:param name="logic_header_subtitle_space-before">6.75mm</xsl:param>
	<xsl:param name="logic_header_subtitle_space-after">6.75mm</xsl:param>
	<xsl:param name="logic_header_subtitle_text-indent">0.0em</xsl:param>
	<xsl:param name="logic_header_subtitle_start-indent">0.0em</xsl:param>
	<xsl:param name="logic_header_subtitle_end-indent">0.0em</xsl:param>
	<xsl:param name="logic_header_subtitle_text-align">justify</xsl:param>
	<xsl:param name="logic_header_subtitle_text-align-last">start</xsl:param>
	<xsl:param name="logic_header_subtitle_break-after">auto</xsl:param>
	<!-- header author -->
	<xsl:param name="logic_header_author_font-family">IPAGothic</xsl:param>
	<xsl:param name="logic_header_author_font-size">100%</xsl:param>
	<xsl:param name="logic_header_author_line-height">150%</xsl:param>
	<xsl:param name="logic_header_author_space-before">6.75mm</xsl:param>
	<xsl:param name="logic_header_author_space-after">6.75mm</xsl:param>
	<xsl:param name="logic_header_author_text-indent">0.0em</xsl:param>
	<xsl:param name="logic_header_author_start-indent">0.0em</xsl:param>
	<xsl:param name="logic_header_author_end-indent">0.0em</xsl:param>
	<xsl:param name="logic_header_author_text-align">justify</xsl:param>
	<xsl:param name="logic_header_author_text-align-last">start</xsl:param>
	<xsl:param name="logic_header_author_break-after">auto</xsl:param>
	<!-- note -->
	<xsl:param name="logic_note_font-family">IPAPMincho</xsl:param>
	<xsl:param name="logic_note_font-size">8.0pt</xsl:param>
	<xsl:param name="logic_note_line-height">12.0pt</xsl:param>
	<xsl:param name="logic_note_space-before">6.75mm</xsl:param>
	<xsl:param name="logic_note_space-after">6.75mm</xsl:param>
	<xsl:param name="logic_note_text-indent">1em</xsl:param>
	<xsl:param name="logic_note_start-indent">2.0em</xsl:param>
	<xsl:param name="logic_note_end-indent">2.0em</xsl:param>
	<xsl:param name="logic_note_text-align">justify</xsl:param>
	<xsl:param name="logic_note_text-align-last">start</xsl:param>
	<xsl:param name="logic_note_break-after">auto</xsl:param>
	<!-- note中で使う list-item 用アトリビュート -->
	<!-- 20090511ytazaki デフォルト値0.1emを指定 -->
	<xsl:param name="logic_note_list_item_space-before"/>
	<xsl:variable name="lg_note_list_item_space-before">
		<xsl:choose>
			<xsl:when test="logic_note_list_item_space-before!=''">
				<xsl:value-of select="$logic_note_list_item_space-before"/>
			</xsl:when>
			<xsl:otherwise>0.1em</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:param name="logic_note_list_item_space-after"/>
	<xsl:variable name="lg_note_list_item_space-after">
		<xsl:choose>
			<xsl:when test="logic_note_list_item_space-after!=''">
				<xsl:value-of select="$logic_note_list_item_space-after"/>
			</xsl:when>
			<xsl:otherwise>0.1em</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!--白黒反転-->
	<xsl:param name="mHanten" select="$Hanten"/>
	<xsl:variable name="m_hanten_ft">white</xsl:variable>
	<!--目次の文字の色-->
	<xsl:param name="m_font_leader_color">black</xsl:param>
	<xsl:variable name="mokuji_font_leader_color">
		<xsl:choose>
			<xsl:when test="$mHanten='true'">
				<xsl:value-of select="$m_hanten_ft"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$m_font_leader_color"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
</xsl:stylesheet>
