<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<!--
  ============================================================
    XMLコンソーシアム  XMP部会  技術系SG  jepaX用スタイルシート
  ============================================================
    table_var.xsl  【表要素】
  ============================================================
    2008-07-22  ver.1.0  by S.Aoki
    2008-07-20 checked by K.Kuwano
    2008-08-19  deletion of regulated value  by K.Kuwano
	2008-09-02  revised   by K.Kuwano
    2010-03-05 revised  by M.Fujishima
    2010-07-19 revised  by H.Sato
    2010-10-13  add a functuion to configurate text-indent by K.Kuwano
  ============================================================
-->
	<!--白黒反転-->
	<xsl:param name="tHanten" select="$Hanten"/>
	<xsl:variable name="t_hanten_bg">black</xsl:variable>
	<xsl:variable name="t_hanten_ft">white</xsl:variable>
	<!-- 見出し列（'tr/th[1]'）の幅 -->
	<!-- 入力欄が 0mm もしくは空白だったら文字数によって自動でカラム幅設定 -->
	<xsl:param name="t_th_width">auto</xsl:param>
	<xsl:variable name="t_th_width_type">
		<xsl:choose>
			<xsl:when test="$t_th_width != '0mm' and $t_th_width != ''">
				<xsl:value-of select="$t_th_width"/>
			</xsl:when>
			<xsl:otherwise>auto</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!-- 【表全体の設定】 -->
	<!-- 文字サイズ -->
	<xsl:param name="t_table_fontsize">10.0pt</xsl:param>
	<!-- 文字の色 -->
	<xsl:param name="t_table_fontcolor">black</xsl:param>
	<xsl:variable name="table_table_fontcolor">
		<xsl:choose>
			<xsl:when test="$tHanten='true'">
				<xsl:value-of select="$t_hanten_ft"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$t_table_fontcolor"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!-- 前段落との空き -->
	<xsl:param name="t_table_spacebefore">6.75mm</xsl:param>
	<!-- 後段落との空き -->
	<xsl:param name="t_table_spaceafter">6.75mm</xsl:param>
	<!-- 終了後改ページ -->
	<xsl:param name="t_table_breakafter">auto</xsl:param>
	<!-- 表内改ページ -->
	<xsl:param name="t_table_keeptogether">auto</xsl:param>
	<!-- 表の幅 -->
	<xsl:param name="t_table_width">100%</xsl:param>
	<!-- 表の位置制御用 -->
	<xsl:param name="t_table_first_column_flag">0</xsl:param>
	<xsl:param name="t_table_third_column_flag">1</xsl:param>
	<!-- 段組を無視してぶち抜く -->
	<xsl:param name="t_table_span">none</xsl:param>
	<!-- 外罫の種類 -->
	<xsl:param name="t_table_borderstyle">solid</xsl:param>
	<!-- 外罫の色 -->
	<xsl:param name="t_table_bordercolor">black</xsl:param>
	<xsl:variable name="table_table_bordercolor">
		<xsl:choose>
			<xsl:when test="$tHanten='true'">
				<xsl:value-of select="$t_hanten_ft"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$t_table_bordercolor"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!-- 外罫の太さ -->
	<xsl:param name="t_table_borderwidth">0.8mm</xsl:param>
	<!-- 【キャプションの設定】 -->
	<!-- キャプションの表示位置 -->
	<xsl:param name="t_caption"/>
	<xsl:variable name="t_caption_side">
		<xsl:choose>
			<xsl:when test="$t_caption='上側'">up</xsl:when>
			<xsl:when test="$t_caption='下側'">down</xsl:when>
			<xsl:otherwise>up</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!-- tableの幅で折り返す -->
	<xsl:param name="wrap_with_table_width">true</xsl:param>
	<!-- フォント -->
	<xsl:param name="t_caption_fontstyle">ゴシック</xsl:param>
	<xsl:variable name="t_caption_fontfamily">
		<xsl:choose>
			<xsl:when test="$t_caption_fontstyle='ゴシック'">IPAGothic</xsl:when>
			<xsl:when test="$t_caption_fontstyle='明朝'">IPAMincho</xsl:when>
			<xsl:otherwise>IPAGothic</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!-- 文字サイズ -->
	<xsl:param name="t_caption_fontsize">150%</xsl:param>
	<!-- 行の高さ -->
	<xsl:param name="t_caption_lineheight">150%</xsl:param>
	<!-- 行の揃え方 -->
	<xsl:param name="t_caption_textalign">center</xsl:param>
	<!-- 1行目行頭のインデント -->
	<xsl:param name="t_caption_text-indent">0em</xsl:param>
	
	<!-- 【見出しセルの設定】 -->
	<!-- フォント -->
	<xsl:param name="t_th_fontstyle">ゴシック</xsl:param>
	<xsl:variable name="t_th_fontfamily">
		<xsl:choose>
			<xsl:when test="$t_th_fontstyle='ゴシック'">IPAGothic</xsl:when>
			<xsl:when test="$t_th_fontstyle='明朝'">IPAMincho</xsl:when>
			<xsl:otherwise>IPAGothic</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!-- 文字サイズ -->
	<xsl:param name="t_th_fontsize">120%</xsl:param>
	<!-- 見出しセルの揃え方 -->
	<xsl:param name="t_th_textalign">start</xsl:param>
	<!-- 見出しセルの1行目の行頭のインデント -->
	<xsl:param name="t_th_text-indent">0em</xsl:param>
	<!-- 見出しセルの天地の揃え方 -->
	<xsl:param name="t_th_displayalign">center</xsl:param>
	<!-- テキストと見出しセルとの間隔 -->
	<xsl:param name="t_th_padding">2.0mm</xsl:param>
	<!-- 罫の種類 -->
	<xsl:param name="t_th_borderstyle">solid</xsl:param>
	<!-- 罫の色 -->
	<xsl:param name="t_th_bordercolor">black</xsl:param>
	<xsl:variable name="table_th_bordercolor">
		<xsl:choose>
			<xsl:when test="$tHanten='true'">
				<xsl:value-of select="$t_hanten_ft"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$t_th_bordercolor"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!-- 罫の太さ -->
	<xsl:param name="t_th_borderwidth">0.4mm</xsl:param>
	<!-- 背景色 -->
	<xsl:param name="t_th_bgcolor">white</xsl:param>
	<xsl:variable name="table_th_bgcolor">
		<xsl:choose>
			<xsl:when test="$tHanten='true'">
				<xsl:value-of select="$t_hanten_bg"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$t_th_bgcolor"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!-- 【データセルの設定】 -->
	<!-- フォント -->
	<xsl:param name="t_td_fontstyle">明朝</xsl:param>
	<xsl:variable name="t_td_fontfamily">
		<xsl:choose>
			<xsl:when test="$t_td_fontstyle='ゴシック'">IPAGothic</xsl:when>
			<xsl:when test="$t_td_fontstyle='明朝'">IPAMincho</xsl:when>
			<xsl:otherwise>IPAGothic</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!-- 文字サイズ -->
	<xsl:param name="t_td_fontsize">100%</xsl:param>
	<!-- テキストのセル内での左右の揃え方 -->
	<xsl:param name="t_td_textalign">center</xsl:param>
	<!-- 見出しセルの1行目の行頭のインデント -->
	<xsl:param name="t_td_text-indent">0em</xsl:param>
	<!-- テキストのセル内での天地の揃え方 -->
	<xsl:param name="t_td_displayalign">center</xsl:param>
	<!-- テキストとセルとの間隔 -->
	<xsl:param name="t_td_padding">2.0mm</xsl:param>
	<!-- 罫の種類 -->
	<xsl:param name="t_td_borderstyle">solid</xsl:param>
	<!-- 罫の色 -->
	<xsl:param name="t_td_bordercolor">black</xsl:param>
	<xsl:variable name="table_td_bordercolor">
		<xsl:choose>
			<xsl:when test="$tHanten='true'">
				<xsl:value-of select="$t_hanten_ft"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$t_td_bordercolor"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!-- 罫の太さ -->
	<xsl:param name="t_td_borderwidth">0.2mm</xsl:param>
	<!-- 背景色 -->
	<xsl:param name="t_td_bgcolor">white</xsl:param>
	<xsl:variable name="table_td_bgcolor">
		<xsl:choose>
			<xsl:when test="$tHanten='true'">
				<xsl:value-of select="$t_hanten_bg"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$t_td_bgcolor"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:param name="t_th_lineheight">150%</xsl:param>
	<xsl:param name="t_td_lineheight">150%</xsl:param>
</xsl:stylesheet>
