<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="2.0">
	<xsl:output method="text"/>
	<xsl:output method="xml" encoding="utf-8" omit-xml-declaration="no"
		doctype-public="-//W3C//DTD XHTML 1.1//EN"
		doctype-system="http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd" indent="no" name="xhtml"/>
	<!-- XHTML 作成 -->
	<xsl:template name="generate_xhtml">
		<xsl:apply-templates select="front|body|back" mode="xhtml"/>
	</xsl:template>
	<xsl:template match="front | body | back" mode="xhtml">
		<xsl:apply-templates select="div" mode="xhtml"/>
	</xsl:template>
	<xsl:template match="div" mode="xhtml">
		<xsl:variable name="div_count">
			<xsl:number level="any" format="1" count="div"/>
		</xsl:variable>
		<xsl:variable name="filename"
			select="concat($application_tmp_output_directory, 'OEBPS/', $div_count, '.xhtml')"/>
		<xsl:value-of select="$filename"/>
		<xsl:text>を出力しました。
</xsl:text>
		<xsl:result-document href="{$filename}" format="xhtml">
			<xsl:processing-instruction name="xml-stylesheet">href="default.css"
				type="text/css"</xsl:processing-instruction>
			<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="ja">
				<head>
					<meta>
						<xsl:attribute name="http-equiv">Content-type</xsl:attribute>
						<xsl:attribute name="content">text/html; charset=utf-8</xsl:attribute>
					</meta>
					<title>
						<xsl:value-of select="name()"/>
					</title>
					<link rel="stylesheet" href="default.css" type="text/css"/>
				</head>
				<body>
					<xsl:apply-templates select="."/>
				</body>
			</html>
		</xsl:result-document>
	</xsl:template>
</xsl:stylesheet>
